unit Langs_TranslateDemo;
//     

interface

  Uses XMLWorks2, TypInfo, XMLVariants, XBase, SysUtils, Classes, Forms,
       JvFileUtil, {AppConsts,} Dialogs, Variants{, cxGridBandedTableView, cxGridDBBandedTableView}, FastStrings;

  function ObjectToXMLElements_Lang(const aObject:TObject; Space_Inp: integer): String;
  Procedure SaveLangTranslate(ObjInp: TObject);
  Procedure LoadLangTranslate(ObjInp: TObject);
  Function LangPath: String;
  Function LangPathDefault: String;

  Var LangInterface: String; //  

implementation



//    
function RFastParseTagXML(const Source, Tag: AnsiString{; var Index: Integer}):
        AnsiString;
var
  NestLevel: Integer;
  StartTag, StopTag: AnsiString;
  StartLen, StopLen, SourceLen: Integer;
  StartIndex, StopIndex: Integer;
begin
  SourceLen := Length(Source);
  StartIndex := 0;
  result := '';
  if (StartIndex < SourceLen) then
  begin
    StartTag := '<' + Tag + '>';
    StartLen := Length(StartTag);

    if StartLen > 2 then
    begin
      StopTag := '</' + Tag + '>';
      StopLen := Length(StopTag);

      StartIndex := Pos(StartTag,Source);
      StopIndex := Pos(StopTag,Source);

      result := Copy(Source, StartIndex+StartLen, StopIndex-StartIndex-StartLen{- 1});

    end;
  end;
end;




  function Base64Encode(const s: string): string;
  begin
  end;


  function Base64Decode(const s: string): string;
  begin
  end;

  procedure AssignIntf(var Dest: IUnknown; const Source: IUnknown);
  begin
    Dest := Source;
  end;


  function GetIntfProp_Lang(Instance: TObject; PropInfo: PPropInfo): IUnknown;
  asm
        { ->    EAX Pointer to instance         }
        {       EDX Pointer to property info    }
        {       ECX Pointer to result interface }

        PUSH    ESI
        PUSH    EDI
        MOV     EDI,EDX

        MOV     EDX,[EDI].TPropInfo.Index       { pass index in EDX }
        CMP     EDX,$80000000
        JNE     @@hasIndex
        MOV     EDX,ECX                         { pass value in EDX }
    @@hasIndex:
        MOV     ESI,[EDI].TPropInfo.GetProc
        CMP     [EDI].TPropInfo.GetProc.Byte[3],$FE
        JA      @@isField
        JB      @@isStaticMethod

    @@isVirtualMethod:
        MOVSX   ESI,SI                          { sign extend slot offset }
        ADD     ESI,[EAX]                       { vmt + slot offset }
        CALL    DWORD PTR [ESI]
        JMP     @@exit

    @@isStaticMethod:
        CALL    ESI
        JMP     @@exit

    @@isField:
        AND  ESI,$00FFFFFF
        ADD  EAX, ESI
        MOV  EDX,[EAX]
        MOV  EAX, ECX

        CALL  AssignIntf

    @@exit:
        POP     EDI
        POP     ESI
  end;



  function GetIntfProp(Instance: TObject; PropInfo: PPropInfo): IUnknown;
  asm
        { ->    EAX Pointer to instance         }
        {       EDX Pointer to property info    }
        {       ECX Pointer to result interface }

        PUSH    ESI
        PUSH    EDI
        MOV     EDI,EDX

        MOV     EDX,[EDI].TPropInfo.Index       { pass index in EDX }
        CMP     EDX,$80000000
        JNE     @@hasIndex
        MOV     EDX,ECX                         { pass value in EDX }
    @@hasIndex:
        MOV     ESI,[EDI].TPropInfo.GetProc
        CMP     [EDI].TPropInfo.GetProc.Byte[3],$FE
        JA      @@isField
        JB      @@isStaticMethod

    @@isVirtualMethod:
        MOVSX   ESI,SI                          { sign extend slot offset }
        ADD     ESI,[EAX]                       { vmt + slot offset }
        CALL    DWORD PTR [ESI]
        JMP     @@exit

    @@isStaticMethod:
        CALL    ESI
        JMP     @@exit

    @@isField:
        AND  ESI,$00FFFFFF
        ADD  EAX, ESI
        MOV  EDX,[EAX]
        MOV  EAX, ECX

        CALL  AssignIntf

    @@exit:
        POP     EDI
        POP     ESI
  end;



  procedure setPropAsString_Lang(Instance: TObject; PropInfo: PPropInfo; const value :
          string);
  var
    ObjectProp : TObject;
    Intf: IXMLWorksObject;
    vTemp : variant;
    StrTmp: String;
  begin
      //  No property
      if (PropInfo = Nil) OR (value = '') or
      // a read only simple type
      ((PropInfo^.SetProc = NIL) and not (PropInfo^.PropType^.Kind in [tkClass, tkInterface]))
      then
      exit;



      case PropInfo^.PropType^.Kind of
        tkString,
        tkLString,
        tkWString:
        if AnsiSameText(PropInfo^.PropType^.Name, 'XMLString') then
            SetStrProp(Instance, PropInfo, Value)
        else if AnsiSameText(PropInfo^.PropType^.Name, 'XMLMIMEString') then
            SetStrProp(Instance, PropInfo, Base64Decode(Value))
        else
            SetStrProp(Instance, PropInfo, XMLToStr(Value));
        tkSet,
        tkInteger:
        if AnsiSameText(PropInfo^.PropType^.Name, 'XMLRGBTColor') then
            SetOrdProp(Instance, PropInfo, SwapRandB(StrToInt(XMLToStr(Value))))
        else
            SetOrdProp(Instance, PropInfo, StrToInt(XMLToStr(Value)));
        tkFloat:{
          if AnsiSameText(PropInfo^.PropType^.Name, 'TDateTime')  then
            SetFloatProp(Instance, PropInfo, StrToDateTime(XMLToStr(Value)))
          else if AnsiSameText(PropInfo^.PropType^.Name, 'TTime')  then
            SetFloatProp(Instance, PropInfo, StrToTime(XMLToStr(Value)))
          else if AnsiSameText(PropInfo^.PropType^.Name, 'TDate')  then
            SetFloatProp(Instance, PropInfo, StrToDate(XMLToStr(Value)))
          else}
            SetFloatProp(Instance, PropInfo, StrToFloat(XMLToStr(Value)));

        tkVariant:
          begin
              vTemp := GetVariantProp(Instance,PropInfo);
              XMLToVariant(value,vTemp);
              SetVariantProp(Instance, PropInfo, vTemp);
          end;

        tkInt64: SetInt64Prop(Instance, PropInfo, StrToInt64(XMLToStr(Value)));

        tkChar,
        tkWChar:
          begin
            StrTmp:=XMLToStr(Value);
            if Length(StrTmp)>0 then
              SetOrdProp(Instance, PropInfo, Ord({XMLToStr(Value)}StrTmp[1]));
          end;

        tkEnumeration: SetOrdProp(Instance, PropInfo, GetEnumValue( PropInfo^.PropType^, XMLToStr(Value)));
        tkClass :
          begin
            try
                ObjectProp := TObject(GetOrdProp(Instance, PropInfo));

                if Assigned(ObjectProp) then
                begin
                    if ObjectProp.GetInterface(IXMLWorksObject, Intf) then
                      Intf.ElementText := Value
                    else if (ObjectProp is TXMLCollection) then
                      TXMLCollection(ObjectProp).ElementText := Value
                    else if (ObjectProp is TXMLCollectionItem) then
                      TXMLCollectionItem(ObjectProp).ElementText := Value
                    else if (ObjectProp is TXMLObject) then
                      TXMLObject(ObjectProp).ElementText := Value
                    else if (ObjectProp is TXMLList) then
                      TXMLList(ObjectProp).ElementText := Value
                    else if (ObjectProp is TStrings) then
                      TStrings(ObjectProp).CommaText := XMLToStr(Value)
                end;
            except
              on e: Exception do
                raise EXMLException.Create('(' + e.Message + ')Error with property - ' + PropInfo^.Name);
            end;
          end;
        tkInterface:
            XMLtoInterface(Value,GetIntfProp(Instance, PropInfo));
        {
            Types not supported :
            tkRecord
            tkArray
            tkDynArray
            tkMethod
            tkUnknown
        }
        end;

  end;




  // IsLangSet -   
  function GetPropAsString_Lang(const Instance: TObject; const PropInfo: PPropInfo; Var IsLangSet: Boolean; Space_Inp: Integer): string;
  var
      ObjectProp : TObject;
      Intf: IXMLWorksObject;
  begin

        if (not Assigned(PropInfo^.PropType^))Or(UpperCase(Trim(PropInfo^.PropType^.Name))='NAME')
        then Exit;

        result := '';
        IsLangSet:=False;
        case PropInfo^.PropType^.Kind of
          tkString,
          tkLString,
          tkWString:
            Begin
                IsLangSet:=True;
                if AnsiSameText(PropInfo^.PropType^.Name, 'XMLString') then
                    result := Trim(GetStrProp(Instance, PropInfo))
                else if AnsiSameText(PropInfo^.PropType^.Name, 'XMLMIMEString') then
                    result := Base64Encode(GetStrProp(Instance, PropInfo))
                else
                 begin
                      result := StrToXML(Trim(GetStrProp(Instance, PropInfo)));
                 end;
            End;

          tkInt64: ;
          tkSet,
          tkInteger: ;
          tkFloat: ;
          tkVariant:
            begin
               IsLangSet:=True;

               if GetVariantProp(Instance, PropInfo)=null
               then result := StrToXML('')
               else result := VariantToXML(Trim(GetVariantProp(Instance, PropInfo)));
            end;
          tkChar,
          tkWChar:
            begin
               IsLangSet:=True;
               result := StrToXML(Chr(GetOrdProp(Instance, PropInfo)));
            end;
          tkEnumeration: ;
          tkClass:
            begin

            end;
          tkInterface:
             begin
                IsLangSet:=True;
                result := InterfaceToXML(GetIntfProp_Lang(Instance, PropInfo));
             end;
        end;
  end;



  function ObjectToXMLElements_Lang(const aObject:TObject; Space_Inp: integer): String;
  var
      i : Integer;
      s : string;
      StringList : TStringList;
      Props: TList;
      IsLangSet: Boolean;
  begin
      result := '';
      StringList := TStringList.Create;
      try
        Props := GetPropertyList(aObject.ClassInfo);
        try
            for i := 0 to Props.Count-1 do
            begin
                s := GetPropAsString_Lang(AObject, PPropInfo(Props.Items[i]), IsLangSet, Space_Inp+4);

                if (IsLangSet)And(UpperCase(PPropInfo(Props.Items[i]).Name)<>UpperCase('Name'))And(Trim(PPropInfo(Props.Items[i]).Name)<>'') then
                  StringList.Add(Space(Space_Inp)+'<' + PPropInfo(Props.Items[i]).Name + '>' + s + Space(Space_Inp)+'</' +PPropInfo(Props.Items[i]).Name + '>');

            end;
            result := StringList.Text;
        finally
            Props.Free;
        end;
      finally
        StringList.Free;
      end;
  end;


  procedure setXMLObject_Lang(Instance: TObject; p_sXML: AnsiString);
  var
    CurrentTagIndex, OverAllIndex: Integer;
    CurrentTag, CurrentTagContent :string;
  begin
    try
        CurrentTagIndex := 1;
        OverallIndex := 1;
        repeat
          CurrentTag := FastParseTag(p_sXML, '<' , '>', OverallIndex);
          CurrentTagContent := FastParseTagXML(p_sXML, CurrentTag, CurrentTagIndex);
          if (Length(CurrentTag) > 0) then
            SetPropAsString_Lang(Instance, GetPropInfo(Instance.ClassInfo, CurrentTag), CurrentTagContent);

          OverAllIndex := CurrentTagIndex;
        until (OverAllIndex<1) or (OverAllIndex > Length(p_sXML));
    except
      on EXMLException do
        raise;
      on e : Exception do
        raise EXMLException.Create('(' + e.Message + ')Error Processing XML - ' 
          +CurrentTag+' ('+CurrentTagContent+') '+iif_Str(Assigned(Instance),Instance.ClassName,''));
    end;
  end;


  function GenSQLLang(SelfInp: TObject): String;
  Var i, b: integer;
//      BandTmp: TcxGridDBBandedTableView;
  begin

    if (SelfInp is TComponent) then
     Begin
        With (SelfInp as TComponent) Do
        Begin

            Result:=ObjectToXMLElements_Lang(SelfInp,-4);


            Result:=Result+Chr(13)+'<ComponentsForm>';

            for i:=0 to ComponentCount-1 Do
        begin

               if (Trim(Components[i].Name)<>'')And
               (not((RusCompare(Components[i].ClassName,'TSaveDBGridEh'))
                  Or(RusCompare(Components[i].ClassName,'TpFIBTransaction'))
                  Or(RusCompare(Components[i].ClassName,'TpFIBStoredProc'))
                  Or(RusCompare(Components[i].ClassName,'TDBEdit'))
                  Or(RusCompare(Components[i].ClassName,'TDBDateTimeEditEh'))
                  Or(RusCompare(Components[i].ClassName,'TDBLookupComboboxEh'))
                  Or(RusCompare(Components[i].ClassName,'TDBComboBoxEh'))

                    )) then
               begin
                   Result:=Result+Chr(13)
                     +'<'+Components[i].Name+'>'+Chr(13)+ObjectToXMLElements_Lang(Components[i],4)
                     +'</'+Components[i].Name+'>'+Chr(13);


               end;
            end;

            Result:=Result+'</ComponentsForm>'+Chr(13)+Chr(13);
        End;
     End;
  end;


  Procedure DecodeSQLLang(SelfInp: TObject;StrInp: String);
  //     
  Var PosTmp, PosTmp2: integer;
      i: integer;
      StrTmp: String;
  begin

       PosTmp:=0;

       if SelfInp is TComponent then
        With SelfInp as TComponent Do
        Begin

           PosTmp:=Pos('ComponentsForm', StrInp);

           if PosTmp=0
           then StrTmp:=Copy(StrInp,1,Length(StrInp))
           else StrTmp:=Copy(StrInp,1,PosTmp-2);

           setXMLObject_Lang(SelfInp, StrInp);

            for i:=0 to ComponentCount-1 Do
            begin


               if (Trim(Components[i].Name)<>'')And
               (not((RusCompare(Components[i].ClassName,'TSaveDBGridEh'))
                  Or(RusCompare(Components[i].ClassName,'TpFIBTransaction'))
                  Or(RusCompare(Components[i].ClassName,'TpFIBStoredProc'))
                  Or(RusCompare(Components[i].ClassName,'TDBEdit'))
                  Or(RusCompare(Components[i].ClassName,'TDBDateTimeEditEh'))
                  Or(RusCompare(Components[i].ClassName,'TDBLookupComboboxEh'))
                  Or(RusCompare(Components[i].ClassName,'TDBComboBoxEh'))

                    )) then
               begin
                     StrTmp:=RFastParseTagXML(StrInp,Components[i].Name);
                     setXMLObject_Lang(Components[i], StrTmp);
               end;
            end;
        End;

  end;


  //    
  Function LangPath: String;
  Begin
    Result:=NormalDir(NormalDir(ExtractFilePath(Application.ExeName))
       +'Langs\'+{User_Sets.}LangInterface);
  End;

  Function LangPathDefault: String;
  Begin
    Result:=NormalDir(NormalDir(ExtractFilePath(Application.ExeName))
       +'Langs\Default');
  End;

  //    
  Procedure SaveLangTranslate(ObjInp: TObject{; LangInp: String});
  Var TransTmp: String;
  begin
      TransTmp:=GenSQLLang(ObjInp);

      if not DirectoryExists(LangPath)
      then ForceDirectories(LangPath);

      SaveStringToFile(TransTmp, LangPath{+Trim(LangInp)}+ObjInp.ClassName+'.xml');
  End;


  Procedure LoadLangTranslate(ObjInp: TObject{; LangInp: String});
  Var TransTmp: String;
  begin
      TransTmp:=LoadStringFromFile(LangPath{+Trim(LangInp)}+ObjInp.ClassName+'.xml');
      DecodeSQLLang(ObjInp,TransTmp);
  end;


end.
