unit corp_const_strDemo;

interface

 Uses xmlworks2, Classes, XBase, SysUtils, Forms, Dialogs;

 Type


    TCorp_Const_StringCollectionItem = class(TXMLCollectionItem)
    private
      FIndexName: String;
      FMessString: String;
    public
      destructor Destroy; Override;
    published
      property IndexName: String read FIndexName write FIndexName;
      property MessString: String read FMessString write FMessString;
    end;


    TCorp_Const_StringCollection = class(TXMLCollection)
    private
      FLangInfo: String;
    public
      constructor Create;
      destructor Destroy; Override;

      Function AddNewItem: TCorp_Const_StringCollectionItem;
      Procedure AddString(IndexNameInp, MessStringInp: String);
      Procedure AddIfNotExist(IndexNameInp, MessStringInp: String);

      function GetItemByIndex(index:integer): TCorp_Const_StringCollectionItem;
      function GetItemByName(NameInp: String): TCorp_Const_StringCollectionItem;
      function GetMessByName(NameInp: String): String;

      procedure Assign(Source: TPersistent); override;
    published
      Property LangInfo: String read FLangInfo write FLangInfo;
    End;


var Corp_Const_String: TCorp_Const_StringCollection;

Procedure Gen_Corp_String;
Function Corp_StrMess(IndexInp: String): String;
Procedure SetResourceLangQuantum;
Procedure AnotherResourceQuantum;

implementation


Uses cxGridPopupMenuConsts, cxClasses, cxExportStrs, cxDataConsts, cxEditConsts,
  cxExtEditConsts, cxFilterConsts, cxFilterControlStrs, cxGridStrs, cxLibraryStrs,
  cxNavigator, dxBarStrs, dxDockConsts, dxExtCtrlsStrs, dxLayoutCommon,
  dxLayoutCustomizeForm, dxLayoutEditForm, dxNavBarConsts;

{ TUser_Sets }

var
  FResStrings: TStringList = nil;


(*procedure cxSetResourceString(const ResString: Pointer; const Value: string);
var
  AIndex: Integer;
begin
  if (FResStrings = nil) then
    FResStrings := TStringList.Create;
  AIndex := FResStrings.IndexOfObject(TObject(ResString));

  if AIndex > -1 then
    FResStrings[AIndex] := Value
  else FResStrings.AddObject(Value, TObject(ResString));
end;

function cxGetResourceString(const ResString: Pointer): string;
var
  AIndex: Integer;
begin
{  if (FResStrings = nil) then
    FResStrings := TStringList.Create;}

  if (FResStrings <> nil) then
  begin
    AIndex := FResStrings.IndexOfObject(TObject(ResString));
    if AIndex > -1 then
      Result := FResStrings[AIndex]
    else Result := LoadResString(PResStringRec(ResString));
  end
  else Result := LoadResString(PResStringRec(ResString));
end;*)


function TCorp_Const_StringCollection.AddNewItem: TCorp_Const_StringCollectionItem;
begin
  Result:=TCorp_Const_StringCollectionItem.Create(Self);
end;

procedure TCorp_Const_StringCollection.AddIfNotExist(IndexNameInp,
  MessStringInp: String);
Var ItemTmp: TCorp_Const_StringCollectionItem;
begin
  ItemTmp:=GetItemByName(IndexNameInp);

{  if Assigned(ItemTmp) then
   begin
      ItemTmp.IndexName:=IndexNameInp;
      ItemTmp.MessString:=MessStringInp;
   end}

  if not Assigned(ItemTmp) then
   begin
      Corp_Const_String.AddString(IndexNameInp, MessStringInp);
   end
  else
   begin
      ItemTmp.IndexName:=IndexNameInp;
      ItemTmp.MessString:=MessStringInp;
   end;
end;

procedure TCorp_Const_StringCollection.AddString(IndexNameInp,
  MessStringInp: String);
begin
  With AddNewItem Do
  Begin
    IndexName:=IndexNameInp;
    MessString:=MessStringInp;
  End;
end;

procedure TCorp_Const_StringCollection.Assign(Source: TPersistent);
begin
  inherited Assign(Source);
end;

constructor TCorp_Const_StringCollection.Create;
begin
  inherited Create(TCorp_Const_StringCollectionItem);
  FLangInfo:='Uk';
end;

destructor TCorp_Const_StringCollection.Destroy;
begin
  Clear;
  inherited;
end;

function TCorp_Const_StringCollection.GetItemByIndex(
  index: integer): TCorp_Const_StringCollectionItem;
begin
     result:=TCorp_Const_StringCollectionItem(items[index])
end;

function TCorp_Const_StringCollection.GetItemByName(
  NameInp: String): TCorp_Const_StringCollectionItem;
var i: integer;
begin
  result:=nil;
  for i:=0 to Count-1 Do
  begin
     if RusUpperCase(Trim(GetItemByIndex(i).IndexName))=RusUpperCase(Trim(NameInp))
     then result:=GetItemByIndex(i);
  end;
end;

{ TCorp_Const_StringCollectionItem }

destructor TCorp_Const_StringCollectionItem.Destroy;
begin

  inherited;
end;


//     
// MessErr(  Corp_Const_String.GetMessByName('')  ); -  
// func Corp_StrMess(IndexInp: String): String; -   
Procedure Gen_Corp_String;
Begin
  if not Assigned(Corp_Const_String)
  then Corp_Const_String:=TCorp_Const_StringCollection.Create;

//  Corp_Const_String.Clear;

  Corp_Const_String.AddIfNotExist('1', '-   -');
  Corp_Const_String.AddIfNotExist('2', '     !');
  Corp_Const_String.AddIfNotExist('3', '    .');
  Corp_Const_String.AddIfNotExist('4', '- !');
  Corp_Const_String.AddIfNotExist('5', '  !');
  Corp_Const_String.AddIfNotExist('6', '     !');
  Corp_Const_String.AddIfNotExist('7', '  ');
  Corp_Const_String.AddIfNotExist('8', '     ! ');
  Corp_Const_String.AddIfNotExist('9', '   ()!');
  Corp_Const_String.AddIfNotExist('10', 'dmROffConnect  ');
  Corp_Const_String.AddIfNotExist('11', ' .');
  Corp_Const_String.AddIfNotExist('12', '  !');
  Corp_Const_String.AddIfNotExist('13', '   !');
  Corp_Const_String.AddIfNotExist('14', ' ');
  Corp_Const_String.AddIfNotExist('15', ' ');
  Corp_Const_String.AddIfNotExist('16', '   :');
  Corp_Const_String.AddIfNotExist('17', '   :');
  Corp_Const_String.AddIfNotExist('18', '     .');
  Corp_Const_String.AddIfNotExist('19', '  . dmSklad.ExecuteProvodk');
  Corp_Const_String.AddIfNotExist('20', '     !');
  Corp_Const_String.AddIfNotExist('21', '     !');
  Corp_Const_String.AddIfNotExist('22', '       !');
  Corp_Const_String.AddIfNotExist('23', '     !');
  Corp_Const_String.AddIfNotExist('24', '!');
  Corp_Const_String.AddIfNotExist('25', '   !');
  Corp_Const_String.AddIfNotExist('26', '      /');
  Corp_Const_String.AddIfNotExist('27', '   ');
  Corp_Const_String.AddIfNotExist('28', '      .');
  Corp_Const_String.AddIfNotExist('29', '     .');
  Corp_Const_String.AddIfNotExist('30', '     .');
  Corp_Const_String.AddIfNotExist('31', '    ,   !');
  Corp_Const_String.AddIfNotExist('32', '      !');
  Corp_Const_String.AddIfNotExist('33', '   !');
  Corp_Const_String.AddIfNotExist('34', '  !');
  Corp_Const_String.AddIfNotExist('35', '  ');
  Corp_Const_String.AddIfNotExist('36', '     !');
  Corp_Const_String.AddIfNotExist('37', '    :');
  Corp_Const_String.AddIfNotExist('38', '   !');
  Corp_Const_String.AddIfNotExist('39', '   :');
  Corp_Const_String.AddIfNotExist('40', '    !');
  Corp_Const_String.AddIfNotExist('41', ' .');
  Corp_Const_String.AddIfNotExist('42', '  !');
  Corp_Const_String.AddIfNotExist('43', '  ');
  Corp_Const_String.AddIfNotExist('44', '       !');
  Corp_Const_String.AddIfNotExist('45', ' !');
  Corp_Const_String.AddIfNotExist('46', ' !');
  Corp_Const_String.AddIfNotExist('47', '   !');
  Corp_Const_String.AddIfNotExist('48', '  !');
  Corp_Const_String.AddIfNotExist('49', '  !');
  Corp_Const_String.AddIfNotExist('50', '   !');
  Corp_Const_String.AddIfNotExist('51', '   !');
  Corp_Const_String.AddIfNotExist('52', '       !');
  Corp_Const_String.AddIfNotExist('53', '     !');
  Corp_Const_String.AddIfNotExist('54', '     !');
  Corp_Const_String.AddIfNotExist('55', '  ');
  Corp_Const_String.AddIfNotExist('56', '  !');
  Corp_Const_String.AddIfNotExist('57', '      .');
  Corp_Const_String.AddIfNotExist('58', '  ,     ');
  Corp_Const_String.AddIfNotExist('59', '        .');
  Corp_Const_String.AddIfNotExist('60', '       .');
  Corp_Const_String.AddIfNotExist('61', '     !');
  Corp_Const_String.AddIfNotExist('62', '       15 .');
  Corp_Const_String.AddIfNotExist('63', '       .');
  Corp_Const_String.AddIfNotExist('64', ' ,    : http://nerusoft.com  http://rudjuk.kiev.ua');
  Corp_Const_String.AddIfNotExist('65', '  .');
  Corp_Const_String.AddIfNotExist('66', '    - 30 !');
  Corp_Const_String.AddIfNotExist('67', '    -   15 .');
  Corp_Const_String.AddIfNotExist('68', '   ');
  Corp_Const_String.AddIfNotExist('69', '.');
  Corp_Const_String.AddIfNotExist('70', '      !');
  Corp_Const_String.AddIfNotExist('71', '-    .');
  Corp_Const_String.AddIfNotExist('72', '  :');
  Corp_Const_String.AddIfNotExist('73', '      .');
  Corp_Const_String.AddIfNotExist('74', '      ');
  Corp_Const_String.AddIfNotExist('75', '     !');
  Corp_Const_String.AddIfNotExist('76', '     ID=');
  Corp_Const_String.AddIfNotExist('77', '  !');
  Corp_Const_String.AddIfNotExist('78', '  !');
  Corp_Const_String.AddIfNotExist('79', '  !');
  Corp_Const_String.AddIfNotExist('80', '   !');
  Corp_Const_String.AddIfNotExist('81', '   !');
  Corp_Const_String.AddIfNotExist('82', '   ');
  Corp_Const_String.AddIfNotExist('83', '   ID=');
  Corp_Const_String.AddIfNotExist('84', ' !');
  Corp_Const_String.AddIfNotExist('85', '');
  Corp_Const_String.AddIfNotExist('86', '  !');
  Corp_Const_String.AddIfNotExist('87', '   !');
  Corp_Const_String.AddIfNotExist('88', '     !');
  Corp_Const_String.AddIfNotExist('89', '  ,   !');
  Corp_Const_String.AddIfNotExist('90', '  ,   !');
  Corp_Const_String.AddIfNotExist('91', '    .    !');
  Corp_Const_String.AddIfNotExist('92', '      ');
  Corp_Const_String.AddIfNotExist('93', '        ');
  Corp_Const_String.AddIfNotExist('94', '     ');
  Corp_Const_String.AddIfNotExist('95', '-  ,    .');
  Corp_Const_String.AddIfNotExist('96', '    !');
  Corp_Const_String.AddIfNotExist('97', '      .');
  Corp_Const_String.AddIfNotExist('98', '   !');
  Corp_Const_String.AddIfNotExist('99', '   ');
  Corp_Const_String.AddIfNotExist('101', '  !');
  Corp_Const_String.AddIfNotExist('102', '  !');
  Corp_Const_String.AddIfNotExist('103', '  !');
  Corp_Const_String.AddIfNotExist('104', '       /');
  Corp_Const_String.AddIfNotExist('105', '  !');
  Corp_Const_String.AddIfNotExist('106', '     !');
  Corp_Const_String.AddIfNotExist('107', '     Light!');
  Corp_Const_String.AddIfNotExist('108', '   ');
  Corp_Const_String.AddIfNotExist('109', '      !');
  Corp_Const_String.AddIfNotExist('110', '       !');
  Corp_Const_String.AddIfNotExist('111', '    !');
  Corp_Const_String.AddIfNotExist('112', ' VisibleCol   (DBGridEhParam)');
  Corp_Const_String.AddIfNotExist('113', ' TitleName   (DBGridEhParam)');
  Corp_Const_String.AddIfNotExist('114', '  ');
  Corp_Const_String.AddIfNotExist('115', '   ');
  Corp_Const_String.AddIfNotExist('116', '');
  Corp_Const_String.AddIfNotExist('117', ' ');
  Corp_Const_String.AddIfNotExist('118', '');
  Corp_Const_String.AddIfNotExist('119', ' ');
  Corp_Const_String.AddIfNotExist('120', '     .');
  Corp_Const_String.AddIfNotExist('121', ' .');
  Corp_Const_String.AddIfNotExist('122', ' ');
  Corp_Const_String.AddIfNotExist('123', '    ,    .');
  Corp_Const_String.AddIfNotExist('124', ' ?');
  Corp_Const_String.AddIfNotExist('125', ' ');
  Corp_Const_String.AddIfNotExist('126', ' ,        ?');
  Corp_Const_String.AddIfNotExist('127', '  ');
  Corp_Const_String.AddIfNotExist('128', '   .');
  Corp_Const_String.AddIfNotExist('129', '      .');
  Corp_Const_String.AddIfNotExist('130', '  ?');
  Corp_Const_String.AddIfNotExist('131', '       :');
  Corp_Const_String.AddIfNotExist('132', ', ,  ,  (), .');
  Corp_Const_String.AddIfNotExist('133', '  ');
  Corp_Const_String.AddIfNotExist('134', ' ');
  Corp_Const_String.AddIfNotExist('135', ' ,     ?');
  Corp_Const_String.AddIfNotExist('136', ' ,       ');
  Corp_Const_String.AddIfNotExist('137', 'ID =');
  Corp_Const_String.AddIfNotExist('138', ' ,         (ID =');
  Corp_Const_String.AddIfNotExist('139', '');
  Corp_Const_String.AddIfNotExist('140', '    ?');
  Corp_Const_String.AddIfNotExist('141', ' ?');
  Corp_Const_String.AddIfNotExist('142', ' ');
  Corp_Const_String.AddIfNotExist('143', ' ,         (ID =');
  Corp_Const_String.AddIfNotExist('144', ' ,       ');
  Corp_Const_String.AddIfNotExist('145', ' ,     ?');
  Corp_Const_String.AddIfNotExist('146', '     .');
  Corp_Const_String.AddIfNotExist('147', '  ?');
  Corp_Const_String.AddIfNotExist('148', '  ');
  Corp_Const_String.AddIfNotExist('149', ' ');
  Corp_Const_String.AddIfNotExist('150', '        ?');
  Corp_Const_String.AddIfNotExist('151', ' ,    ?');
  Corp_Const_String.AddIfNotExist('152', '');
  Corp_Const_String.AddIfNotExist('153', '   ?');

  Corp_Const_String.AddIfNotExist('154', 'ٸ     ');
  Corp_Const_String.AddIfNotExist('155', ' ');
  Corp_Const_String.AddIfNotExist('156', ' ');
  Corp_Const_String.AddIfNotExist('157', ' ');
  Corp_Const_String.AddIfNotExist('158', ' ');
  Corp_Const_String.AddIfNotExist('159', ' ');
  Corp_Const_String.AddIfNotExist('160', '  ');
  Corp_Const_String.AddIfNotExist('161', ' ');
  Corp_Const_String.AddIfNotExist('162', ' ');
  Corp_Const_String.AddIfNotExist('163', ' ');
  Corp_Const_String.AddIfNotExist('164', ' ');
  Corp_Const_String.AddIfNotExist('165', ' ');
  Corp_Const_String.AddIfNotExist('166', ' ');
  Corp_Const_String.AddIfNotExist('167', ' ');
  Corp_Const_String.AddIfNotExist('168', ' ');
  Corp_Const_String.AddIfNotExist('169', ' ');

{  Corp_Const_String.AddIfNotExist('170', '');
  Corp_Const_String.AddIfNotExist('171', '');
  Corp_Const_String.AddIfNotExist('172', '');
  Corp_Const_String.AddIfNotExist('173', '');
  Corp_Const_String.AddIfNotExist('174', '');
  Corp_Const_String.AddIfNotExist('175', '');
  Corp_Const_String.AddIfNotExist('176', '');
  Corp_Const_String.AddIfNotExist('177', '');
  Corp_Const_String.AddIfNotExist('178', '');
  Corp_Const_String.AddIfNotExist('179', '');
  Corp_Const_String.AddIfNotExist('180', '');
  Corp_Const_String.AddIfNotExist('181', '');
  Corp_Const_String.AddIfNotExist('182', '');
  Corp_Const_String.AddIfNotExist('183', '');
  Corp_Const_String.AddIfNotExist('184', '');
  Corp_Const_String.AddIfNotExist('185', '');
  Corp_Const_String.AddIfNotExist('186', '');
  Corp_Const_String.AddIfNotExist('187', '');
  Corp_Const_String.AddIfNotExist('188', '');
  Corp_Const_String.AddIfNotExist('189', '');
  Corp_Const_String.AddIfNotExist('190', '');
  Corp_Const_String.AddIfNotExist('191', '');
  Corp_Const_String.AddIfNotExist('192', '');
  Corp_Const_String.AddIfNotExist('193', '');
  Corp_Const_String.AddIfNotExist('194', '');
  Corp_Const_String.AddIfNotExist('195', '');
  Corp_Const_String.AddIfNotExist('196', '');
  Corp_Const_String.AddIfNotExist('197', '');
  Corp_Const_String.AddIfNotExist('198', '');
  Corp_Const_String.AddIfNotExist('199', '');
  Corp_Const_String.AddIfNotExist('200', '');}




  Corp_Const_String.AddIfNotExist('Deleting', '');
  Corp_Const_String.AddIfNotExist('DelDoc', '  ?');
  Corp_Const_String.AddIfNotExist('Zamech', '');
{  Corp_Const_String.AddIfNotExist('', '');
  Corp_Const_String.AddIfNotExist('', '');
  Corp_Const_String.AddIfNotExist('', '');
  Corp_Const_String.AddIfNotExist('', '');
  Corp_Const_String.AddIfNotExist('', '');}



  //   Quantum Grid
  Corp_Const_String.AddIfNotExist('scxUnsupportedExport', '   : %1');
  Corp_Const_String.AddIfNotExist('scxStyleManagerKill', '       ');
  Corp_Const_String.AddIfNotExist('scxStyleManagerCreate', '   ');
  Corp_Const_String.AddIfNotExist('scxExportToHtml', '   - (*.html)');
  Corp_Const_String.AddIfNotExist('scxExportToXml', '  XML  (*.xml)');
  Corp_Const_String.AddIfNotExist('scxExportToText', '    (*.txt)');
  Corp_Const_String.AddIfNotExist('scxEmptyExportCache', '  ');
  Corp_Const_String.AddIfNotExist('scxIncorrectUnion', '   ');
  Corp_Const_String.AddIfNotExist('scxIllegalWidth', '   ');
  Corp_Const_String.AddIfNotExist('scxInvalidColumnRowCount', '     ');
  Corp_Const_String.AddIfNotExist('scxIllegalHeight', '   ');
  Corp_Const_String.AddIfNotExist('scxInvalidColumnIndex', '  %d   ');
  Corp_Const_String.AddIfNotExist('scxInvalidRowIndex', '  %d   ');
  Corp_Const_String.AddIfNotExist('scxInvalidStyleIndex', '     %d');
  Corp_Const_String.AddIfNotExist('scxExportToExcel', '  MS Excel (*.xls)');
  Corp_Const_String.AddIfNotExist('scxWorkbookWrite', '   XLS-');
  Corp_Const_String.AddIfNotExist('scxInvalidCellDimension', '   ');
  Corp_Const_String.AddIfNotExist('scxBoolTrue', '');
  Corp_Const_String.AddIfNotExist('scxBoolFalse', '');

  Corp_Const_String.AddIfNotExist('cxSGridNone', '');
  Corp_Const_String.AddIfNotExist('cxSGridSortColumnAsc', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridSortColumnDesc', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridClearSorting', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridGroupByThisField', '   ');
  Corp_Const_String.AddIfNotExist('cxSGridRemoveThisGroupItem', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridGroupByBox', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridAlignmentSubMenu', '');
  Corp_Const_String.AddIfNotExist('cxSGridAlignLeft', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridAlignRight', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridAlignCenter', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridRemoveColumn', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridFieldChooser', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridBestFit', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridBestFitAllColumns', '  (  )');
  Corp_Const_String.AddIfNotExist('cxSGridShowFooter', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridShowGroupFooter', '   ');

  Corp_Const_String.AddIfNotExist('cxSGridSumMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridMinMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridMaxMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridCountMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridAvgMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridNoneMenuItem', '');


  // cxDataConsts.pas
  Corp_Const_String.AddIfNotExist('cxSDataReadError','  ');
  Corp_Const_String.AddIfNotExist('cxSDataWriteError','  ');
  Corp_Const_String.AddIfNotExist('cxSDataItemExistError','  ');
  Corp_Const_String.AddIfNotExist('cxSDataRecordIndexError','    ');
  Corp_Const_String.AddIfNotExist('cxSDataItemIndexError','    ');
  Corp_Const_String.AddIfNotExist('cxSDataProviderModeError','      ');
  Corp_Const_String.AddIfNotExist('cxSDataInvalidStreamFormat','   ');
  Corp_Const_String.AddIfNotExist('cxSDataRowIndexError','    ');
  Corp_Const_String.AddIfNotExist('cxSDataCustomDataSourceInvalidCompare','GetInfoForCompare not implemented');
  // DB
  Corp_Const_String.AddIfNotExist('cxSDBDetailFilterControllerNotFound','    ');
  Corp_Const_String.AddIfNotExist('cxSDBNotInGridMode','     ');


  // cxEditConsts.Pas
  Corp_Const_String.AddIfNotExist('cxSEditDateConvertError','     ');
  Corp_Const_String.AddIfNotExist('cxSEditInvalidRepositoryItem','    ');
  Corp_Const_String.AddIfNotExist('cxSEditNumericValueConvertError','     ');
  Corp_Const_String.AddIfNotExist('cxSEditPopupCircularReferencingError','   ');
  Corp_Const_String.AddIfNotExist('cxSEditPostError','     ');
  Corp_Const_String.AddIfNotExist('cxSEditTimeConvertError','    ');
  Corp_Const_String.AddIfNotExist('cxSEditValidateErrorText','  .  Esc   .');
  Corp_Const_String.AddIfNotExist('cxSEditValueOutOfBounds','   ');

  // TODO
{  cxSEditCheckBoxChecked             = 'True';
  cxSEditCheckBoxGrayed              = '';
  cxSEditCheckBoxUnchecked           = 'False';
  cxSRadioGroupDefaultCaption        = '';}

  Corp_Const_String.AddIfNotExist('cxSTextTrue','');
  Corp_Const_String.AddIfNotExist('cxSTextFalse','');

  // blob
  Corp_Const_String.AddIfNotExist('cxSBlobButtonOK','&');
  Corp_Const_String.AddIfNotExist('cxSBlobButtonCancel','&');
  Corp_Const_String.AddIfNotExist('cxSBlobButtonClose','&');
  Corp_Const_String.AddIfNotExist('cxSBlobMemo','()');
  Corp_Const_String.AddIfNotExist('cxSBlobMemoEmpty','(memo)');
  Corp_Const_String.AddIfNotExist('cxSBlobPicture','()');
  Corp_Const_String.AddIfNotExist('cxSBlobPictureEmpty','()');

  // popup menu items
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionCut','&');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionCopy','&');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionPaste','&');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionDelete','&');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionLoad','&...');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionSave','&. ...');

  // date
  Corp_Const_String.AddIfNotExist('cxSDatePopupClear','');
  Corp_Const_String.AddIfNotExist('cxSDatePopupNow','');
  Corp_Const_String.AddIfNotExist('cxSDatePopupOK','');
  Corp_Const_String.AddIfNotExist('cxSDatePopupToday','');
  Corp_Const_String.AddIfNotExist('cxSDateError',' ');
  // smart input consts
  Corp_Const_String.AddIfNotExist('cxSDateToday','');
  Corp_Const_String.AddIfNotExist('cxSDateYesterday','');
  Corp_Const_String.AddIfNotExist('cxSDateTomorrow','');
  Corp_Const_String.AddIfNotExist('cxSDateSunday','');
  Corp_Const_String.AddIfNotExist('cxSDateMonday','');
  Corp_Const_String.AddIfNotExist('cxSDateTuesday','');
  Corp_Const_String.AddIfNotExist('cxSDateWednesday','');
  Corp_Const_String.AddIfNotExist('cxSDateThursday','');
  Corp_Const_String.AddIfNotExist('cxSDateFriday','');
  Corp_Const_String.AddIfNotExist('cxSDateSaturday','');
  Corp_Const_String.AddIfNotExist('cxSDateFirst', '');
  Corp_Const_String.AddIfNotExist('cxSDateSecond','');
  Corp_Const_String.AddIfNotExist('cxSDateThird','');
  Corp_Const_String.AddIfNotExist('cxSDateFourth','');
  Corp_Const_String.AddIfNotExist('cxSDateFifth','');
  Corp_Const_String.AddIfNotExist('cxSDateSixth','');
  Corp_Const_String.AddIfNotExist('cxSDateSeventh','');
  Corp_Const_String.AddIfNotExist('cxSDateBOM','bom');
  Corp_Const_String.AddIfNotExist('cxSDateEOM','eom');
  Corp_Const_String.AddIfNotExist('cxSDateNow','');

  // calculator
  Corp_Const_String.AddIfNotExist('scxSCalcError','');




  //********** dxBarStrs
  Corp_Const_String.AddIfNotExist('dxSBAR_LOOKUPDIALOGCAPTION',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_LOOKUPDIALOGOK','');
  Corp_Const_String.AddIfNotExist('dxSBAR_LOOKUPDIALOGCANCEL','');

  Corp_Const_String.AddIfNotExist('dxSBAR_DIALOGOK','');
  Corp_Const_String.AddIfNotExist('dxSBAR_DIALOGCANCEL','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_0','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_1','Ҹ-');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_2','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_3','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_4','-');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_5','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_6','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_7','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_8','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_9','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_10','-');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_11','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_12','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_13','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_14','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLOR_STR_15','');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLORAUTOTEXT','()');
  Corp_Const_String.AddIfNotExist('dxSBAR_COLORCUSTOMTEXT','()');
  Corp_Const_String.AddIfNotExist('dxSBAR_DATETODAY','');
  Corp_Const_String.AddIfNotExist('dxSBAR_DATECLEAR','');
  Corp_Const_String.AddIfNotExist('dxSBAR_DATEDIALOGCAPTION',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_TREEVIEWDIALOGCAPTION',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_IMAGEDIALOGCAPTION',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_IMAGEINDEX',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_IMAGETEXT','');
  Corp_Const_String.AddIfNotExist('dxSBAR_PLACEFORCONTROL','  ');
  Corp_Const_String.AddIfNotExist('dxSBAR_CANTASSIGNCONTROL','    ,    TdxBarControlContainerItem.');

  Corp_Const_String.AddIfNotExist('dxSBAR_WANTTORESETTOOLBAR',' ,     ''%s''  ?');
  Corp_Const_String.AddIfNotExist('dxSBAR_WANTTORESETUSAGEDATA','This will delete the record of the commands you''ve used in this application and restore the default set of visible commands to the menus and toolbars. It will not undo any explicit customizations.   Are you sure you want to proceed?');
  Corp_Const_String.AddIfNotExist('dxSBAR_BARMANAGERMORETHENONE','     TdxBarManager');
  Corp_Const_String.AddIfNotExist('dxSBAR_BARMANAGERBADOWNER','TdxBarManager    - TForm (TCustomForm)');
  Corp_Const_String.AddIfNotExist('dxSBAR_NOBARMANAGERS','TdxBarManagers    ');
  Corp_Const_String.AddIfNotExist('dxSBAR_WANTTODELETETOOLBAR','     ''%s'' ?');
  Corp_Const_String.AddIfNotExist('dxSBAR_WANTTODELETECATEGORY','    ''%s'' ?');
  Corp_Const_String.AddIfNotExist('dxSBAR_WANTTOCLEARCOMMANDS','       ''%s'' ?');
  Corp_Const_String.AddIfNotExist('dxSBAR_RECURSIVESUBITEMS','     -');
  Corp_Const_String.AddIfNotExist('dxSBAR_COMMANDNAMECANNOTBEBLANK','    . ,  .');
  Corp_Const_String.AddIfNotExist('dxSBAR_TOOLBAREXISTS','    ''%s''  .');
  Corp_Const_String.AddIfNotExist('dxSBAR_RECURSIVEGROUPS','     ');

  Corp_Const_String.AddIfNotExist('dxSBAR_DEFAULTCATEGORYNAME',' ');

  Corp_Const_String.AddIfNotExist('dxSBAR_CP_ADDSUBITEM',' & ');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_ADDBUTTON',' &');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_ADDITEM',' &');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_DELETEBAR','  ');

  Corp_Const_String.AddIfNotExist('dxSBAR_CP_RESET','&');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_DELETE','&');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_NAME','&:');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_CAPTION','&:'); // is the same as dxSBAR_CP_NAME (at design-time)
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_DEFAULTSTYLE','&  ');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_TEXTONLYALWAYS','&  ()');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_TEXTONLYINMENUS','  ( )');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_IMAGEANDTEXT','  &');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_BEGINAGROUP',' &');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_VISIBLE','&');
  Corp_Const_String.AddIfNotExist('dxSBAR_CP_MOSTRECENTLYUSED','&  ');

  Corp_Const_String.AddIfNotExist('dxSBAR_ADDEX','...');
  Corp_Const_String.AddIfNotExist('dxSBAR_RENAMEEX','...');
  Corp_Const_String.AddIfNotExist('dxSBAR_DELETE','');
  Corp_Const_String.AddIfNotExist('dxSBAR_CLEAR','');
  Corp_Const_String.AddIfNotExist('dxSBAR_VISIBLE','');
  Corp_Const_String.AddIfNotExist('dxSBAR_OK','');
  Corp_Const_String.AddIfNotExist('dxSBAR_CANCEL','');
  Corp_Const_String.AddIfNotExist('dxSBAR_SUBMENUEDITOR',' ...');
  Corp_Const_String.AddIfNotExist('dxSBAR_SUBMENUEDITORCAPTION',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_INSERTEX','...');

  Corp_Const_String.AddIfNotExist('dxSBAR_MOVEUP',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_MOVEDOWN',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_POPUPMENUEDITOR','  ...');
  Corp_Const_String.AddIfNotExist('dxSBAR_TABSHEET1','   ');
  Corp_Const_String.AddIfNotExist('dxSBAR_TABSHEET2','  ');
  Corp_Const_String.AddIfNotExist('dxSBAR_TABSHEET3','  ');
  Corp_Const_String.AddIfNotExist('dxSBAR_TOOLBARS',' &:');
  Corp_Const_String.AddIfNotExist('dxSBAR_TNEW','&...');
  Corp_Const_String.AddIfNotExist('dxSBAR_TRENAME','&...');
  Corp_Const_String.AddIfNotExist('dxSBAR_TDELETE','&');
  Corp_Const_String.AddIfNotExist('dxSBAR_TRESET','&...');
  Corp_Const_String.AddIfNotExist('dxSBAR_CLOSE','');
  Corp_Const_String.AddIfNotExist('dxSBAR_CAPTION','');
  Corp_Const_String.AddIfNotExist('dxSBAR_CATEGORIES','&:');
  Corp_Const_String.AddIfNotExist('dxSBAR_COMMANDS',':');
  Corp_Const_String.AddIfNotExist('dxSBAR_DESCRIPTION','');

  Corp_Const_String.AddIfNotExist('dxSBAR_CUSTOMIZE','&...');
  Corp_Const_String.AddIfNotExist('dxSBAR_ADDREMOVEBUTTONS','&   ');
  Corp_Const_String.AddIfNotExist('dxSBAR_MOREBUTTONS',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_RESETTOOLBAR','&  ');
  Corp_Const_String.AddIfNotExist('dxSBAR_EXPAND',' (Ctrl-Down)');
  Corp_Const_String.AddIfNotExist('dxSBAR_DRAGTOMAKEMENUFLOAT','    ');

  Corp_Const_String.AddIfNotExist('dxSBAR_TOOLBARNEWNAME','');
  Corp_Const_String.AddIfNotExist('dxSBAR_CATEGORYADD',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_CATEGORYINSERT',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_CATEGORYRENAME',' ');
  Corp_Const_String.AddIfNotExist('dxSBAR_TOOLBARADD','  ');
  Corp_Const_String.AddIfNotExist('dxSBAR_TOOLBARRENAME','  ');
  Corp_Const_String.AddIfNotExist('dxSBAR_CATEGORYNAME','& :');
  Corp_Const_String.AddIfNotExist('dxSBAR_TOOLBARNAME','&  :');
  Corp_Const_String.AddIfNotExist('dxSBAR_CUSTOMIZINGFORM',' ...');

  Corp_Const_String.AddIfNotExist('dxSBAR_MODIFY','... ');
  Corp_Const_String.AddIfNotExist('dxSBAR_PERSMENUSANDTOOLBARS','    ');
  Corp_Const_String.AddIfNotExist('dxSBAR_MENUSSHOWRECENTITEMS','&      ');
  Corp_Const_String.AddIfNotExist('dxSBAR_SHOWFULLMENUSAFTERDELAY',' &    ');
  Corp_Const_String.AddIfNotExist('dxSBAR_RESETUSAGEDATA','&  ');

  Corp_Const_String.AddIfNotExist('dxSBAR_OTHEROPTIONS','');
  Corp_Const_String.AddIfNotExist('dxSBAR_LARGEICONS','& ');
  Corp_Const_String.AddIfNotExist('dxSBAR_HINTOPT1','     ');
  Corp_Const_String.AddIfNotExist('dxSBAR_HINTOPT2','     ');
  Corp_Const_String.AddIfNotExist('dxSBAR_MENUANIMATIONS','& :');
  Corp_Const_String.AddIfNotExist('dxSBAR_MENUANIM1','()');
  Corp_Const_String.AddIfNotExist('dxSBAR_MENUANIM2','');
  Corp_Const_String.AddIfNotExist('dxSBAR_MENUANIM3','');
  Corp_Const_String.AddIfNotExist('dxSBAR_MENUANIM4','');
  Corp_Const_String.AddIfNotExist('dxSBAR_MENUANIM5','');


  //****************** dxDockConsts
  Corp_Const_String.AddIfNotExist('sdxInvalidLayoutSiteDeleting','    TdxLayoutDockSite.');
  Corp_Const_String.AddIfNotExist('sdxInvalidFloatSiteDeleting','    TdxFloatDockSite.');
  Corp_Const_String.AddIfNotExist('sdxInvalidFloatingDeleting','    TdxCustomDockSite   .');
  Corp_Const_String.AddIfNotExist('sdxInvalidParentAssigning','       .');
  Corp_Const_String.AddIfNotExist('sdxInvalidOwner',' TdxCustomDockControl   TCustomForm.');
  Corp_Const_String.AddIfNotExist('sdxInvalidParent',' %s   TdxCustomDockControl.');
  Corp_Const_String.AddIfNotExist('sdxInvalidDockSiteParent',' TdxDockSite    TdxCustomDockControl.');
  Corp_Const_String.AddIfNotExist('sdxInvalidFloatSiteParent',' TdxFloatDockSite    TdxFloatForm.');
  Corp_Const_String.AddIfNotExist('sdxInvalidPanelChild','    TdxCustomDockControl  TdxDockPanel (%s   ).');
  Corp_Const_String.AddIfNotExist('sdxInvalidSiteChild','    TdxCustomDockControl  TdxCustomDockSite (%s   ).');
  Corp_Const_String.AddIfNotExist('sdxInvaldZoneOwner','    TdxZone   TdxCustomDockControl.');
  Corp_Const_String.AddIfNotExist('sdxInternalErrorAutoHide','     .');
  Corp_Const_String.AddIfNotExist('sdxInternalErrorPainter','   TdxCustomDockControl.');
  Corp_Const_String.AddIfNotExist('sdxInternalErrorLayout','   %s  .');
  Corp_Const_String.AddIfNotExist('sdxInternalErrorCreateLayout','     %s  .');
  Corp_Const_String.AddIfNotExist('sdxInternalErrorDestroyLayout','    %s  .');
  Corp_Const_String.AddIfNotExist('sdxManagerError','      TdxDockingManager instance,   .');
  Corp_Const_String.AddIfNotExist('sdxAncestorError','        ,    .');



  //**************** dxExtCtrlsStrs
  Corp_Const_String.AddIfNotExist('sdxAutoColorText','');
  Corp_Const_String.AddIfNotExist('sdxCustomColorText','...');

  Corp_Const_String.AddIfNotExist('sdxSysColorScrollBar',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorBackground','');
  Corp_Const_String.AddIfNotExist('sdxSysColorActiveCaption',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorInactiveCaption','  ');
  Corp_Const_String.AddIfNotExist('sdxSysColorMenu','');
  Corp_Const_String.AddIfNotExist('sdxSysColorWindow','');
  Corp_Const_String.AddIfNotExist('sdxSysColorWindowFrame',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorMenuText',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorWindowText',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorCaptionText',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorActiveBorder',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorInactiveBorder','  ');
  Corp_Const_String.AddIfNotExist('sdxSysColorAppWorkSpace','  ');
  Corp_Const_String.AddIfNotExist('sdxSysColorHighLight',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorHighLighText',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorBtnFace','  ');
  Corp_Const_String.AddIfNotExist('sdxSysColorBtnShadow',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorGrayText',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorBtnText',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorInactiveCaptionText','   ');
  Corp_Const_String.AddIfNotExist('sdxSysColorBtnHighligh',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColor3DDkShadow','3D ');
  Corp_Const_String.AddIfNotExist('sdxSysColor3DLight','3D ');
  Corp_Const_String.AddIfNotExist('sdxSysColorInfoText',' ');
  Corp_Const_String.AddIfNotExist('sdxSysColorInfoBk',' .');

  Corp_Const_String.AddIfNotExist('sdxPureColorBlack','');
  Corp_Const_String.AddIfNotExist('sdxPureColorRed','');
  Corp_Const_String.AddIfNotExist('sdxPureColorLime','-');
  Corp_Const_String.AddIfNotExist('sdxPureColorYellow','');
  Corp_Const_String.AddIfNotExist('sdxPureColorGreen','');
  Corp_Const_String.AddIfNotExist('sdxPureColorTeal','');
  Corp_Const_String.AddIfNotExist('sdxPureColorAqua','');
  Corp_Const_String.AddIfNotExist('sdxPureColorBlue','');
  Corp_Const_String.AddIfNotExist('sdxPureColorWhite','');
  Corp_Const_String.AddIfNotExist('sdxPureColorOlive','');
  Corp_Const_String.AddIfNotExist('sdxPureColorMoneyGreen','');
  Corp_Const_String.AddIfNotExist('sdxPureColorNavy','');
  Corp_Const_String.AddIfNotExist('sdxPureColorSkyBlue','-');
  Corp_Const_String.AddIfNotExist('sdxPureColorGray','');
  Corp_Const_String.AddIfNotExist('sdxPureColorMedGray',' ');
  Corp_Const_String.AddIfNotExist('sdxPureColorSilver','');
  Corp_Const_String.AddIfNotExist('sdxPureColorMaroon','-');
  Corp_Const_String.AddIfNotExist('sdxPureColorPurple','');
  Corp_Const_String.AddIfNotExist('sdxPureColorFuchsia','');
  Corp_Const_String.AddIfNotExist('sdxPureColorCream','');

  Corp_Const_String.AddIfNotExist('sdxBrushStyleSolid','');
  Corp_Const_String.AddIfNotExist('sdxBrushStyleClear','');
  Corp_Const_String.AddIfNotExist('sdxBrushStyleHorizontal','');
  Corp_Const_String.AddIfNotExist('sdxBrushStyleVertical','');
  Corp_Const_String.AddIfNotExist('sdxBrushStyleFDiagonal',' ');
  Corp_Const_String.AddIfNotExist('sdxBrushStyleBDiagonal',' ');
  Corp_Const_String.AddIfNotExist('sdxBrushStyleCross','');
  Corp_Const_String.AddIfNotExist('sdxBrushStyleDiagCross',' ');



  //*********** dxLayoutCommon
  Corp_Const_String.AddIfNotExist('dxLayoutNewGroupCaption',' ');
  Corp_Const_String.AddIfNotExist('dxLayoutNewGroupDialogCaption',' ');
  Corp_Const_String.AddIfNotExist('dxLayoutNewGroupDialogEditCaption','   :');

  Corp_Const_String.AddIfNotExist('dxLayoutNewItemCaption',' ');
  Corp_Const_String.AddIfNotExist('dxLayoutNewItemDialogCaption',' ');
  Corp_Const_String.AddIfNotExist('dxLayoutNewItemDialogEditCaption','   :');


  //********** dxLayoutCustomizeForm
  Corp_Const_String.AddIfNotExist('dxLayoutCustomizeFormCaption','');
  Corp_Const_String.AddIfNotExist('dxLayoutCustomizeFormItemsCaption','');
  Corp_Const_String.AddIfNotExist('dxLayoutCustomizeFormGroupsCaption','');
  Corp_Const_String.AddIfNotExist('dxLayoutCustomizeFormGroupsCreateCaption','...');
  Corp_Const_String.AddIfNotExist('dxLayoutCustomizeFormGroupsDeleteCaption','');

  //************* dxLayoutEditForm
  Corp_Const_String.AddIfNotExist('dxLayoutEditFormOK','');
  Corp_Const_String.AddIfNotExist('dxLayoutEditFormCancel','');

  //************ dxNavBarConsts
  Corp_Const_String.AddIfNotExist('sdxInvalideGroupControl','     TdxNavBarGroupControl.');






  // HyperLink
{  scxSHyperLinkPrefix                = 'http://';
  scxSHyperLinkDoubleSlash           = '//';}

  // edit repository
{  Corp_Const_String.AddIfNotExist('scxSEditRepositoryBlobItem','BlobEdit|Represents the BLOB editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryButtonItem','ButtonEdit|Represents an edit control with embedded buttons');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCalcItem','CalcEdit|Represents an edit control with a dropdown calculator window');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCheckBoxItem','CheckBox|Represents a check box control that allows selecting an option');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryComboBoxItem','ComboBox|Represents the combo box editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCurrencyItem','CurrencyEdit|Represents an editor enabling editing currency data');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryDateItem','DateEdit|Represents an edit control with a dropdown calendar');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryHyperLinkItem','HyperLink|Represents a text editor with hyperlink functionality');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryImageComboBoxItem','ImageComboBox|Represents an editor displaying the list of images and text strings within the dropdown window');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryImageItem','Image|Represents an image editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryLookupComboBoxItem','LookupComboBox|Represents a lookup combo box control');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryMaskItem','MaskEdit|Represents a generic masked edit control.');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryMemoItem','Memo|Represents an edit control that allows editing memo data');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryMRUItem','MRUEdit|Represents a text editor displaying the list of most recently used items (MRU) within a dropdown window');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryPopupItem','PopupEdit|Represents an edit control with a dropdown list');
  Corp_Const_String.AddIfNotExist('scxSEditRepositorySpinItem','SpinEdit|Represents a spin editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryRadioGroupItem','RadioGroup|Represents a group of radio buttons');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryTextItem','TextEdit|Represents a single line text editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryTimeItem','TimeEdit|Represents an editor displaying time values');

  Corp_Const_String.AddIfNotExist('scxRegExprLine','Line');
  Corp_Const_String.AddIfNotExist('scxRegExprChar','Char');
  Corp_Const_String.AddIfNotExist('scxRegExprNotAssignedSourceStream','The source stream is not assigned');
  Corp_Const_String.AddIfNotExist('scxRegExprEmptySourceStream','The source stream is empty');
  Corp_Const_String.AddIfNotExist('scxRegExprCantUsePlusQuantifier','The ''+'' quantifier cannot be applied here');
  Corp_Const_String.AddIfNotExist('scxRegExprCantUseStarQuantifier','The ''*'' quantifier cannot be applied here');
  Corp_Const_String.AddIfNotExist('scxRegExprCantCreateEmptyAlt','The alternative should not be empty');
  Corp_Const_String.AddIfNotExist('scxRegExprCantCreateEmptyBlock','The block should not be empty');
  Corp_Const_String.AddIfNotExist('scxRegExprIllegalSymbol','Illegal ''%s''');
  Corp_Const_String.AddIfNotExist('scxRegExprIllegalQuantifier','Illegal quantifier ''%s''');
  Corp_Const_String.AddIfNotExist('scxRegExprNotSupportQuantifier','The parameter quantifiers are not supported');
  Corp_Const_String.AddIfNotExist('scxRegExprIllegalIntegerValue','Illegal integer value');
  Corp_Const_String.AddIfNotExist('scxRegExprTooBigReferenceNumber','Too big reference number');
  Corp_Const_String.AddIfNotExist('scxRegExprCantCreateEmptyEnum','Can''t create empty enumeration');
  Corp_Const_String.AddIfNotExist('scxRegExprSubrangeOrder','The starting character of the subrange must be less than the finishing one');
  Corp_Const_String.AddIfNotExist('scxRegExprHexNumberExpected0','Hexadecimal number expected');
  Corp_Const_String.AddIfNotExist('scxRegExprHexNumberExpected','Hexadecimal number expected but ''%s'' found');
  Corp_Const_String.AddIfNotExist('scxRegExprMissing','Missing ''%s''');
  Corp_Const_String.AddIfNotExist('scxRegExprUnnecessary','Unnecessary ''%s''');
  Corp_Const_String.AddIfNotExist('scxRegExprIncorrectSpace','The space character is not allowed after ''\''');
  Corp_Const_String.AddIfNotExist('scxRegExprNotCompiled','Regular expression is not compiled');
  Corp_Const_String.AddIfNotExist('scxRegExprIncorrectParameterQuantifier','Incorrect parameter quantifier');
  Corp_Const_String.AddIfNotExist('scxRegExprCantUseParameterQuantifier','The parameter quantifier cannot be applied here');

  Corp_Const_String.AddIfNotExist('scxMaskEditRegExprError','Regular expression errors:');
  Corp_Const_String.AddIfNotExist('scxMaskEditInvalidEditValue','The edit value is invalid');
  Corp_Const_String.AddIfNotExist('scxMaskEditNoMask','None');
  Corp_Const_String.AddIfNotExist('scxMaskEditIllegalFileFormat','Illegal file format');
  Corp_Const_String.AddIfNotExist('scxMaskEditEmptyMaskCollectionFile','The mask collection file is empty');
  Corp_Const_String.AddIfNotExist('scxMaskEditMaskCollectionFiles','Mask collection files');
  Corp_Const_String.AddIfNotExist('cxSSpinEditInvalidNumericValue','Invalid numeric value');


  // cxExtEditConsts.Pas
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryColorComboBoxItem','ColorComboBox |Represents a editor with color functionality');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryFontNameComboBoxItem','FontNameComboBox |Represents a editor with font functionality');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryLabelItem','Label|Represents a Label');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryProgressBarItem','ProgressBar|Represents a ProgressBar');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryTrackBarItem','TrackBar|Represents a TrackBar');
  Corp_Const_String.AddIfNotExist('scxSEditRepositorySpinButtonItem','SpinButton|Represents a SpinButton');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCheckComboBox','CheckComboBox|Represents a CheckComboBox');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryShellComboBoxItem','ShellComboBox|Represents a combo box with a dropdown shell tree view');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCheckGroupItem','CheckGroup|Represents a group of check boxes');
  Corp_Const_String.AddIfNotExist('scxUDAssociated','%s is already associated with %s');
  Corp_Const_String.AddIfNotExist('scxHotZoneStyleMediaPlayer9','MediaPlayer9');
  Corp_Const_String.AddIfNotExist('scxHotZoneStyleMediaPlayer8','MediaPlayer8');
  Corp_Const_String.AddIfNotExist('scxHotZoneStyleXPTaskBar','XPTaskBar');
  Corp_Const_String.AddIfNotExist('scxHotZoneStyleSimple','Simple');

{  cxSEditCheckGroupCaptionStateDelimiter = ': ';
  cxSEditCheckGroupExportColumnSeparator = '  ';
  cxSEditCheckGroupFilterColumnSeparator = '; '; }
{  Corp_Const_String.AddIfNotExist('cxSEditCheckGroupChecked','');
  Corp_Const_String.AddIfNotExist('cxSEditCheckGroupGrayed','Grayed');
  Corp_Const_String.AddIfNotExist('cxSEditCheckGroupUnchecked',' ');}

  Corp_Const_String.AddIfNotExist('cxSCheckComboBoxStates0PropertyDlgCaption','cxCheckComboBox -  ');
  Corp_Const_String.AddIfNotExist('cxSCheckGroupStates0PropertyDlgCaption','cxCheckGroup -  ');

  Corp_Const_String.AddIfNotExist('cxSEditRichEditLibraryError','      ');
  Corp_Const_String.AddIfNotExist('cxSEditRichEditLineInsertionError','     ');
  Corp_Const_String.AddIfNotExist('cxSEditRichEditLoadFail','  ');
  Corp_Const_String.AddIfNotExist('cxSEditRichEditSaveFail','  ');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryRichEditItem',' |  ');


  // cxFilterConsts
  // base operators
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorEqual','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNotEqual',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLess',', ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLessEqual','  ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorGreater',', ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorGreaterEqual','  ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLike','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNotLike',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorBetween','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNotBetween',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorInList','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNotInList',' ');

  Corp_Const_String.AddIfNotExist('cxSFilterOperatorYesterday','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorToday','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorTomorrow','');

  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLastWeek',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLastMonth',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLastYear',' ');

  Corp_Const_String.AddIfNotExist('cxSFilterOperatorThisWeek',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorThisMonth',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorThisYear',' ');

  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNextWeek',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNextMonth',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNextYear',' ');

  Corp_Const_String.AddIfNotExist('cxSFilterAndCaption','');
  Corp_Const_String.AddIfNotExist('cxSFilterOrCaption','');
  Corp_Const_String.AddIfNotExist('cxSFilterNotCaption','');
  Corp_Const_String.AddIfNotExist('cxSFilterBlankCaption','');

  // derived
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorIsNull','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorIsNotNull',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorBeginsWith',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorDoesNotBeginWith','  ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorEndsWith','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorDoesNotEndWith',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorContains','');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorDoesNotContain',' ');
  // filter listbox's values
  Corp_Const_String.AddIfNotExist('cxSFilterBoxAllCaption','()');
  Corp_Const_String.AddIfNotExist('cxSFilterBoxCustomCaption','(...)');
  Corp_Const_String.AddIfNotExist('cxSFilterBoxBlanksCaption','()');
  Corp_Const_String.AddIfNotExist('cxSFilterBoxNonBlanksCaption','( )');


  // cxFilterControlStrs.pas
  // cxFilterBoolOperator
  Corp_Const_String.AddIfNotExist('cxSFilterBoolOperatorAnd','');        // all
  Corp_Const_String.AddIfNotExist('cxSFilterBoolOperatorOr','');          // any
  Corp_Const_String.AddIfNotExist('cxSFilterBoolOperatorNotAnd',' '); // not all
  Corp_Const_String.AddIfNotExist('cxSFilterBoolOperatorNotOr',' ');   // not any
  //
  Corp_Const_String.AddIfNotExist('cxSFilterRootButtonCaption','');
  Corp_Const_String.AddIfNotExist('cxSFilterAddCondition',' &');
  Corp_Const_String.AddIfNotExist('cxSFilterAddGroup',' &');
  Corp_Const_String.AddIfNotExist('cxSFilterRemoveRow','& ');
  Corp_Const_String.AddIfNotExist('cxSFilterClearAll',' &');
  Corp_Const_String.AddIfNotExist('cxSFilterFooterAddCondition','     ');

  Corp_Const_String.AddIfNotExist('cxSFilterGroupCaption','  ');
  Corp_Const_String.AddIfNotExist('cxSFilterRootGroupCaption','<>');
  Corp_Const_String.AddIfNotExist('cxSFilterControlNullString','<>');

  Corp_Const_String.AddIfNotExist('cxSFilterErrorBuilding','      ');

  //FilterDialog
  Corp_Const_String.AddIfNotExist('cxSFilterDialogCaption',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogInvalidValue',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogUse','');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogSingleCharacter','-  ');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogCharactersSeries','-  ');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogOperationAnd','');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogOperationOr','');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogRows','  :');

  // FilterControlDialog
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogCaption',' ');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogNewFile',' .flt');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogOpenDialogCaption','  ');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogSaveDialogCaption','    ');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionSaveCaption','& ...');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionOpenCaption','&...');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionApplyCaption','&');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionOkCaption','');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionCancelCaption','');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogFileExt','flt');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogFileFilter',' (*.flt)|*.flt');


  //****** cxGridStrs
  Corp_Const_String.AddIfNotExist('scxGridRecursiveLevels','     ');

  Corp_Const_String.AddIfNotExist('scxGridDeletingConfirmationCaption','');
  Corp_Const_String.AddIfNotExist('scxGridDeletingFocusedConfirmationText',' ?');
  Corp_Const_String.AddIfNotExist('scxGridDeletingSelectedConfirmationText','   ?');

  Corp_Const_String.AddIfNotExist('scxGridNewItemRowInfoText','     ');

  Corp_Const_String.AddIfNotExist('scxGridFilterIsEmpty','< >');

  Corp_Const_String.AddIfNotExist('scxGridCustomizationFormCaption','');
  Corp_Const_String.AddIfNotExist('scxGridCustomizationFormColumnsPageCaption','');
  Corp_Const_String.AddIfNotExist('scxGridGroupByBoxCaption','    ');
  Corp_Const_String.AddIfNotExist('scxGridFilterCustomizeButtonCaption','...');

  Corp_Const_String.AddIfNotExist('scxGridCustomizationFormBandsPageCaption','');

  Corp_Const_String.AddIfNotExist('scxGridConverterIntermediaryMissing','   !'#13#10',   %s   .');
  Corp_Const_String.AddIfNotExist('scxGridConverterNotExistGrid','cxGrid  ');
  Corp_Const_String.AddIfNotExist('scxGridConverterNotExistComponent','  ');
  Corp_Const_String.AddIfNotExist('scxImportErrorCaption',' ');

  Corp_Const_String.AddIfNotExist('scxNotExistGridView','   ');
  Corp_Const_String.AddIfNotExist('scxNotExistGridLevel','    ');
  Corp_Const_String.AddIfNotExist('scxCantCreateExportOutputFile','      ');

  Corp_Const_String.AddIfNotExist('cxSEditRepositoryExtLookupComboBoxItem','ExtLookupComboBox|        QuantumGrid');


  //************ cxLibraryStrs.Pas
  Corp_Const_String.AddIfNotExist('scxCantCreateRegistryKey','    : \%s');
  Corp_Const_String.AddIfNotExist('scxConverterCantCreateStyleRepository','    ');


  //************ cxNavigator
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_First',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Prior',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_PriorPage',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Next',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_NextPage',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Last',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Insert',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Delete',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Edit',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Post',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Cancel',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Refresh',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_SaveBookmark',' ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_GotoBookmark','  ');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Filter',' ');
  Corp_Const_String.AddIfNotExist('cxNavigator_DeleteRecordQuestion',' ?');


{  Corp_Const_String.AddIfNotExist('', '');
  Corp_Const_String.AddIfNotExist('', '');
  Corp_Const_String.AddIfNotExist('', '');}


//   ShowMessage(IntToStr(Corp_Const_String.Count));

End;


//   Quantum
Procedure AnotherResourceQuantum;
Begin


(*

  ++++++++++++++    

  //   Quantum Grid
  Corp_Const_String.AddIfNotExist('scxUnsupportedExport', '   : %1');
  Corp_Const_String.AddIfNotExist('scxStyleManagerKill', '       ');
  Corp_Const_String.AddIfNotExist('scxStyleManagerCreate', '   ');
  Corp_Const_String.AddIfNotExist('scxExportToHtml', '   - (*.html)');
  Corp_Const_String.AddIfNotExist('scxExportToXml', 'Export to XML document (*.xml)');
  Corp_Const_String.AddIfNotExist('scxExportToText', 'Export to text format (*.txt)');
  Corp_Const_String.AddIfNotExist('scxEmptyExportCache', '  ');
  Corp_Const_String.AddIfNotExist('scxIncorrectUnion', '   ');
  Corp_Const_String.AddIfNotExist('scxIllegalWidth', '   ');
  Corp_Const_String.AddIfNotExist('scxInvalidColumnRowCount', '     ');
  Corp_Const_String.AddIfNotExist('scxIllegalHeight', '   ');
  Corp_Const_String.AddIfNotExist('scxInvalidColumnIndex', '  %d   ');
  Corp_Const_String.AddIfNotExist('scxInvalidRowIndex', 'The row index %d out of bounds');
  Corp_Const_String.AddIfNotExist('scxInvalidStyleIndex', '     %d');
  Corp_Const_String.AddIfNotExist('scxExportToExcel', '  MS Excel (*.xls)');
  Corp_Const_String.AddIfNotExist('scxWorkbookWrite', '   XLS-');
  Corp_Const_String.AddIfNotExist('scxInvalidCellDimension', '   ');
  Corp_Const_String.AddIfNotExist('scxBoolTrue', '');
  Corp_Const_String.AddIfNotExist('scxBoolFalse', '');

  Corp_Const_String.AddIfNotExist('cxSGridNone', '');
  Corp_Const_String.AddIfNotExist('cxSGridSortColumnAsc', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridSortColumnDesc', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridClearSorting', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridGroupByThisField', '   ');
  Corp_Const_String.AddIfNotExist('cxSGridRemoveThisGroupItem', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridGroupByBox', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridAlignmentSubMenu', '');
  Corp_Const_String.AddIfNotExist('cxSGridAlignLeft', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridAlignRight', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridAlignCenter', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridRemoveColumn', '  ');
  Corp_Const_String.AddIfNotExist('cxSGridFieldChooser', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridBestFit', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridBestFitAllColumns', '  (  )');
  Corp_Const_String.AddIfNotExist('cxSGridShowFooter', ' ');
  Corp_Const_String.AddIfNotExist('cxSGridShowGroupFooter', '   ');

  Corp_Const_String.AddIfNotExist('cxSGridSumMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridMinMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridMaxMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridCountMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridAvgMenuItem', '');
  Corp_Const_String.AddIfNotExist('cxSGridNoneMenuItem', '');


  // cxDataConsts.pas
  Corp_Const_String.AddIfNotExist('cxSDataReadError','Stream read error');
  Corp_Const_String.AddIfNotExist('cxSDataWriteError','Stream write error');
  Corp_Const_String.AddIfNotExist('cxSDataItemExistError','Item already exists');
  Corp_Const_String.AddIfNotExist('cxSDataRecordIndexError','RecordIndex out of range');
  Corp_Const_String.AddIfNotExist('cxSDataItemIndexError','ItemIndex out of range');
  Corp_Const_String.AddIfNotExist('cxSDataProviderModeError','This operation is not supported in provider mode');
  Corp_Const_String.AddIfNotExist('cxSDataInvalidStreamFormat','Invalid stream format');
  Corp_Const_String.AddIfNotExist('cxSDataRowIndexError','RowIndex out of range');
  Corp_Const_String.AddIfNotExist('cxSDataCustomDataSourceInvalidCompare','GetInfoForCompare not implemented');
  // DB
  Corp_Const_String.AddIfNotExist('cxSDBDetailFilterControllerNotFound','DetailFilterController not found');
  Corp_Const_String.AddIfNotExist('cxSDBNotInGridMode','DataController not in GridMode');


  // cxEditConsts.Pas
  Corp_Const_String.AddIfNotExist('cxSEditDateConvertError','Could not convert to date');
  Corp_Const_String.AddIfNotExist('cxSEditInvalidRepositoryItem','The repository item is not acceptable');
  Corp_Const_String.AddIfNotExist('cxSEditNumericValueConvertError','Could not convert to numeric value');
  Corp_Const_String.AddIfNotExist('cxSEditPopupCircularReferencingError','Circular referencing is not allowed');
  Corp_Const_String.AddIfNotExist('cxSEditPostError','An error occured during posting edit value');
  Corp_Const_String.AddIfNotExist('cxSEditTimeConvertError','Could not convert to time');
  Corp_Const_String.AddIfNotExist('cxSEditValidateErrorText','Invalid input value. Use escape key to abandon changes');
  Corp_Const_String.AddIfNotExist('cxSEditValueOutOfBounds','Value out of bounds');

  // TODO
{  cxSEditCheckBoxChecked             = 'True';
  cxSEditCheckBoxGrayed              = '';
  cxSEditCheckBoxUnchecked           = 'False';
  cxSRadioGroupDefaultCaption        = '';}

  Corp_Const_String.AddIfNotExist('cxSTextTrue','True');
  Corp_Const_String.AddIfNotExist('cxSTextFalse','False');

  // blob
  Corp_Const_String.AddIfNotExist('cxSBlobButtonOK','&OK');
  Corp_Const_String.AddIfNotExist('cxSBlobButtonCancel','&Cancel');
  Corp_Const_String.AddIfNotExist('cxSBlobButtonClose','&Close');
  Corp_Const_String.AddIfNotExist('cxSBlobMemo','(MEMO)');
  Corp_Const_String.AddIfNotExist('cxSBlobMemoEmpty','(memo)');
  Corp_Const_String.AddIfNotExist('cxSBlobPicture','(PICTURE)');
  Corp_Const_String.AddIfNotExist('cxSBlobPictureEmpty','(picture)');

  // popup menu items
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionCut','Cu&t');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionCopy','&Copy');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionPaste','&Paste');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionDelete','&Delete');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionLoad','&Load...');
  Corp_Const_String.AddIfNotExist('cxSMenuItemCaptionSave','Save &As...');

  // date
  Corp_Const_String.AddIfNotExist('cxSDatePopupClear','Clear');
  Corp_Const_String.AddIfNotExist('cxSDatePopupNow','Now');
  Corp_Const_String.AddIfNotExist('cxSDatePopupOK','OK');
  Corp_Const_String.AddIfNotExist('cxSDatePopupToday','Today');
  Corp_Const_String.AddIfNotExist('cxSDateError','Invalid Date');
  // smart input consts
  Corp_Const_String.AddIfNotExist('cxSDateToday','today');
  Corp_Const_String.AddIfNotExist('cxSDateYesterday','yesterday');
  Corp_Const_String.AddIfNotExist('cxSDateTomorrow','tomorrow');
  Corp_Const_String.AddIfNotExist('cxSDateSunday','Sunday');
  Corp_Const_String.AddIfNotExist('cxSDateMonday','Monday');
  Corp_Const_String.AddIfNotExist('cxSDateTuesday','Tuesday');
  Corp_Const_String.AddIfNotExist('cxSDateWednesday','Wednesday');
  Corp_Const_String.AddIfNotExist('cxSDateThursday','Thursday');
  Corp_Const_String.AddIfNotExist('cxSDateFriday','Friday');
  Corp_Const_String.AddIfNotExist('cxSDateSaturday','Saturday');
  Corp_Const_String.AddIfNotExist('cxSDateFirst', 'first');
  Corp_Const_String.AddIfNotExist('cxSDateSecond','second');
  Corp_Const_String.AddIfNotExist('cxSDateThird','third');
  Corp_Const_String.AddIfNotExist('cxSDateFourth','fourth');
  Corp_Const_String.AddIfNotExist('cxSDateFifth','fifth');
  Corp_Const_String.AddIfNotExist('cxSDateSixth','sixth');
  Corp_Const_String.AddIfNotExist('cxSDateSeventh','seventh');
  Corp_Const_String.AddIfNotExist('cxSDateBOM','bom');
  Corp_Const_String.AddIfNotExist('cxSDateEOM','eom');
  Corp_Const_String.AddIfNotExist('cxSDateNow','now');

  // calculator
  Corp_Const_String.AddIfNotExist('scxSCalcError','Error');

  // HyperLink
{  scxSHyperLinkPrefix                = 'http://';
  scxSHyperLinkDoubleSlash           = '//';}

  // edit repository
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryBlobItem','BlobEdit|Represents the BLOB editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryButtonItem','ButtonEdit|Represents an edit control with embedded buttons');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCalcItem','CalcEdit|Represents an edit control with a dropdown calculator window');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCheckBoxItem','CheckBox|Represents a check box control that allows selecting an option');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryComboBoxItem','ComboBox|Represents the combo box editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCurrencyItem','CurrencyEdit|Represents an editor enabling editing currency data');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryDateItem','DateEdit|Represents an edit control with a dropdown calendar');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryHyperLinkItem','HyperLink|Represents a text editor with hyperlink functionality');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryImageComboBoxItem','ImageComboBox|Represents an editor displaying the list of images and text strings within the dropdown window');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryImageItem','Image|Represents an image editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryLookupComboBoxItem','LookupComboBox|Represents a lookup combo box control');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryMaskItem','MaskEdit|Represents a generic masked edit control.');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryMemoItem','Memo|Represents an edit control that allows editing memo data');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryMRUItem','MRUEdit|Represents a text editor displaying the list of most recently used items (MRU) within a dropdown window');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryPopupItem','PopupEdit|Represents an edit control with a dropdown list');
  Corp_Const_String.AddIfNotExist('scxSEditRepositorySpinItem','SpinEdit|Represents a spin editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryRadioGroupItem','RadioGroup|Represents a group of radio buttons');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryTextItem','TextEdit|Represents a single line text editor');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryTimeItem','TimeEdit|Represents an editor displaying time values');

  Corp_Const_String.AddIfNotExist('scxRegExprLine','Line');
  Corp_Const_String.AddIfNotExist('scxRegExprChar','Char');
  Corp_Const_String.AddIfNotExist('scxRegExprNotAssignedSourceStream','The source stream is not assigned');
  Corp_Const_String.AddIfNotExist('scxRegExprEmptySourceStream','The source stream is empty');
  Corp_Const_String.AddIfNotExist('scxRegExprCantUsePlusQuantifier','The ''+'' quantifier cannot be applied here');
  Corp_Const_String.AddIfNotExist('scxRegExprCantUseStarQuantifier','The ''*'' quantifier cannot be applied here');
  Corp_Const_String.AddIfNotExist('scxRegExprCantCreateEmptyAlt','The alternative should not be empty');
  Corp_Const_String.AddIfNotExist('scxRegExprCantCreateEmptyBlock','The block should not be empty');
  Corp_Const_String.AddIfNotExist('scxRegExprIllegalSymbol','Illegal ''%s''');
  Corp_Const_String.AddIfNotExist('scxRegExprIllegalQuantifier','Illegal quantifier ''%s''');
  Corp_Const_String.AddIfNotExist('scxRegExprNotSupportQuantifier','The parameter quantifiers are not supported');
  Corp_Const_String.AddIfNotExist('scxRegExprIllegalIntegerValue','Illegal integer value');
  Corp_Const_String.AddIfNotExist('scxRegExprTooBigReferenceNumber','Too big reference number');
  Corp_Const_String.AddIfNotExist('scxRegExprCantCreateEmptyEnum','Can''t create empty enumeration');
  Corp_Const_String.AddIfNotExist('scxRegExprSubrangeOrder','The starting character of the subrange must be less than the finishing one');
  Corp_Const_String.AddIfNotExist('scxRegExprHexNumberExpected0','Hexadecimal number expected');
  Corp_Const_String.AddIfNotExist('scxRegExprHexNumberExpected','Hexadecimal number expected but ''%s'' found');
  Corp_Const_String.AddIfNotExist('scxRegExprMissing','Missing ''%s''');
  Corp_Const_String.AddIfNotExist('scxRegExprUnnecessary','Unnecessary ''%s''');
  Corp_Const_String.AddIfNotExist('scxRegExprIncorrectSpace','The space character is not allowed after ''\''');
  Corp_Const_String.AddIfNotExist('scxRegExprNotCompiled','Regular expression is not compiled');
  Corp_Const_String.AddIfNotExist('scxRegExprIncorrectParameterQuantifier','Incorrect parameter quantifier');
  Corp_Const_String.AddIfNotExist('scxRegExprCantUseParameterQuantifier','The parameter quantifier cannot be applied here');

  Corp_Const_String.AddIfNotExist('scxMaskEditRegExprError','Regular expression errors:');
  Corp_Const_String.AddIfNotExist('scxMaskEditInvalidEditValue','The edit value is invalid');
  Corp_Const_String.AddIfNotExist('scxMaskEditNoMask','None');
  Corp_Const_String.AddIfNotExist('scxMaskEditIllegalFileFormat','Illegal file format');
  Corp_Const_String.AddIfNotExist('scxMaskEditEmptyMaskCollectionFile','The mask collection file is empty');
  Corp_Const_String.AddIfNotExist('scxMaskEditMaskCollectionFiles','Mask collection files');
  Corp_Const_String.AddIfNotExist('cxSSpinEditInvalidNumericValue','Invalid numeric value');


  // cxExtEditConsts.Pas
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryColorComboBoxItem','ColorComboBox |Represents a editor with color functionality');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryFontNameComboBoxItem','FontNameComboBox |Represents a editor with font functionality');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryLabelItem','Label|Represents a Label');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryProgressBarItem','ProgressBar|Represents a ProgressBar');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryTrackBarItem','TrackBar|Represents a TrackBar');
  Corp_Const_String.AddIfNotExist('scxSEditRepositorySpinButtonItem','SpinButton|Represents a SpinButton');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCheckComboBox','CheckComboBox|Represents a CheckComboBox');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryShellComboBoxItem','ShellComboBox|Represents a combo box with a dropdown shell tree view');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryCheckGroupItem','CheckGroup|Represents a group of check boxes');
  Corp_Const_String.AddIfNotExist('scxUDAssociated','%s is already associated with %s');
  Corp_Const_String.AddIfNotExist('scxHotZoneStyleMediaPlayer9','MediaPlayer9');
  Corp_Const_String.AddIfNotExist('scxHotZoneStyleMediaPlayer8','MediaPlayer8');
  Corp_Const_String.AddIfNotExist('scxHotZoneStyleXPTaskBar','XPTaskBar');
  Corp_Const_String.AddIfNotExist('scxHotZoneStyleSimple','Simple');

{  cxSEditCheckGroupCaptionStateDelimiter = ': ';
  cxSEditCheckGroupExportColumnSeparator = '  ';
  cxSEditCheckGroupFilterColumnSeparator = '; '; }
  Corp_Const_String.AddIfNotExist('cxSEditCheckGroupChecked','Checked');
  Corp_Const_String.AddIfNotExist('cxSEditCheckGroupGrayed','Grayed');
  Corp_Const_String.AddIfNotExist('cxSEditCheckGroupUnchecked','Unchecked');

  Corp_Const_String.AddIfNotExist('cxSCheckComboBoxStates0PropertyDlgCaption','cxCheckComboBox - CheckStates editor');
  Corp_Const_String.AddIfNotExist('cxSCheckGroupStates0PropertyDlgCaption','cxCheckGroup - CheckStates editor');

  Corp_Const_String.AddIfNotExist('cxSEditRichEditLibraryError','Cannot load a RichEdit library');
  Corp_Const_String.AddIfNotExist('cxSEditRichEditLineInsertionError','RichEdit line insertion error');
  Corp_Const_String.AddIfNotExist('cxSEditRichEditLoadFail','Failed to Load Stream');
  Corp_Const_String.AddIfNotExist('cxSEditRichEditSaveFail','Failed to Save Stream');
  Corp_Const_String.AddIfNotExist('scxSEditRepositoryRichEditItem','RichEdit|RichEdit control');


  // cxFilterConsts
  // base operators
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorEqual','equals');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNotEqual','does not equal');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLess','is less than');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLessEqual','is less than or equal to');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorGreater','is greater than');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorGreaterEqual','is greater than or equal to');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLike','like');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNotLike','not like');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorBetween','between');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNotBetween','not between');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorInList','in');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNotInList','not in');

  Corp_Const_String.AddIfNotExist('cxSFilterOperatorYesterday','is yesterday');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorToday','is today');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorTomorrow','is tomorrow');

  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLastWeek','is last week');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLastMonth','is last month');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorLastYear','is last year');

  Corp_Const_String.AddIfNotExist('cxSFilterOperatorThisWeek','is this week');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorThisMonth','is this month');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorThisYear','is this year');

  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNextWeek','is next week');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNextMonth','is next month');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorNextYear','is next year');

  Corp_Const_String.AddIfNotExist('cxSFilterAndCaption','and');
  Corp_Const_String.AddIfNotExist('cxSFilterOrCaption','or');
  Corp_Const_String.AddIfNotExist('cxSFilterNotCaption','not');
  Corp_Const_String.AddIfNotExist('cxSFilterBlankCaption','blank');

  // derived
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorIsNull','is blank');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorIsNotNull','is not blank');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorBeginsWith','begins with');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorDoesNotBeginWith','does not begin with');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorEndsWith','ends with');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorDoesNotEndWith','does not end with');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorContains','contains');
  Corp_Const_String.AddIfNotExist('cxSFilterOperatorDoesNotContain','does not contain');
  // filter listbox's values
  Corp_Const_String.AddIfNotExist('cxSFilterBoxAllCaption','(All)');
  Corp_Const_String.AddIfNotExist('cxSFilterBoxCustomCaption','(Custom...)');
  Corp_Const_String.AddIfNotExist('cxSFilterBoxBlanksCaption','(Blanks)');
  Corp_Const_String.AddIfNotExist('cxSFilterBoxNonBlanksCaption','(NonBlanks)');


  // cxFilterControlStrs.pas
  // cxFilterBoolOperator
  Corp_Const_String.AddIfNotExist('cxSFilterBoolOperatorAnd','AND');        // all
  Corp_Const_String.AddIfNotExist('cxSFilterBoolOperatorOr','OR');          // any
  Corp_Const_String.AddIfNotExist('cxSFilterBoolOperatorNotAnd','NOT AND'); // not all
  Corp_Const_String.AddIfNotExist('cxSFilterBoolOperatorNotOr','NOT OR');   // not any
  //
  Corp_Const_String.AddIfNotExist('cxSFilterRootButtonCaption','Filter');
  Corp_Const_String.AddIfNotExist('cxSFilterAddCondition','Add &Condition');
  Corp_Const_String.AddIfNotExist('cxSFilterAddGroup','Add &Group');
  Corp_Const_String.AddIfNotExist('cxSFilterRemoveRow','&Remove Row');
  Corp_Const_String.AddIfNotExist('cxSFilterClearAll','Clear &All');
  Corp_Const_String.AddIfNotExist('cxSFilterFooterAddCondition','press the button to add a new condition');

  Corp_Const_String.AddIfNotExist('cxSFilterGroupCaption','applies to the following conditions');
  Corp_Const_String.AddIfNotExist('cxSFilterRootGroupCaption','<root>');
  Corp_Const_String.AddIfNotExist('cxSFilterControlNullString','<empty>');

  Corp_Const_String.AddIfNotExist('cxSFilterErrorBuilding','Can''t build filter from source');

  //FilterDialog
  Corp_Const_String.AddIfNotExist('cxSFilterDialogCaption','Custom Filter');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogInvalidValue','Invalid value');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogUse','Use');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogSingleCharacter','to represent any single character');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogCharactersSeries','to represent any series of characters');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogOperationAnd','AND');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogOperationOr','OR');
  Corp_Const_String.AddIfNotExist('cxSFilterDialogRows','Show rows where:');

  // FilterControlDialog
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogCaption','Filter builder');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogNewFile','untitled.flt');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogOpenDialogCaption','Open an existing filter');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogSaveDialogCaption','Save the active filter to file');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionSaveCaption','&Save As...');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionOpenCaption','&Open...');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionApplyCaption','&Apply');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionOkCaption','OK');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogActionCancelCaption','Cancel');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogFileExt','flt');
  Corp_Const_String.AddIfNotExist('cxSFilterControlDialogFileFilter','Filters (*.flt)|*.flt');


  //****** cxGridStrs
  Corp_Const_String.AddIfNotExist('scxGridRecursiveLevels','You cannot create recursive levels');

  Corp_Const_String.AddIfNotExist('scxGridDeletingConfirmationCaption','Confirm');
  Corp_Const_String.AddIfNotExist('scxGridDeletingFocusedConfirmationText','Delete record?');
  Corp_Const_String.AddIfNotExist('scxGridDeletingSelectedConfirmationText','Delete all selected records?');

  Corp_Const_String.AddIfNotExist('scxGridNewItemRowInfoText','Click here to add a new row');

  Corp_Const_String.AddIfNotExist('scxGridFilterIsEmpty','<Filter is Empty>');

  Corp_Const_String.AddIfNotExist('scxGridCustomizationFormCaption','Customization');
  Corp_Const_String.AddIfNotExist('scxGridCustomizationFormColumnsPageCaption','Columns');
  Corp_Const_String.AddIfNotExist('scxGridGroupByBoxCaption','Drag a column header here to group by that column');
  Corp_Const_String.AddIfNotExist('scxGridFilterCustomizeButtonCaption','Customize...');

  Corp_Const_String.AddIfNotExist('scxGridCustomizationFormBandsPageCaption','Bands');

  Corp_Const_String.AddIfNotExist('scxGridConverterIntermediaryMissing','Missing an intermediary component!'#13#10'Please add a %s component to the form.');
  Corp_Const_String.AddIfNotExist('scxGridConverterNotExistGrid','cxGrid does not exist');
  Corp_Const_String.AddIfNotExist('scxGridConverterNotExistComponent','Component does not exist');
  Corp_Const_String.AddIfNotExist('scxImportErrorCaption','Import error');

  Corp_Const_String.AddIfNotExist('scxNotExistGridView','Grid view does not exist');
  Corp_Const_String.AddIfNotExist('scxNotExistGridLevel','Active grid level does not exist');
  Corp_Const_String.AddIfNotExist('scxCantCreateExportOutputFile','Can''t create the export output file');

  Corp_Const_String.AddIfNotExist('cxSEditRepositoryExtLookupComboBoxItem','ExtLookupComboBox|Represents an ultra-advanced lookup using the QuantumGrid as its drop down control');


  //************ cxLibraryStrs.Pas
  Corp_Const_String.AddIfNotExist('scxCantCreateRegistryKey','Can''t create the registry key: \%s');
  Corp_Const_String.AddIfNotExist('scxConverterCantCreateStyleRepository','Can''t create the Style Repository');


  //************ cxNavigator
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_First','First record');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Prior','Prior record');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_PriorPage','Prior page');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Next','Next record');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_NextPage','Next page');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Last','Last record');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Insert','Insert record');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Delete','Delete record');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Edit','Edit record');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Post','Post edit');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Cancel','Cancel edit');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Refresh','Refresh data');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_SaveBookmark','Save Bookmark');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_GotoBookmark','Goto Bookmark');
  Corp_Const_String.AddIfNotExist('cxNavigatorHint_Filter','Filter data');
  Corp_Const_String.AddIfNotExist('cxNavigator_DeleteRecordQuestion','Delete record?');





  //********** dxBarStrs
  dxSBAR_LOOKUPDIALOGCAPTION = 'Select value';
  dxSBAR_LOOKUPDIALOGOK = 'OK';
  dxSBAR_LOOKUPDIALOGCANCEL = 'Cancel';

  dxSBAR_DIALOGOK = 'OK';
  dxSBAR_DIALOGCANCEL = 'Cancel';
  dxSBAR_COLOR_STR_0 = 'Black';
  dxSBAR_COLOR_STR_1 = 'Maroon';
  dxSBAR_COLOR_STR_2 = 'Green';
  dxSBAR_COLOR_STR_3 = 'Olive';
  dxSBAR_COLOR_STR_4 = 'Navy';
  dxSBAR_COLOR_STR_5 = 'Purple';
  dxSBAR_COLOR_STR_6 = 'Teal';
  dxSBAR_COLOR_STR_7 = 'Gray';
  dxSBAR_COLOR_STR_8 = 'Silver';
  dxSBAR_COLOR_STR_9 = 'Red';
  dxSBAR_COLOR_STR_10 = 'Lime';
  dxSBAR_COLOR_STR_11 = 'Yellow';
  dxSBAR_COLOR_STR_12 = 'Blue';
  dxSBAR_COLOR_STR_13 = 'Fuchsia';
  dxSBAR_COLOR_STR_14 = 'Aqua';
  dxSBAR_COLOR_STR_15 = 'White';
  dxSBAR_COLORAUTOTEXT = '(automatic)';
  dxSBAR_COLORCUSTOMTEXT = '(custom)';
  dxSBAR_DATETODAY = 'Today';
  dxSBAR_DATECLEAR = 'Clear';
  dxSBAR_DATEDIALOGCAPTION = 'Select the date';
  dxSBAR_TREEVIEWDIALOGCAPTION = 'Select item';
  dxSBAR_IMAGEDIALOGCAPTION = 'Select item';
  dxSBAR_IMAGEINDEX = 'Image Index';
  dxSBAR_IMAGETEXT = 'Text';
  dxSBAR_PLACEFORCONTROL = 'The place for the ';
  dxSBAR_CANTASSIGNCONTROL = 'You cannot assign the same control to more than one TdxBarControlContainerItem.';

  dxSBAR_WANTTORESETTOOLBAR = 'Are you sure you want to reset the changes made to the ''%s'' toolbar?';
  dxSBAR_WANTTORESETUSAGEDATA = 'This will delete the record of the commands you''ve used in this application and restore the default set of visible commands to the menus and toolbars. It will not undo any explicit customizations.   Are you sure you want to proceed?';
  dxSBAR_BARMANAGERMORETHENONE  = 'A Form should contain only a single TdxBarManager';
  dxSBAR_BARMANAGERBADOWNER = 'TdxBarManager should have as its Owner - TForm (TCustomForm)';
  dxSBAR_NOBARMANAGERS = 'There are no TdxBarManagers available';
  dxSBAR_WANTTODELETETOOLBAR = 'Are you sure you want to delete the ''%s'' toolbar?';
  dxSBAR_WANTTODELETECATEGORY = 'Are you sure you want to delete the ''%s'' category?';
  dxSBAR_WANTTOCLEARCOMMANDS = 'Are you sure you want to delete all commands in the ''%s'' category?';
  dxSBAR_RECURSIVESUBITEMS = 'You cannot create recursive subitems';
  dxSBAR_COMMANDNAMECANNOTBEBLANK = 'A command name cannot be blank. Please enter a name.';
  dxSBAR_TOOLBAREXISTS = 'A toolbar named ''%s'' already exists. Type another name.';
  dxSBAR_RECURSIVEGROUPS = 'You cannot create recursive groups';

  dxSBAR_DEFAULTCATEGORYNAME = 'Default';

  dxSBAR_CP_ADDSUBITEM = 'Add &SubItem';
  dxSBAR_CP_ADDBUTTON = 'Add &Button';
  dxSBAR_CP_ADDITEM = 'Add &Item';
  dxSBAR_CP_DELETEBAR = 'Delete Bar';

  dxSBAR_CP_RESET = '&Reset';
  dxSBAR_CP_DELETE = '&Delete';
  dxSBAR_CP_NAME = '&Name:';
  dxSBAR_CP_CAPTION = '&Caption:'; // is the same as dxSBAR_CP_NAME (at design-time)
  dxSBAR_CP_DEFAULTSTYLE = 'Defa&ult style';
  dxSBAR_CP_TEXTONLYALWAYS = '&Text Only (Always)';
  dxSBAR_CP_TEXTONLYINMENUS = 'Text &Only (in Menus)';
  dxSBAR_CP_IMAGEANDTEXT = 'Image &and Text';
  dxSBAR_CP_BEGINAGROUP = 'Begin a &Group';
  dxSBAR_CP_VISIBLE = '&Visible';
  dxSBAR_CP_MOSTRECENTLYUSED = '&Most recently used';

  dxSBAR_ADDEX = 'Add...';
  dxSBAR_RENAMEEX = 'Rename...';
  dxSBAR_DELETE = 'Delete';
  dxSBAR_CLEAR = 'Clear';
  dxSBAR_VISIBLE = 'Visible';
  dxSBAR_OK = 'OK';
  dxSBAR_CANCEL = 'Cancel';
  dxSBAR_SUBMENUEDITOR = 'SubMenu Editor...';
  dxSBAR_SUBMENUEDITORCAPTION = 'ExpressBars SubMenu Editor';
  dxSBAR_INSERTEX = 'Insert...';

  dxSBAR_MOVEUP = 'Move Up';
  dxSBAR_MOVEDOWN = 'Move Down';
  dxSBAR_POPUPMENUEDITOR = 'PopupMenu Editor...';
  dxSBAR_TABSHEET1 = ' Toolbars ';
  dxSBAR_TABSHEET2 = ' Commands ';
  dxSBAR_TABSHEET3 = ' Options ';
  dxSBAR_TOOLBARS = 'Toolb&ars:';
  dxSBAR_TNEW = '&New...';
  dxSBAR_TRENAME = 'R&ename...';
  dxSBAR_TDELETE = '&Delete';
  dxSBAR_TRESET = '&Reset...';
  dxSBAR_CLOSE = 'Close';
  dxSBAR_CAPTION = 'Customize';
  dxSBAR_CATEGORIES = 'Cate&gories:';
  dxSBAR_COMMANDS = 'Comman&ds:';
  dxSBAR_DESCRIPTION = 'Description  ';

  dxSBAR_CUSTOMIZE = '&Customize...';
  dxSBAR_ADDREMOVEBUTTONS = '&Add or Remove Buttons';
  dxSBAR_MOREBUTTONS = 'More Buttons';
  dxSBAR_RESETTOOLBAR = '&Reset Toolbar';
  dxSBAR_EXPAND = 'Expand (Ctrl-Down)';
  dxSBAR_DRAGTOMAKEMENUFLOAT = 'Drag to make this menu float';

  dxSBAR_TOOLBARNEWNAME  = 'Custom ';
  dxSBAR_CATEGORYADD  = 'Add Category';
  dxSBAR_CATEGORYINSERT  = 'Insert Category';
  dxSBAR_CATEGORYRENAME  = 'Rename Category';
  dxSBAR_TOOLBARADD  = 'Add Toolbar';
  dxSBAR_TOOLBARRENAME  = 'Rename Toolbar';
  dxSBAR_CATEGORYNAME  = '&Category name:';
  dxSBAR_TOOLBARNAME  = '&Toolbar name:';
  dxSBAR_CUSTOMIZINGFORM = 'Customization Form...';

  dxSBAR_MODIFY = '... modify';
  dxSBAR_PERSMENUSANDTOOLBARS = 'Personalized Menus and Toolbars  ';
  dxSBAR_MENUSSHOWRECENTITEMS = 'Me&nus show recently used commands first';
  dxSBAR_SHOWFULLMENUSAFTERDELAY = 'Show f&ull menus after a short delay';
  dxSBAR_RESETUSAGEDATA = '&Reset my usage data';

  dxSBAR_OTHEROPTIONS = 'Other  ';
  dxSBAR_LARGEICONS = '&Large icons';
  dxSBAR_HINTOPT1 = 'Show Tool&Tips on toolbars';
  dxSBAR_HINTOPT2 = 'Show s&hortcut keys in ToolTips';
  dxSBAR_MENUANIMATIONS = '&Menu animations:';
  dxSBAR_MENUANIM1 = '(None)';
  dxSBAR_MENUANIM2 = 'Random';
  dxSBAR_MENUANIM3 = 'Unfold';
  dxSBAR_MENUANIM4 = 'Slide';
  dxSBAR_MENUANIM5 = 'Fade';


  //****************** dxDockConsts
  sdxInvalidLayoutSiteDeleting = 'You cannot delete a TdxLayoutDockSite.';
  sdxInvalidFloatSiteDeleting = 'You cannot delete a TdxFloatDockSite.';
  sdxInvalidFloatingDeleting = 'You cannot delete a TdxCustomDockSite in floating mode.';
  sdxInvalidParentAssigning = 'You cannot set the parent for this component.';
  sdxInvalidOwner = 'The Owner of the TdxCustomDockControl must be TCustomForm.';
  sdxInvalidParent = 'The Parent of the %s must be TdxCustomDockControl.';
  sdxInvalidDockSiteParent = 'The Parent of the TdxDockSite cannot be TdxCustomDockControl.';
  sdxInvalidFloatSiteParent = 'The Parent of the TdxFloatDockSite can only be TdxFloatForm.';
  sdxInvalidPanelChild = 'You cannot insert a TdxCustomDockControl into TdxDockPanel (%s is being inserted).';
  sdxInvalidSiteChild = 'You can only insert a TdxCustomDockControl into TdxCustomDockSite (%s is being inserted).';
  sdxInvaldZoneOwner = 'You cannot create a TdxZone without the owning TdxCustomDockControl.';
  sdxInternalErrorAutoHide = 'Internal error while autohide controls.';  
  sdxInternalErrorPainter = 'Internal error in the TdxCustomDockControl painter.';
  sdxInternalErrorLayout = 'Internal error in the %s object layout.';
  sdxInternalErrorCreateLayout = 'Internal error while creating a %s object layout.';
  sdxInternalErrorDestroyLayout = 'Internal error while destroying a %s object layout.';
  sdxManagerError = 'You cannot have more than one TdxDockingManager instance on a Form.';
  sdxAncestorError = 'Docking and auto hiding operations are not available for controls declared in an ancestor form.';



  //**************** dxExtCtrlsStrs
  sdxAutoColorText = 'Auto';
  sdxCustomColorText = 'Custom...';

  sdxSysColorScrollBar = 'ScrollBar';
  sdxSysColorBackground = 'Background';
  sdxSysColorActiveCaption = 'Active Caption';
  sdxSysColorInactiveCaption = 'Inactive Caption';
  sdxSysColorMenu = 'Menu';
  sdxSysColorWindow = 'Window';
  sdxSysColorWindowFrame = 'Window Frame';
  sdxSysColorMenuText = 'Menu Text';
  sdxSysColorWindowText = 'Window Text';
  sdxSysColorCaptionText = 'Caption Text';
  sdxSysColorActiveBorder = 'Active Border';
  sdxSysColorInactiveBorder = 'Inactive Border';
  sdxSysColorAppWorkSpace = 'App Workspace';
  sdxSysColorHighLight = 'Highlight';
  sdxSysColorHighLighText = 'Highlight Text';
  sdxSysColorBtnFace = 'Button Face';
  sdxSysColorBtnShadow = 'Button Shadow';
  sdxSysColorGrayText = 'Gray Text';
  sdxSysColorBtnText = 'Button Text';
  sdxSysColorInactiveCaptionText = 'Inactive Caption Text';
  sdxSysColorBtnHighligh = 'Button Highlight';
  sdxSysColor3DDkShadow = '3DDk Shadow';
  sdxSysColor3DLight = '3DLight';
  sdxSysColorInfoText = 'Info Text';
  sdxSysColorInfoBk = 'InfoBk';

  sdxPureColorBlack = 'Black';
  sdxPureColorRed = 'Red';
  sdxPureColorLime = 'Lime';
  sdxPureColorYellow = 'Yellow';
  sdxPureColorGreen = 'Green';
  sdxPureColorTeal = 'Teal';
  sdxPureColorAqua = 'Aqua';
  sdxPureColorBlue = 'Blue';
  sdxPureColorWhite = 'White';
  sdxPureColorOlive = 'Olive';
  sdxPureColorMoneyGreen = 'Money Green';
  sdxPureColorNavy = 'Navy';
  sdxPureColorSkyBlue = 'Sky Blue';
  sdxPureColorGray = 'Gray';
  sdxPureColorMedGray = 'Medium Gray';
  sdxPureColorSilver = 'Silver';
  sdxPureColorMaroon = 'Maroon';
  sdxPureColorPurple = 'Purple';
  sdxPureColorFuchsia = 'Fuchsia';
  sdxPureColorCream = 'Cream';

  sdxBrushStyleSolid = 'Solid';
  sdxBrushStyleClear = 'Clear';
  sdxBrushStyleHorizontal = 'Horizontal';
  sdxBrushStyleVertical = 'Vertical';
  sdxBrushStyleFDiagonal = 'FDiagonal';
  sdxBrushStyleBDiagonal = 'BDiagonal';
  sdxBrushStyleCross = 'Cross';
  sdxBrushStyleDiagCross = 'DiagCross';



  //*********** dxLayoutCommon
  dxLayoutNewGroupCaption = 'New Group';
  dxLayoutNewGroupDialogCaption = 'New Group';
  dxLayoutNewGroupDialogEditCaption = 'Enter a new group caption:';

  dxLayoutNewItemCaption = 'New Item';
  dxLayoutNewItemDialogCaption = 'New Item';
  dxLayoutNewItemDialogEditCaption = 'Enter a new item caption:';


  //********** dxLayoutCustomizeForm
  dxLayoutCustomizeFormCaption = 'Customize';
  dxLayoutCustomizeFormItemsCaption = 'Items';
  dxLayoutCustomizeFormGroupsCaption = 'Groups';
  dxLayoutCustomizeFormGroupsCreateCaption = 'Create...';
  dxLayoutCustomizeFormGroupsDeleteCaption = 'Delete';


  //************* dxLayoutEditForm
  dxLayoutEditFormOK = 'OK';
  dxLayoutEditFormCancel = 'Cancel';


  //************ dxNavBarConsts
  sdxInvalideGroupControl = 'Invalid the TdxNavBarGroupControl parent or group.';











==================================================================================


  //**************** cxPCConsts.Pas
  Corp_Const_String.AddIfNotExist('scxPCImageListIndexError','Index (%d) must be between 0 and %d');
  Corp_Const_String.AddIfNotExist('scxPCNoBaseImages','BaseImages is not assigned');
  Corp_Const_String.AddIfNotExist('scxPCNoRegisteredStyles','There are no styles registered');
  Corp_Const_String.AddIfNotExist('scxPCPageIndexError','%d is an invalid PageIndex value.  PageIndex must be ' +
    'between 0 and %d');
  Corp_Const_String.AddIfNotExist('scxPCPainterClassError','PCPainterClass is nil');
  Corp_Const_String.AddIfNotExist('scxPCStandardStyleError','%s is an unsupported standard style');
  Corp_Const_String.AddIfNotExist('scxPCStyleNameError','%s is an unregistered style name');
  Corp_Const_String.AddIfNotExist('scxPCTabCountEqualsZero','Tabs.Count = 0');
  Corp_Const_String.AddIfNotExist('scxPCTabIndexError','Tab''s index (%d) out of bounds');
  Corp_Const_String.AddIfNotExist('scxPCTabVisibleIndexOutsOfBounds','TabVisibleIndex (%d) must be between 0 and %d');
  Corp_Const_String.AddIfNotExist('scxPCVisibleTabListEmpty','There are no visible tabs');


  //***************** cxShellCommon.Pas
  Corp_Const_String.AddIfNotExist('SShellDefaultNameStr','Name');
  Corp_Const_String.AddIfNotExist('SShellDefaultSizeStr','Size');
  Corp_Const_String.AddIfNotExist('SShellDefaultTypeStr','Type');
  Corp_Const_String.AddIfNotExist('SShellDefaultModifiedStr','Modified');

  //***************** cxSSRes
  Corp_Const_String.AddIfNotExist('scxSheetName','Sheet');

  // categories constants
  Corp_Const_String.AddIfNotExist('scxSpreadSheet','SpreadSheet');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetDesc','SpreadSheet properties and/or events');

  // SpreadSheetBook errors
  Corp_Const_String.AddIfNotExist('scxSpreadSheetErrorReadSST','Reading SST record error');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetInvalidSheetNumber','Invalid page number');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetInvalidFileName','Invalid file %s name');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetInvalidFileFormat','Invalid %s file format');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetInvalidStreamFormat','Invalid stream format');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetInvalidSheetCaption','Sheet caption invalid or already exist');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetSheetPageExist','Page already exists');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetMergeCellError','Merge cell error, certain cells already merged');
  Corp_Const_String.AddIfNotExist('scxChangePartOfMergeCells','Cannot change part of merged cells');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetMergeCellError2','Some modify cells is merged');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetDefineNameError','Error define name, name already exist');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetDefineNameError2','Error define name, name contains extra characters');

  // sheet popup menu constants
  Corp_Const_String.AddIfNotExist('scxPopupMenuMergeCells','Merge cells');
  Corp_Const_String.AddIfNotExist('scxPopupMenuSplitCells','Split cells');
  Corp_Const_String.AddIfNotExist('scxPopupMenuFormatCells','Format cells');
  Corp_Const_String.AddIfNotExist('scxPopupMenuHideRows','Hide rows');
  Corp_Const_String.AddIfNotExist('scxPopupMenuUnhideRows','Unhide rows');
  Corp_Const_String.AddIfNotExist('scxPopupMenuHideCols','Hide column');
  Corp_Const_String.AddIfNotExist('scxPopupMenuUnhideCols','Unhide column');

  // insert and deliting cells constants
  Corp_Const_String.AddIfNotExist('scxSpreadSheetShiftCellLeft','Shift cells left');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetShiftCellTop','Shift cells top');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetShiftCellRight','Shift cells right');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetShiftCellBottom','Shift cells bottom');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetAllRow','Entire row');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetAllColumn','Entire column');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetDeleteCells','Delete');
  Corp_Const_String.AddIfNotExist('scxSpreadSheetInsertCells','Insert');

  // datastorage
  Corp_Const_String.AddIfNotExist('scxDataStorageErrorReadCellRecord','Error reading cell record');
  Corp_Const_String.AddIfNotExist('scxDataStorageErrorSetCellRecord','Error setting cell record');
  // style
  Corp_Const_String.AddIfNotExist('scxStyleInvalidColorIndex','Invalid color index');
  Corp_Const_String.AddIfNotExist('scxStyleInvalidCellStyle','Invalid cell style');

  // calculation error
  Corp_Const_String.AddIfNotExist('scxCaclulatorCyclingError','Calculation error. Formula cycled indexes present');
  Corp_Const_String.AddIfNotExist('scxCaclulatorConstructFormula','Error constructing formula. Parsed expression error offset at');
  Corp_Const_String.AddIfNotExist('scxCaclulatorParseFormula','Error parsing formula at string position');
  Corp_Const_String.AddIfNotExist('scxCaclulatorStringExpression','Error syntax in string expression');
  Corp_Const_String.AddIfNotExist('scxCaclulatorFuncInvalidIndex','Invalid function index');
  Corp_Const_String.AddIfNotExist('scxCaclulatorFuncInvalidName','Invalid function name');
  Corp_Const_String.AddIfNotExist('scxCaclulatorErrorSymbol','Error - symbol '')'' expected!');
  Corp_Const_String.AddIfNotExist('scxCaclulatorErrorString','Error - unterminated string!');
  Corp_Const_String.AddIfNotExist('scxCaclulatorUnknownExpression','Unknown string expression');
  Corp_Const_String.AddIfNotExist('scxCaclulatorUnknownToken','Unknown token in expression');
  Corp_Const_String.AddIfNotExist('scxCaclulatorDivByZero','Division by zero!');
  Corp_Const_String.AddIfNotExist('scxCaclulatorTypeErr','Incompatible operands type!');
  Corp_Const_String.AddIfNotExist('scxCaclulatorMissingTokens','Missing tokens');
  Corp_Const_String.AddIfNotExist('scxCaclulatorMissingParamters','Missing stack parameters');
  Corp_Const_String.AddIfNotExist('scxCaclulatorFuncNeedResult','Function need result');

  // error codes such as excel program
{  scxNullError    = '#NULL!';
  scxDivZeroError = '#DIV/0!';
  scxValueError   = '#VALUE!';
  scxNameError    = '#NAME!';
  scxNumError     = '#NUM!';
  scxRefError     = '#REF!';
  scxNAError      = '#N/A!';}

  // forms resources
  Corp_Const_String.AddIfNotExist('scxFormApply','Apply');
  Corp_Const_String.AddIfNotExist('scxFormCancel','Cancel');
  Corp_Const_String.AddIfNotExist('scxFormOk','Ok');

  // format form strings
  Corp_Const_String.AddIfNotExist('scxFormatDialogFormatCaption','Format cells');
  Corp_Const_String.AddIfNotExist('scxFormatCellStyle','Cell style');
  Corp_Const_String.AddIfNotExist('scxFormatCellStyleType','Style type');
  Corp_Const_String.AddIfNotExist('scxFormatStyleStyleSettings','Style settings');

  Corp_Const_String.AddIfNotExist('scxFormatStyleGeneral', '&General');
  Corp_Const_String.AddIfNotExist('scxFormatStyleCurrency', '&Currency');
  Corp_Const_String.AddIfNotExist('scxFormatStyleNumber', '&Number');
  Corp_Const_String.AddIfNotExist('scxFormatStyleDateTime', '&Date/Time');
  Corp_Const_String.AddIfNotExist('scxFormatStyleText', '&Text');

  Corp_Const_String.AddIfNotExist('scxGeneralStyleDescription', 'General format cells have no specific format.');
  Corp_Const_String.AddIfNotExist('scxNumberStyleDescription', 'Number is used for general display of numbers.');
  Corp_Const_String.AddIfNotExist('scxCurrencyStyleDescription', 'Currency formats are used for general monetary amounts.');
  Corp_Const_String.AddIfNotExist('scxDateTimeStyleDescription', 'Date/Time formats are used for date and time serial numbers as Date/Time values.');
  Corp_Const_String.AddIfNotExist('scxTextStyleDescription', 'Text formatted cells are treated as text even when a number is in the cell.  The cell is displayed exactly as entered.');


  Corp_Const_String.AddIfNotExist('scxFormatDialogText', '&Alignment');
  Corp_Const_String.AddIfNotExist('scxFormatDialogBorder', '&Border');
  Corp_Const_String.AddIfNotExist('scxFormatDialogPatterns', '&Patterns');
  Corp_Const_String.AddIfNotExist('scxFormatDialogHorzAlign', '&Horizontal');
  Corp_Const_String.AddIfNotExist('scxFormatDialogVertAlign', '&Vertical');
  Corp_Const_String.AddIfNotExist('scxFormatDialogTextAlignment', 'Text alignment');
  Corp_Const_String.AddIfNotExist('scxFormatDialogTextControl', 'Text control');
  Corp_Const_String.AddIfNotExist('scxFormatDialogGeneral', 'General');
  Corp_Const_String.AddIfNotExist('scxFormatDialogLeft', 'Left');
  Corp_Const_String.AddIfNotExist('scxFormatDialogCenter', 'Center');
  Corp_Const_String.AddIfNotExist('scxFormatDialogRight', 'Right');
  Corp_Const_String.AddIfNotExist('scxFormatDialogFill', 'Fill');
  Corp_Const_String.AddIfNotExist('scxFormatDialogJustify', 'Justify');
  Corp_Const_String.AddIfNotExist('scxFormatDialogTop', 'Top');
  Corp_Const_String.AddIfNotExist('scxFormatDialogBottom', 'Bottom');
  Corp_Const_String.AddIfNotExist('scxFormatDialogWrap', '&Word wrap');
  Corp_Const_String.AddIfNotExist('scxFormatDialogFont', '&Font');
  Corp_Const_String.AddIfNotExist('scxFormatDialogNone', '&None');
  Corp_Const_String.AddIfNotExist('scxFormatDialogNone2', 'None');
  Corp_Const_String.AddIfNotExist('scxFormatDialogOutline', '&Ou&tl&ine');
  Corp_Const_String.AddIfNotExist('scxFormatDialogInside', '&Inside');
  Corp_Const_String.AddIfNotExist('scxFormatDialogItems', 'Items');
  Corp_Const_String.AddIfNotExist('scxFormatDialogAllBorder', 'All borders');
  Corp_Const_String.AddIfNotExist('scxFormatDialogLine', 'Line');
  Corp_Const_String.AddIfNotExist('scxFormatDialogStyle', '&Style:');
  Corp_Const_String.AddIfNotExist('scxFormatDialogColor', '&Color:');
  Corp_Const_String.AddIfNotExist('scxFormatDialogTextStr', 'Text');
  Corp_Const_String.AddIfNotExist('scxFormatDialogCellShading', 'Cell shading');
  Corp_Const_String.AddIfNotExist('scxFormatDialogSample', 'Sample');
  Corp_Const_String.AddIfNotExist('scxFormatDialogPattern', '&Pattern:');
  Corp_Const_String.AddIfNotExist('scxFormatDialogSampleText', 'The quick brown fox jumps over the lazy dog');
  Corp_Const_String.AddIfNotExist('scxUseDefaultColor', 'Use default color');
  Corp_Const_String.AddIfNotExist('scxColorEditorCaption', 'Color property editor');

  // history constants
  Corp_Const_String.AddIfNotExist('scxChangeCellsStyle', 'Format cells');
  Corp_Const_String.AddIfNotExist('scxChangeCellsData', 'Change cells');
  Corp_Const_String.AddIfNotExist('scxChangeInsertCells', 'Insert cells');
  Corp_Const_String.AddIfNotExist('scxChangeDeleteCells', 'Delete cells');
  Corp_Const_String.AddIfNotExist('scxPasteCommand', 'Paste cells');
  Corp_Const_String.AddIfNotExist('scxCutCommand', 'Cut cells');
  Corp_Const_String.AddIfNotExist('scxMergeCells', 'Merge cells');
  Corp_Const_String.AddIfNotExist('scxSplitCells', 'Split cells');
  Corp_Const_String.AddIfNotExist('scxSortCellsAction', 'Sort cells');
  Corp_Const_String.AddIfNotExist('scxClearCells', 'Clear cells');
  Corp_Const_String.AddIfNotExist('scxClearAllAction', 'Clear all');

  // color box dialog strings
  scxColorBoxAutomatic = 'Automatic';
  scxColorBoxNone      = 'None';

  // import/export strings
  scxExcelImportUndefinedString = 'Undefined string in shared string table!';
  scxXLSFuncCustructErr = 'Formula not construct';
  scxXLSUnknownFunc     = 'Unknown function';
  scxXLSSharedFunc      = 'Shared';
  scxXLSNameRef         = 'Invalid name reference: ';

  scxWorkbookWrite = 'Error store workbook stream';
  scxWorkbookRead  = 'Error read workbook stream';


// function names definition
  sxlfAbs         = 'ABS';
  sxlfAcos        = 'ACOS';
  sxlfAcosh       = 'ACOSH';
  sxlfAnd         = 'AND';
  sxlfAsin        = 'ASIN';
  sxlfAsinh       = 'ASINH';
  sxlfAtan        = 'ATAN';
  sxlfAtan2       = 'ATAN2';
  sxlfAtanh       = 'ATANH';
  sxlfAverage     = 'AVERAGE';
  sxlfAverageA    = 'AVERAGEA';
  sxlfCos         = 'COS';
  sxlfCosh        = 'COSH';
  sxlfCount       = 'COUNT';
  sxlfCounta      = 'COUNTA';
  sxlfCountblank  = 'COUNTBLANK';
  sxlfCountif     = 'COUNTIF';
  sxlfDate        = 'DATE';
  sxlfDay         = 'DAY';
  sxlfDollar      = 'DOLLAR';
  sxlfExp         = 'EXP';
  sxlfFact        = 'FACT';
  sxlfInt         = 'INT';
  sxlfIF          = 'IF';
  sxlfLn          = 'LN';
  sxlfLog         = 'LOG';
  sxlfLog10       = 'LOG10';
  sxlfMax         = 'MAX';
  sxlfMin         = 'MIN';
  sxlfMod         = 'MOD';
  sxlfMonth       = 'MONTH';
  sxlfNot         = 'NOT';
  sxlfNow         = 'NOW';
  sxlfOdd         = 'ODD';
  sxlfOr          = 'OR';
  sxlfPi          = 'PI';
  sxlfPower       = 'POWER';
  sxlfRadians     = 'RADIANS';
  sxlfRand        = 'RAND';
  sxlfRound       = 'ROUND';
  sxlfRounddown   = 'ROUNDDOWN';
  sxlfRoundup     = 'ROUNDUP';
  sxlfSign        = 'SIGN';
  sxlfSin         = 'SIN';
  sxlfSinh        = 'SINH';
  sxlfSqrt        = 'SQRT';
  sxlfSum         = 'SUM';
  sxlfSumsq       = 'SUMSQ';
  sxlfTan         = 'TAN';
  sxlfTanh        = 'TANH';
  sxlfTime        = 'TIME';
  sxlfToday       = 'TODAY';
  sxlfTrunc       = 'TRUNC';
  sxlfYear        = 'YEAR';
  sxlfWeekDay     = 'WEEKDAY';
  sxlfFalse       = 'FALSE';
  sxlfTrue        = 'TRUE';

  sxlfEven        = 'EVEN';
  sxlfTrim        = 'TRIM';
  sxlfCeiling     = 'CEILING';
  sxlfFloor       = 'FLOOR';
  sxlfConcatenate = 'CONCATENATE';
  sxlfDegrees     = 'DEGREES';
  sxlfFixed       = 'FIXED';
  sxlfHour        = 'HOUR';
  sxlfMinute      = 'MINUTE';
  sxlfSecond      = 'SECOND';
  sxlfIsEven      = 'ISEVEN';
  sxlfIsOdd       = 'ISODD';
  sxlfIsBlank     = 'ISBLANK';
  sxlfIsNa        = 'ISNA';
  sxlfIsLogical   = 'ISLOGICAL';
  sxlfIsErr       = 'ISERR';
  sxlfIsError     = 'ISERROR';
  sxlfIsNonText   = 'ISNONTEXT';
  sxlfIsNumber    = 'ISNUMBER';
  sxlfIsText      = 'ISTEXT';
  sxlfLen         = 'LEN';
  sxlfLeft        = 'LEFT';
  sxlfRight       = 'RIGHT';
  sxlfMid         = 'MID';
  sxlfLower       = 'LOWER';
  sxlfUpper       = 'UPPER';



  //************ cxTLStrs
  scxIndexOutOfBounds    = 'Index %d out of bounds';
  scxInvalidStreamFormat = 'Invalid stream format';
  scxMultiSelectRequired = 'Multi select required';

  // designers constants

  scxDesignerCaption     = 'TreeListDesigner editing - ';
  scxBands               = 'Bands...';
  scxColumns             = 'Columns...';
  scxCreateAllItems      = 'Create all columns';
  scxDeleteAllItems      = 'Delete all columns';
  scxItems = 'Items editor...';

  // customizing box
  
  scxCustomizeCaption = 'Customize';
  scxColumnsCaption   = '   Columns   ';
  scxBandsCaption     = '    Bands    ';

  scxInvalidIntegerValue   = 'Invalid integer value';
  scxOperationNotSupported = 'Operation not supported';


  scxTreeListDeletingFocusedConfirmationText = 'Delete record(s)?';
  scxTreeListDeletingConfirmationCaption = 'Confirm';

  scxExportNotVisibleControl = 'Control must be visible for export';



  //*********** cxTLStyleSheetPreview
  cxTextDescription    = 'ABC';
  cxPreviewDescription = 'Check the preview style';


  //*********** cxWebDsgnStrs
  scxCantAddComponent = 'Controls cannot be added to a web module';
  scxCantCreateUniqueName = 'Can''t create unique name';
  scxError = 'Error';
  scxFileReadOnly = 'The edit buffer of "%s" is marked read-only.';
  scxInvalidPageName = 'Invalid Page name';
  scxInvalidValue = '"%s" is not a valid integer value.';
  scxScalingFactorError = 'Scaling factor must be between %d and %d.';
  scxValueMustBeInteger = 'Value must be valid integer number';
  scxValueNotInTheRange = 'Value not in the range %d - %d';

  scxWebModuleDesignerComponentsPage = 'Components';
  scxWebModuleDesignerHTMLPage = 'HTML';
  scxWebModuleDesignerPreviewPage = 'Preview';
  scxNoImage = '(No Image)';

  { menus }
  scxNone = '(None)';
  scxEdit = '&Edit';
  scxUndo = '&Undo';
  scxCut = 'Cu&t';
  scxCopy = '&Copy';
  scxPaste = '&Paste';
  scxDelete = '&Delete';
  scxSelectAll = 'Se&lect All';
  scxPosition = '&Position';
  scxAlignToGrid = 'Align to Grid';
  scxAlign = 'Align...';
  scxSize = 'Size...';
  scxScale = 'Scale...';
  scxTabOrder = 'TabOrder...';
  scxEnvironmentOptions = 'Environment Options...';

  { hint prefixes }
  scxHintOrigin = 'Origin';
  scxHintSize = 'Size';
  scxHintTabStop = 'TabStop';
  scxHintTabOrder = 'Order';

  { Web Design Form }

  scxWebDsgnFormButton = 'Form';
  scxWebDsgnResultButton = 'HTML Result';
  scxWebDsgnPreviewButton = 'Preview';

  { Designer Dialog Forms}
  scxWebDsgnButtonOKCaption = 'OK';
  scxWebDsgnButtonApplyCaption = '&Apply';
  scxWebDsgnButtonCancelCaption = 'Cancel';
  scxWebDsgnButtonHelpCaption = '&Help';

  { Alignment form}
  scxWebDsgnAlignFormCaption = 'Alignment';
  scxWebDsgnAlignHAlignCaption = ' Horizontal ';
  scxWebDsgnAlignHAlignItem1 = '&No Changes';
  scxWebDsgnAlignHAlignItem2 = '&Left sides';
  scxWebDsgnAlignHAlignItem3 = '&Centers';
  scxWebDsgnAlignHAlignItem4 = '&Right sides';
  scxWebDsgnAlignHAlignItem5 = '&Space equally';
  scxWebDsgnAlignHAlignItem6 = 'Center in &Window';
  scxWebDsgnAlignVAlignCaption = ' Vertical ';
  scxWebDsgnAlignVAlignItem1 = 'No Chan&ges';
  scxWebDsgnAlignVAlignItem2 = '&Tops';
  scxWebDsgnAlignVAlignItem3 = 'C&enters';
  scxWebDsgnAlignVAlignItem4 = '&Bottoms';
  scxWebDsgnAlignVAlignItem5 = 'Space e&qually';
  scxWebDsgnAlignVAlignItem6 = 'Center &in Window';

  { Scale form }
  scxWebDsgnScaleFormCaption = 'Scale';
  scxWebDsgnScaleLabelFactor = '&Scaling factor:';

  { Size form }
  scxWebDsgnSizeFormCaption = 'Size';
  scxWebDsgnSizeWidthCaption = ' Width ';
  scxWebDsgnSizeHeightCaption = ' Height ';
  scxWebDsgnAlignSizeItem1 = 'No &change';
  scxWebDsgnAlignSizeItem2 = 'Shrin&k to smallest';
  scxWebDsgnAlignSizeItem3 = 'Grow to &largest';
  scxWebDsgnAlignSizeItem4 = 'E&xactly (px):';

  { Tab order form}
  scxWebDsgnTabOrderFormCaption = 'Edit Tab Order';
  scxWebDsgnTabOrderLabelControlsListed = '&Controls listed in tab order:';

  { Wizards }
  scxWebDsgnWizardPropertiesCaption = 'Properties';
  scxWebDsgnWizardPageModulePropertiesCaption = 'Page Module Properties';
  scxWebDsgnWizardDataModulePropertiesCaption = 'Data Module Properties';
  scxWebDsgnWizardFramesetPropertiesCaption = 'Frameset Properties';
  scxWebDsgnWizardScriptCaption = '&Server Script:';
  scxWebDsgnWizardCachingCaption = '&Caching:';
  scxWebDsgnWizardonDemandCaption = 'On &Demand';
  scxWebDsgnWizardPageNameCaption = 'Page &Name:';
  scxWebDsgnWizardDesignerCaption = '&Designer';
  scxWebDsgnWizardPublishedCaption = '&Published';
  scxWebDsgnWizardTemplateCaption = 'Frameset Template';
  scxWebDsgnWizardFramesetCaption = 'Frameset:';
  scxWebDsgnWizardPreviewCaption = 'Preview:';
  scxWebDsgnWizardDescriptionCaption = 'Description:';

  { Data Module Wizard }
  scxWebDsgnDataModuleWizardCaption = 'New EWF Data Module';

  { Page Module Wizard }
  scxWebDsgnPageModuleWizardCaption = 'New EWF Page Module';

  { Frameset Wizard }
  scxWebDsgnFramesetWizardCaption = 'New EWF Frameset';

  { Project Module Wizard }
  scxWebDsgnProjectModuleWizardCaption = 'New EWF Application';
  scxWebDsgnProjectWizardServerTypeCaption = '&Server Type';
  scxWebDsgnProjectWizardClassNameCaption = {$IFDEF VCL}'Co' + {$ENDIF}'Class&Name';

  { Web Components designers }
  cxWebCompEditorAdd = '&Add';
  cxWebCompEditorDelete = '&Delete';
  cxWebCompEditorSelectAll = 'Select All';
  cxWebCompEditorMoveUp = 'Move &Up';
  cxWebCompEditorMoveDown = 'Move &Down';
  cxWebCompEditorButtonBar = '&Button Bar';
  cxWebCompEditorAddDefaultColumns = 'Add default columns';
  cxWebCompEditorRestoreDefaults = 'Restore Defaults';
  cxWebCompEditorNewItem = '&New Item';
  cxWebCompEditorNewSubItem = 'N&ew SubItem';
  cxWebCompEditorLevelUp = 'Level Up';
  cxWebCompEditorLevelDown = 'Level Down';
  cxWebCompEditorItemProperties = 'Item Properties';
  cxWebCompEditorItemName = 'N&ame:';
  cxWebCompEditorItemHint = '&Hint:';
  cxWebCompEditorItemHref = 'H&ref:';
  cxWebCompEditorItemTarget = '&Target:';
  cxWebCompEditorItemImageIndex = 'I&mage Index:';

  { Designer ToolBar strings }
  scxBarButtonHintFormat = 'Blok Format';
  scxBarButtonHintFontName = 'Font Name';
  scxBarButtonHintFontSize = 'Font Size';
  scxBarButtonHintBold = 'Bold';
  scxBarButtonHintItalic = 'Italic';
  scxBarButtonHintUnderline = 'Underline';
  scxBarButtonHintAlignLeft = 'Align Left';
  scxBarButtonHintAlignCenter = 'Center';
  scxBarButtonHintAlignRight = 'Align Right';
  scxBarButtonHintJustify = 'Justify';
  scxBarButtonHintAlignNone = 'No Align';
  scxBarButtonHintNumbering = 'Numbering';
  scxBarButtonHintBullets = 'Bullets';
  scxBarButtonHintOutdent = 'Decrease Indent';
  scxBarButtonHintIndent = 'Increase Indent';
  scxBarButtonHintSubscript = 'Subscript';
  scxBarButtonHintSuperscript = 'Superscript';
  scxBarButtonHintBGColor = 'Highlight Color';
  scxBarButtonHintForeColor = 'Font Color';
  scxBarButtonHintLink = 'Link';
  scxBarButtonHintUnlink = 'UnLink';
  scxBarButtonHintRemoveFmt = 'Remove Formatting';

  scxBarButtonHintInsTable = 'Insert Table';
  scxBarButtonHintInsRowA = 'Insert Row Above';
  scxBarButtonHintInsRowB = 'Insert Row Below';
  scxBarButtonHintInsColL = 'Insert Column to the Left';
  scxBarButtonHintInsColR = 'Insert Column to the Right';
  scxBarButtonHintInsCell = 'Insert Cell';
  scxBarButtonHintDelTable = 'Delete Table';
  scxBarButtonHintDelRow = 'Delete Rows';
  scxBarButtonHintDelCol = 'Delete Columns';
  scxBarButtonHintDelCells = 'Delete Cells';
  scxBarButtonHintMergeCells = 'Merge Cells';
  scxBarButtonHintSplitCell = 'Split Cell';
  scxBarButtonHintSelTable = 'Select Table';
  scxBarButtonHintSelRow = 'Select Row';
  scxBarButtonHintSelCol = 'Select Column';
  scxBarButtonHintSelCell = 'Select Cell';

  scxBarButtonHintNewWholeFrame = 'New Whole Frame';
  scxBarButtonHintNewLFrame = 'New Left Frame';
  scxBarButtonHintNewRFrame = 'New Right Frame';
  scxBarButtonHintNewTFrame = 'New Top Frame';
  scxBarButtonHintNewBFrame = 'New Bottom Frame';
  scxBarButtonHintDelFrame = 'Delete Frame';

  scxBarFormatComboNone = '(none)';
  scxBarFormatComboNormal = 'Normal';
  scxBarFormatComboFormat = 'Formatted';
  scxBarFormatComboAdress = 'Address';
  scxBarFormatComboH1 = 'Heading 1';
  scxBarFormatComboH2 = 'Heading 2';
  scxBarFormatComboH3 = 'Heading 3';
  scxBarFormatComboH4 = 'Heading 4';
  scxBarFormatComboH5 = 'Heading 5';
  scxBarFormatComboH6 = 'Heading 6';
  scxBarFormatComboNumList = 'Numbered List';
  scxBarFormatComboBulList = 'Bulleted List';
  scxBarFormatComboDirList = 'Directory List';
  scxBarFormatComboMenuList = 'Menu List';
  scxBarFormatComboDefTerm = 'Definition Term';
  scxBarFormatComboDef = 'Definition';
  scxBarFormatComboPara = 'Paragraph';

  scxBarFontSizeComboNormal = 'Normal';

  scxBarColorHintDef = 'default';

  scxBarFontComboDef = 'default font';

  scxBarStdColors = 'Standard Colors';
  scxBarWebColors = 'Web Palette';
  scxBarSystemColors = 'System Colors';
  scxBarCustomColor = 'Custom Color';

  { HTML Editor command IDs}
  scxCmdUndo = 'Undo';
  scxCmdRedo = 'Redo';
  scxCmdCantUndo = 'Can''t Undo';
  scxCmdCantRedo = 'Can''t Redo';
  scxCmdResize = 'Resize';
  scxCmdMove = 'Move';
  scxCmdInsert = 'Insert';
  scxCmdDelete = 'Delete';
  scxCmdTableInsert = 'Table Insert';
  scxCmdTableDelete = 'Table Delete';
  scxCmdRowInsert = 'Row Insert';
  scxCmdRowDelete = 'Rows Delete';
  scxCmdColInsert = 'Column Insert';
  scxCmdColDelete = 'Columns Delete';
  scxCmdCellInsert = 'Cell Insert';
  scxCmdCellSplit = 'Cell Split';
  scxCmdCellMerge = 'Cells Merge';
  scxCmdCellDelete = 'Cells Delete';
  scxCmdFrameInsert = 'Frame Insert';
  scxCmdFrameDelete = 'Frame Delete';

  scxCmdAlign = 'Align';

  { Frameset templates strings}
  scxTemplate1Name = 'Banner and content';
  scxTemplate1Description = 'Creates a banner frame at the top, with a contents and main frame. Hyperlinks in the banner change the contents frame.';
  scxTemplate1Template = '<html>' + #13#10 +
      '  <head>' + #13#10 +
      '    <title></title>' + #13#10 +
      '  </head>' + #13#10 +
      '  <frameset rows="64,*">' + #13#10 +
      '  <frame name="banner" src="" scrolling="no" noresize>' + #13#10 +
      '    <frameset cols="150,*">' + #13#10 +
      '      <frame name="contents" src="">' + #13#10 +
      '      <frame name="main" src="">' + #13#10 +
      '    </frameset>' + #13#10 +
      '    <noframes>' + #13#10 +
      '      <p>' + #13#10 +
      '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
      '        Web browser that supports HTML 4.0 and later.' + #13#10 +
      '      </p>' + #13#10 +
      '    </noframes>' + #13#10 +
      '  </frameset>' + #13#10 +
      '</html>';
  scxTemplate2Name = 'Contents';
  scxTemplate2Description = 'Creates a contents frame on the left containing hyperlinks that change the page shown on the right.';
  scxTemplate2Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset cols="150,*">' + #13#10 +
  '    <frame name="contents" src="">' + #13#10 +
  '    <frame name="main" src="">' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';
  scxTemplate3Name = 'Footer';
  scxTemplate3Description = 'Creates a main frame with a footer underneath it. Hyperlinks in the footer change the main frame.';
  scxTemplate3Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '    <frameset rows="*,64">' + #13#10 +
  '      <frame name="main" src="">' + #13#10 +
  '      <frame name="footer" src="" scrolling="no" noresize>' + #13#10 +
  '      <noframes>' + #13#10 +
  '        <p>' + #13#10 +
  '          This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '          Web browser that supports HTML 4.0 and later.' + #13#10 +
  '        </p>' + #13#10 +
  '      </noframes>' + #13#10 +
  '    </frameset>' + #13#10 +
  '</html>';
  scxTemplate4Name = 'Footnotes';
  scxTemplate4Description = 'Creates a main frame with a footnotes underneath it. Hyperlinks in the main frame change the footnotes.';
  scxTemplate4Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset rows="*,20%">' + #13#10 +
  '    <frame name="main" src="">' + #13#10 +
  '    <frame name="footnotes" src="">' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';
  scxTemplate5Name = 'Header';
  scxTemplate5Description = 'Creates a navigation header and a main frame underneath it. Hyperlinks in the header change the main frame.';
  scxTemplate5Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset rows="64,*">' + #13#10 +
  '    <frame name="header" src="" scrolling="no" noresize>' + #13#10 +
  '    <frame name="main" src="">' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';
  scxTemplate6Name = 'Header, Footer and Contents';
  scxTemplate6Description = 'Creates header and footer frames for navigation. Hyperlinks in the header and footer change the contents frame.';
  scxTemplate6Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset rows="64,*,64">' + #13#10 +
  '    <frame name="header" src="" scrolling="no" noresize>' + #13#10 +
  '    <frameset cols="150,*">' + #13#10 +
  '      <frame name="contents" src="">' + #13#10 +
  '      <frame name="main" src="">' + #13#10 +
  '    </frameset>' + #13#10 +
  '    <frame name="footer" src="" scrolling="no" noresize>' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';
  scxTemplate7Name = 'Horizontal Split';
  scxTemplate7Description = 'Creates independent top and bottom frames.';
  scxTemplate7Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset rows="*,*">' + #13#10 +
  '    <frame name="top" src="">' + #13#10 +
  '    <frame name="bottom" src="">' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';
  scxTemplate8Name = 'Nested Hierarchy';
  scxTemplate8Description = 'Creates a nested information hierarchy. General hyperlinks on the left change the more specific on the right top.';
  scxTemplate8Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset cols="150,*">' + #13#10 +
  '    <frame name="left" src="" scrolling="no" noresize>' + #13#10 +
  '    <frameset rows="20%,*">' + #13#10 +
  '      <frame name="rtop" src="">' + #13#10 +
  '      <frame name="rbottom" src="">' + #13#10 +
  '    </frameset>' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';
  scxTemplate9Name = 'Top-Down Hierarchy';
  scxTemplate9Description = 'Creates a top-down information hierarchy. General hyperlinks at the top change the more specific middle frame.';
  scxTemplate9Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset rows="64,25%,*">' + #13#10 +
  '    <frame name="top" src="" scrolling="no" noresize>' + #13#10 +
  '    <frame name="middle" src="">' + #13#10 +
  '    <frame name="bottom" src="">' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';
  scxTemplate10Name = 'Vertical Split';
  scxTemplate10Description = 'Creates independent right and left frames.';
  scxTemplate10Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset cols="*,*">' + #13#10 +
  '    <frame name="left" src="">' + #13#10 +
  '    <frame name="right" src="">' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';
  scxTemplate11Name = 'Whole Frame';
  scxTemplate11Description = 'Creates a single main frame.';
  scxTemplate11Template = '<html>' + #13#10 +
  '  <head>' + #13#10 +
  '    <title></title>' + #13#10 +
  '  </head>' + #13#10 +
  '  <frameset cols="*">' + #13#10 +
  '    <frame name="main" src="">' + #13#10 +
  '    <noframes>' + #13#10 +
  '      <p>' + #13#10 +
  '        This HTML frameset displays multiple Web pages. To view this frameset, use a' + #13#10 +
  '        Web browser that supports HTML 4.0 and later.' + #13#10 +
  '      </p>' + #13#10 +
  '    </noframes>' + #13#10 +
  '  </frameset>' + #13#10 +
  '</html>';



  //*********** cxWebPasScriptStrs
  scxPascalCompileError = 'Innerfuse Pascal Script compilation error';
  scxPascalRunError = 'Innerfuse Pascal Script runtime error';

  scxPascalHTMLtemplate =  '<%unit Main;'#13#10 +
                           'begin%>'#13#10 +
                           '<html>'#13#10 +
                           '  <head>'#13#10 +
                           '    <title><%=Context.Page.Title%></title>'#13#10 +
                           '  </head>'#13#10 +
                           '  <body>'#13#10 +
                           '    <ewf:Form id="<%=Form.Name%>">'#13#10 +
                           '    </ewf:Form>'#13#10 +
                           '  </body>'#13#10 +
                           '</html>'#13#10 +
                           '<%end.%>'#13#10;



  //************** cxWebStrs
  scxWebNoPage = 'Application does not have the default page';
  scxWebPageNotFound = 'Web Page not found: %s';
  scxWebPageContentIsEmpty = 'Web Page %s does not have content';
  scxResourceNotFound = 'Resource %s not found';
  scxWebSessionsLimitExceeded = 'Sessions limit is exceeded';
  scxWebCannotChangePositioningType = 'The designer doesn''t support this positioning type';
  scxWebDuplicateName = 'Component name "%s" is duplicated';
  scxControlParentSetToSelf = 'A control cannot have itself as its parent';
  // Script errors
  scxDuplicateScriptEngineID = 'The server-side script engine with ID ''%d'' is already registered.';
  scxDuplicateScriptEngineName = 'The ''%s'' name is already used.';
  scxCannotCreateScriptEngine = 'Cannot create script engine: %s.'#13#10'Error code: %x';
  scxDuplicateItem = 'An item named %s already exists';
  scxItemNameIsBlank = 'Item name cannot be blank';
  scxObjectFactoryNotFound = 'Object factory for class %s missing';
  scxScriptClassNotFound = 'Wrapper for class %s missing';
  scxScriptErrorHTML = '<table border="0">'#13#10 +
                       '  <tr>'#13#10 +
                       '    <td colspan="3"><b>Error[%0:u]: <font size=+2>%1:s</font></b></td>'#13#10 +
                       '  </tr>'#13#10 +
                       '  <tr>'#13#10 +
                       '    <td width="5%%"></td>'#13#10 +
                       '    <td width="20%%"><b>Code:</b></td>'#13#10 +
                       '    <td>#%2:x</td>'#13#10 +
                       '  </tr>'#13#10 +
                       '  <tr>'#13#10 +
                       '    <td></td>'#13#10 +
                       '    <td><b>Description:</b></td>'#13#10 +
                       '    <td>%3:s</td>'#13#10 +
                       '  </tr>'#13#10 +
                       '  <tr>'#13#10 +
                       '    <td></td>'#13#10 +
                       '    <td><b>Source name:</b></td>'#13#10 +
                       '    <td>%4:s</td>'#13#10 +
                       '  </tr>'#13#10 +
                       '  <tr>'#13#10 +
                       '    <td></td>'#13#10 +
                       '    <td><b>Source line:</b></td>'#13#10 +
                       '    <td>%5:u</td>'#13#10 +
                       '  </tr>'#13#10 +
                       '  <tr>'#13#10 +
                       '    <td></td>'#13#10 +
                       '    <td><b>Position:</b></td>'#13#10 +
                       '    <td>%6:u</td>'#13#10 +
                       '  </tr>'#13#10 +
                       '  <tr>'#13#10 +
                       '    <td></td>'#13#10 +
                       '    <td colspan="2"><pre>%7:s<br><font color="#FF0000">%8:s</font></pre></td>'#13#10 +
                       '  </tr>'#13#10 +
                       '</table>'#13#10;
  // Script parser errors
  scxWebScriptParserError = 'Server-side script parser error';
  scxWebPreParsingError = 'Server-side script pre-parsing error';
  scxCantFindIncludePage = 'Cannot find included page: %s';
  scxCantFindIncludeFile = 'Cannot find included file: %s';
  scxInclusionNotSupported = 'Page %s does not support inclusion';
  scxRecursiveInclude = 'The %s %s recursively includes itself';
  scxUnsupportedIncludeType = 'Unsupported include type ''%s''';
  scxExpectedSymbol = 'Expected ''%s''';
  scxUnknownScriptEngine = 'Unknown server-side script engine name: ''%s''.';
  // HTML parser errors
  scxExpectedPropertyName = 'Expected property Name';
  scxInvalidPropertyName = 'Invalid property name';
  scxExpectedPropertyValue = 'Expected property value';
  scxExpectedClassname = 'Expected classname';
  scxExpectedClosingTag = 'Expected closing tag for %s';
  scxUnexpectedClosingTag = 'Unexpected closing tag for %s';
  scxTooManyForms = 'Too many forms';
  scxComponentOutOfForm = 'Component with name "%s" out of form';
  scxInvalidPropertyValue = 'The property value %s of the %s property is invalid';
  scxInvalidComponentClassName = 'The web classname in the tag: ewf:%s is invalid';
  scxIncorrectComponentClassName = 'The class name of the component: %s is not: %s';
  scxCannotAssignProperty = 'Cannot assign the property %s of the %s component.';
  scxInvalidComponentPropertyValue = 'The property %s of the %s component is invalid.';
  scxUnexpectedEWFTag = 'The EWF tag cannot be placed on this module.';
  // HTML builder errors
  scxUnableWriteAttribute = 'Unable write attribute';
  scxInvalidAttribute = 'Invalid attribute';
  scxInvalidStyleAttribute = 'Invalid style attribute';
  scxInvalidEventAttribute = 'Invalid event attribute';
  scxInvalidClosingTag = 'Invalid closing tag';
  scxUnsupportedTag = 'Tag %s doesn''t supported in this browser';
  // HTML Templates
  scxSmartRedirectHTML = '<html>'#13#10 +
                         '  <head>'#13#10 +
                         '    <title>Document Moved 301</title>'#13#10 +
                         '    <meta http-equiv="Refresh" content="0; url=%0:s">'#13#10 +
                         '    <script language="Javascript" type="text/javascript">'#13#10 +
                         '      location.href="%0:s"'#13#10 +
                         '    </script>'#13#10 +
                         '  </head>'#13#10 +
                         '  <body>'#13#10 +
                         '    <h1>Object Moved</h1><hr>'#13#10 +
                         '    This Object may be found <a href="%0:s">here.</a>'#13#10 +
                         '  </body>'#13#10 +
                         '</html>'#13#10;
  scxPageTitleScript = '<%=Context.Page.Title%>';
  scxFormNameScript = '<%=Form.Name%>';
  scxDefaultHTMLTemplate = '<html>'#13#10 +
                           '  <head>'#13#10 +
                           '    <title>%0:s</title>'#13#10 +
                           '  </head>'#13#10 +
                           '  <body>'#13#10 +
                           '    <ewf:Form id="%1:s">'#13#10 +
                           '    </ewf:Form>'#13#10 +
                           '  </body>'#13#10 +
                           '</html>'#13#10;
  scxDebugHTMLFileName = 'htmlsource.ewf';
  // WebGrid strings
  scxNodeBtnHint = 'Row #';
  scxCancelBtnHint = 'Cancel edit';
  scxDeleteBtnHint = 'Delete record';
  scxInsertBtnHint = 'Insert record';
  scxPostBtnHint = 'Post edit';
  scxEmptyGroupPanelText = '&nbsp;Drag a column header here to group by that column&nbsp;';
  scxStatusBarText = 'Rows %d - %d From %d Visible';
  scxStatusBarEmptyGridText = 'Data not loaded to grid';
  // WebDataSources strings
  scxDeleteConfirmText = 'Delete record?';


  //******* dxBarDBNavStrs
  dxSBAR_DBNAVERROR1 = 'You already have an existing DBNavigator button with the same defined style';

  dxSBAR_CATEGORYNAME = 'DB Navigator';
  dxSBAR_DELETERECORD = 'Do you want to delete the current record?';

  dxSBAR_BTNCAPTION_FIRST = 'First';
  dxSBAR_BTNCAPTION_PRIOR = 'Prior';
  dxSBAR_BTNCAPTION_NEXT = 'Next';
  dxSBAR_BTNCAPTION_LAST = 'Last';
  dxSBAR_BTNCAPTION_INSERT = 'Insert';
  dxSBAR_BTNCAPTION_DELETE = 'Delete';
  dxSBAR_BTNCAPTION_EDIT = 'Edit';
  dxSBAR_BTNCAPTION_POST = 'Post';
  dxSBAR_BTNCAPTION_CANCEL = 'Cancel';
  dxSBAR_BTNCAPTION_REFRESH = 'Refresh';




  //************ dxPSRes
  sdxBtnOK = 'OK';
  sdxBtnOKAccelerated = '&OK';
  sdxBtnCancel = 'Cancel';
  sdxBtnClose = 'Close';
  sdxBtnApply = '&Apply';
  sdxBtnHelp = '&Help';
  sdxBtnFix = '&Fix';
  sdxBtnNew = '&New...';
  sdxBtnIgnore = '&Ignore';
  sdxBtnYes = '&Yes';
  sdxBtnNo = '&No';
  sdxBtnEdit = '&Edit...';
  sdxBtnReset = '&Reset';
  sdxBtnAdd = '&Add';
  sdxBtnAddComposition = 'Add &Composition';
  sdxBtnDefault = '&Default...';
  sdxBtnDelete = '&Delete...';
  sdxBtnDescription = '&Description...';  
  sdxBtnCopy = '&Copy...';
  sdxBtnYesToAll = 'Yes To &All';
  sdxBtnRestoreDefaults = '&Restore Defaults';
  sdxBtnRestoreOriginal = 'Restore &Original';
  sdxBtnTitleProperties = 'Title Properties...';
  sdxBtnProperties = 'P&roperties...';
  sdxBtnNetwork = 'Net&work...';
  sdxBtnBrowse = '&Browse...';
  sdxBtnPageSetup = 'Pa&ge Setup...';
  sdxBtnPrintPreview = 'Print Pre&view...';
  sdxBtnPreview = 'Pre&view...';
  sdxBtnPrint = 'Print...';
  sdxBtnOptions = '&Options...';
  sdxBtnStyleOptions = 'Style Options...';
  sdxBtnDefinePrintStyles = '&Define Styles...';
  sdxBtnPrintStyles = 'Print Styles';
  sdxBtnBackground = 'Background';
  sdxBtnShowToolBar = 'Show &ToolBar';
  sdxBtnDesign = 'D&esign...';
  sdxBtnMoveUp = 'Move &Up';
  sdxBtnMoveDown = 'Move Dow&n';  

  sdxBtnMoreColors = '&More Colors...';
  sdxBtnFillEffects = '&Fill Effects...';
  sdxBtnNoFill = '&No Fill';
  sdxBtnAutomatic = '&Automatic';
  sdxBtnNone = '&None';

  sdxBtnOtherTexture = 'Other Te&xture...';
  sdxBtnInvertColors = 'I&nvert Colors';
  sdxBtnSelectPicture = 'Se&lect Picture...';

  sdxEditReports = 'Edit Reports';
  sdxComposition = 'Composition';
  sdxReportTitleDlgCaption = 'Report Title';
  sdxMode = '&Mode:';
  sdxText = '&Text';
  sdxProperties = '&Properties';
  sdxAdjustOnScale = '&Adjust on Scale';
  sdxTitleModeNone = 'None';
  sdxTitleModeOnEveryTopPage = 'On Every Top Page';
  sdxTitleModeOnFirstPage = 'On First Page';

  sdxEditDescription = 'Edit Description';
  sdxRename = 'Rena&me';
  sdxSelectAll = '&Select All';
  
  sdxAddReport = 'Add Report';
  sdxAddAndDesignReport = 'Add and D&esign Report...';
  sdxNewCompositionCaption = 'New Composition';
  sdxName = '&Name:';
  sdxCaption = '&Caption:';
  sdxAvailableSources = '&Available Source(s)';
  sdxOnlyComponentsInActiveForm = 'Only Components in Active &Form';
  sdxOnlyComponentsWithoutLinks = 'Only Components &without Existing ReportLinks';
  sdxItemName = 'Name';
  sdxItemDescription = 'Description';
    
  sdxConfirmDeleteItem = 'Do you want to delete next items: %s ?';
  sdxAddItemsToComposition = 'Add Items to Composition';
  sdxHideAlreadyIncludedItems = 'Hide Already &Included Items';
  sdxAvailableItems = 'Available &Items';
  sdxItems = '&Items';
  sdxEnable = '&Enable';
  sdxOptions = 'Options';
  sdxShow = 'Show';
  sdxPaintItemsGraphics = '&Paint Item Graphics';
  sdxDescription = '&Description:';

  sdxNewReport = 'NewReport';

  sdxOnlySelected = 'Only &Selected';
  sdxExtendedSelect = '&Extended Select';
  sdxIncludeFixed = '&Include Fixed';

  sdxFonts = 'Fonts';
  sdxBtnFont = 'Fo&nt...';
  sdxBtnEvenFont = 'E&ven Font...';
  sdxBtnOddFont = 'Odd Fo&nt...';
  sdxBtnFixedFont = 'F&ixed Font...';
  sdxBtnGroupFont = 'Grou&p Font...';
  sdxBtnChangeFont = 'Change Fo&nt...';

  sdxFont = 'Font';
  sdxOddFont = 'Odd Font';
  sdxEvenFont = 'Even Font';
  sdxPreviewFont = 'Preview Font';
  sdxCaptionNodeFont = 'Level Caption Font';
  sdxGroupNodeFont = 'Group Node Font';
  sdxGroupFooterFont = 'Group Footer Font';
  sdxHeaderFont = 'Header Font';
  sdxFooterFont = 'Footer Font';
  sdxBandFont = 'Band Font';

  sdxTransparent = '&Transparent';
  sdxFixedTransparent = 'Fi&xed Transparent';
  sdxCaptionTransparent = 'Caption Transparent';
  sdxGroupTransparent = 'Group Transparent';

  sdxGraphicAsTextValue = '(GRAPHIC)';
  sdxColors = 'Colors';
  sdxColor = 'Co&lor:';
  sdxOddColor = 'Odd Co&lor:';
  sdxEvenColor = 'E&ven Color:';
  sdxPreviewColor = '&Preview Color:';
  sdxBandColor = '&Band Color:';
  sdxLevelCaptionColor = 'Le&vel Caption Color:';
  sdxHeaderColor = 'H&eader Color:';
  sdxGroupNodeColor = 'Group &Node Color:';
  sdxGroupFooterColor = '&Group Footer Color:';
  sdxFooterColor = 'Foo&ter Color:';
  sdxFixedColor = 'F&ixed Color:';
  sdxGroupColor = 'Grou&p Color:';
  sdxCaptionColor = 'Caption Color:';
  sdxGridLinesColor = 'Gri&d Line Color:';

  sdxBands = '&Bands';
  sdxLevelCaptions = 'Levels &Caption';
  sdxHeaders = 'H&eaders';
  sdxFooters = 'Foote&rs';
  sdxGroupFooters = '&Group Footers';
  sdxPreview = 'Previe&w';
  sdxPreviewLineCount = 'Preview Line Coun&t:';
  sdxAutoCalcPreviewLineCount = 'A&uto Calculate Preview Lines';

  sdxGrid = 'Grid Lines';
  sdxNodesGrid = 'Node Grid Lines';
  sdxGroupFooterGrid = 'GroupFooter Grid Lines';

  sdxStateImages = '&State Images';
  sdxImages = '&Images';

  sdxTextAlign = 'Text&Align';
  sdxTextAlignHorz = 'Hori&zontally';
  sdxTextAlignVert = '&Vertically';
  sdxTextAlignLeft = 'Left';
  sdxTextAlignCenter = 'Center';
  sdxTextAlignRight = 'Right';
  sdxTextAlignTop = 'Top';
  sdxTextAlignVCenter = 'Center';
  sdxTextAlignBottom = 'Bottom';
  sdxBorderLines = '&Border';
  sdxHorzLines = 'Hori&zontal Lines';
  sdxVertLines = '&Vertical Lines';
  sdxFixedHorzLines = 'Fi&xed Horizontal Lines';
  sdxFixedVertLines = 'Fixe&d Vertical Lines';
  sdxFlatCheckMarks = 'F&lat CheckMarks';
  sdxCheckMarksAsText = '&Display CheckMarks as Text';

  sdxRowAutoHeight = 'Ro&w AutoHeight';
  sdxEndEllipsis = '&EndEllipsis';

  sdxDrawBorder = '&Draw Border';
  sdxFullExpand = 'Full &Expand';
  sdxBorderColor = '&Border Color:';
  sdxAutoNodesExpand = 'A&uto Nodes Expand';
  sdxExpandLevel = 'Expand &Level:';
  sdxFixedRowOnEveryPage = 'Fixed Rows';

  sdxDrawMode = 'Draw &Mode:';
  sdxDrawModeStrict = 'Strict';
  sdxDrawModeOddEven = 'Odd/Even Rows Mode';
  sdxDrawModeChess = 'Chess Mode';
  sdxDrawModeBorrow = 'Borrow From Source';

  sdx3DEffects = '3D Effects';
  sdxUse3DEffects = 'Use &3D Effects';
  sdxSoft3D = 'Sof&t3D';

  sdxBehaviors = 'Behaviors';
  sdxMiscellaneous = 'Miscellaneous';
  sdxOnEveryPage = 'On Every Page';
  sdxNodeExpanding = 'Node Expanding';
  sdxSelection = 'Selection';
  sdxNodeAutoHeight = '&Node Auto Height';
  sdxTransparentGraphics = '&Transparent Graphics';
  sdxAutoWidth = 'Auto &Width';

  sdxDisplayGraphicsAsText = 'Display Graphic As &Text';
  sdxTransparentColumnGraphics = 'Transparent &Graphics';

  sdxBandsOnEveryPage = 'Bands';
  sdxHeadersOnEveryPage = 'Headers';
  sdxFootersOnEveryPage = 'Footers';
  sdxGraphics = '&Graphics';

  { Common messages }
  
  sdxOutOfResources = 'Out of Resources';
  sdxFileAlreadyExists = 'File "%s" Already Exists.';
  sdxConfirmOverWrite = 'File "%s" already exists. Overwrite ?';
  sdxInvalidFileName = 'Invalid File Name "%s"';
  sdxRequiredFileName = 'Enter file name.';
  sdxOutsideMarginsMessage =
    'One or more margins are set outside the printable area of the page.' + #13#10 +
    'Do you want to continue ?';
  sdxOutsideMarginsMessage2 =
    'One or more margins are set outside the printable area of the page.' + #13#10 +
    'Choose the Fix button to increase the appropriate margins.';
  sdxInvalidMarginsMessage =
    'One or more margins are set to the invalid values.' + #13#10 +
    'Choose the Fix button to correct this problem.' + #13#10 +
    'Choose the Restore button to restore original values.';
  sdxInvalidMargins = 'One or more margins has invalid values';
  sdxOutsideMargins = 'One or more margins are set outside the printable area of the page';
  sdxThereAreNowItemsForShow = 'There are no items in this view';

  { Color palette }
  
  sdxPageBackground = ' Page Background';
  sdxPenColor = 'Pen Color';
  sdxFontColor = 'Font Color';
  sdxBrushColor = 'Brush Color';
  sdxHighLight = 'HighLight';

  { Color names }
  
  sdxColorBlack = 'Black';
  sdxColorDarkRed = 'Dark Red';
  sdxColorRed = 'Red';
  sdxColorPink = 'Pink';
  sdxColorRose = 'Rose';
  sdxColorBrown = 'Brown';
  sdxColorOrange = 'Orange';
  sdxColorLightOrange = 'Light Orange';
  sdxColorGold = 'Gold';
  sdxColorTan = 'Tan';
  sdxColorOliveGreen = 'Olive Green';
  sdxColorDrakYellow = 'Dark Yellow';
  sdxColorLime = 'Lime';
  sdxColorYellow = 'Yellow';
  sdxColorLightYellow = 'Light Yellow';
  sdxColorDarkGreen = 'Dark Green';
  sdxColorGreen = 'Green';
  sdxColorSeaGreen = 'Sea Green';
  sdxColorBrighthGreen = 'Bright Green';
  sdxColorLightGreen = 'Light Green';
  sdxColorDarkTeal = 'Dark Teal';
  sdxColorTeal = 'Teal';
  sdxColorAqua = 'Aqua';
  sdxColorTurquoise = 'Turquoise';
  sdxColorLightTurquoise = 'Light Turquoise';
  sdxColorDarkBlue = 'Dark Blue';
  sdxColorBlue = 'Blue';
  sdxColorLightBlue = 'Light Blue';
  sdxColorSkyBlue = 'Sky Blue';
  sdxColorPaleBlue = 'Pale Blue';
  sdxColorIndigo = 'Indigo';
  sdxColorBlueGray = 'Blue Gray';
  sdxColorViolet = 'Violet';
  sdxColorPlum = 'Plum';
  sdxColorLavender = 'Lavender';
  sdxColorGray80 = 'Gray-80%';
  sdxColorGray50 = 'Gray-50%';
  sdxColorGray40 = 'Gray-40%';
  sdxColorGray25 = 'Gray-25%';
  sdxColorWhite = 'White';
 
  { FEF Dialog }
  
  sdxTexture = '&Texture';
  sdxPattern = '&Pattern';
  sdxPicture = 'P&icture';
  sdxForeground = '&Foreground';
  sdxBackground = '&Background';
  sdxSample = 'Sample:';

  sdxFEFCaption = 'Fill Effects';
  sdxPaintMode = 'Paint &Mode';
  sdxPaintModeCenter = 'Center';
  sdxPaintModeStretch = 'Stretch';
  sdxPaintModeTile = 'Tile';
  sdxPaintModeProportional = 'Proportional';

  { Pattern names }
  
  sdxPatternGray5 = '5%';
  sdxPatternGray10 = '10%';
  sdxPatternGray20 = '20%';
  sdxPatternGray25 = '25%';
  sdxPatternGray30 = '30%';
  sdxPatternGray40 = '40%';
  sdxPatternGray50 = '50%';
  sdxPatternGray60 = '60%';
  sdxPatternGray70 = '70%';
  sdxPatternGray75 = '75%';
  sdxPatternGray80 = '80%';
  sdxPatternGray90 = '90%';
  sdxPatternLightDownwardDiagonal = 'Light downward diagonal';
  sdxPatternLightUpwardDiagonal = 'Light upward diagonal';
  sdxPatternDarkDownwardDiagonal = 'Dark downward diagonal';
  sdxPatternDarkUpwardDiagonal = 'Dark upward diagonal';
  sdxPatternWideDownwardDiagonal = 'Wide downward diagonal';
  sdxPatternWideUpwardDiagonal = 'Wide upward diagonal';
  sdxPatternLightVertical = 'Light vertical';
  sdxPatternLightHorizontal = 'Light horizontal';
  sdxPatternNarrowVertical = 'Narrow vertical';
  sdxPatternNarrowHorizontal = 'Narrow horizontal';
  sdxPatternDarkVertical = 'Dark vertical';
  sdxPatternDarkHorizontal = 'Dark horizontal';
  sdxPatternDashedDownward = 'Dashed downward';
  sdxPatternDashedUpward = 'Dashed upward';
  sdxPatternDashedVertical = 'Dashed vertical';
  sdxPatternDashedHorizontal = 'Dashed horizontal';
  sdxPatternSmallConfetti = 'Small confetti';
  sdxPatternLargeConfetti = 'Large confetti';
  sdxPatternZigZag = 'Zig zag';
  sdxPatternWave = 'Wave';
  sdxPatternDiagonalBrick = 'Diagonal brick';
  sdxPatternHorizantalBrick = 'Horizontal brick';
  sdxPatternWeave = 'Weave';
  sdxPatternPlaid = 'Plaid';
  sdxPatternDivot = 'Divot';
  sdxPatternDottedGrid = 'Dottedgrid';
  sdxPatternDottedDiamond = 'Dotted diamond';
  sdxPatternShingle = 'Shingle';
  sdxPatternTrellis = 'Trellis';
  sdxPatternSphere = 'Sphere';
  sdxPatternSmallGrid = 'Small grid';
  sdxPatternLargeGrid = 'Large grid';
  sdxPatternSmallCheckedBoard = 'Small checked board';
  sdxPatternLargeCheckedBoard = 'Large checked board';
  sdxPatternOutlinedDiamond = 'Outlined diamond';
  sdxPatternSolidDiamond = 'Solid diamond';

  { Texture names }
  
  sdxTextureNewSprint = 'Newsprint';
  sdxTextureGreenMarble = 'Green marble';
  sdxTextureBlueTissuePaper = 'Blue tissue paper';
  sdxTexturePapyrus = 'Papyrus';
  sdxTextureWaterDroplets = 'Water droplets';
  sdxTextureCork = 'Cork';
  sdxTextureRecycledPaper = 'Recycled paper';
  sdxTextureWhiteMarble = 'White marble';
  sdxTexturePinkMarble = 'Pink marble';
  sdxTextureCanvas = 'Canvas';
  sdxTexturePaperBag = 'Paper bag';
  sdxTextureWalnut = 'Walnut';
  sdxTextureParchment = 'Parchment';
  sdxTextureBrownMarble = 'Brown marble';
  sdxTexturePurpleMesh = 'Purple mesh';
  sdxTextureDenim = 'Denim';
  sdxTextureFishFossil = 'Fish fossil';
  sdxTextureOak = 'Oak';
  sdxTextureStationary = 'Stationary';
  sdxTextureGranite = 'Granite';
  sdxTextureBouquet = 'Bouquet';
  sdxTextureWonenMat = 'Woven mat';
  sdxTextureSand = 'Sand';
  sdxTextureMediumWood = 'Medium wood';

  sdxFSPCaption = 'Picture Preview';
  sdxWidth = 'Width';
  sdxHeight = 'Height';

  { Brush Dialog }
  
  sdxBrushDlgCaption = 'Brush properties';
  sdxStyle = '&Style:';

  { Enter New File Name dialog }
  
  sdxENFNCaption = 'Choose New File Name';
  sdxEnterNewFileName = 'Enter New File Name';

  { Define styles dialog }
  
  sdxDefinePrintStylesCaption = 'Define Print Styles';
  sdxDefinePrintStylesTitle = 'Print &Styles';
  sdxDefinePrintStylesWarningDelete = 'Do you want to delete "%s" ?';
  sdxDefinePrintStylesWarningClear = 'Do you want to delete all not built-in styles ?';
  sdxClear = 'C&lear...';

  { Print device }
  
  sdxCustomSize = 'Custom Size';
  sdxDefaultTray = 'Default Tray';
  sdxInvalidPrintDevice = 'Printer selected is not valid';
  sdxNotPrinting = 'Printer is not currently printing';
  sdxPrinting = 'Printing in progress';
  sdxDeviceOnPort = '%s on %s';
  sdxPrinterIndexError = 'Printer index out of range';
  sdxNoDefaultPrintDevice = 'There is no default printer selected';

  { Edit AutoText Entries Dialog }
  
  sdxAutoTextDialogCaption = 'Edit AutoText Entries';
  sdxEnterAutoTextEntriesHere = ' Enter A&utoText Entries Here: ';

  { Print dialog }
  
  sdxPrintDialogCaption = 'Print';
  sdxPrintDialogPrinter = ' Printer ';
  sdxPrintDialogName = '&Name:';
  sdxPrintDialogStatus = 'Status:';
  sdxPrintDialogType = 'Type:';
  sdxPrintDialogWhere = 'Where:';
  sdxPrintDialogComment = 'Comment:';
  sdxPrintDialogPrintToFile = 'Print to &File';
  sdxPrintDialogPageRange = ' Page range ';
  sdxPrintDialogAll = '&All';
  sdxPrintDialogCurrentPage = 'Curr&ent Page';
  sdxPrintDialogSelection = '&Selection';
  sdxPrintDialogPages = '&Pages:';
  sdxPrintDialogRangeLegend = 'Enter page number and/or page ranges' + #10#13 +
    'separated by commas. For example: 1,3,5-12.';
  sdxPrintDialogCopies = ' Copies ';
  sdxPrintDialogNumberOfPages = 'N&umber of Pages:';
  sdxPrintDialogNumberOfCopies = 'Number of &Copies:';
  sdxPrintDialogCollateCopies = 'Colla&te Copies';
  sdxPrintDialogAllPages = 'All';
  sdxPrintDialogEvenPages = 'Even';
  sdxPrintDialogOddPages = 'Odd';
  sdxPrintDialogPrintStyles = ' Print St&yles ';

  { PrintToFile Dialog }
  
  sdxPrintDialogOpenDlgTitle = 'Choose File Name';
  sdxPrintDialogOpenDlgAllFiles = 'All Files';
  sdxPrintDialogOpenDlgPrinterFiles = 'Printer Files';
  sdxPrintDialogPageNumbersOutOfRange = 'Page numbers out of range (%d - %d)';
  sdxPrintDialogInvalidPageRanges = 'Invalid page ranges';
  sdxPrintDialogRequiredPageNumbers = 'Enter page numbers';
  sdxPrintDialogNoPrinters = 'No printers are installed. To install a printer, ' + 
    'point to Settings on the Windows Start menu, click Printers, and then double-click Add Printer. ' + 
    'Follow the instructions in the wizard.';
  sdxPrintDialogInPrintingState = 'Printer is currently printing.' + #10#13 +
    'Please wait.';

  { Printer State }
  
  sdxPrintDialogPSPaused = 'Paused';
  sdxPrintDialogPSPendingDeletion = 'Pending Deletion';
  sdxPrintDialogPSBusy = 'Busy';
  sdxPrintDialogPSDoorOpen = 'Door Open';
  sdxPrintDialogPSError = 'Error';
  sdxPrintDialogPSInitializing = 'Initializing';
  sdxPrintDialogPSIOActive = 'IO Active';
  sdxPrintDialogPSManualFeed = 'Manual Feed';
  sdxPrintDialogPSNoToner = 'No Toner';
  sdxPrintDialogPSNotAvailable = 'Not Available';
  sdxPrintDialogPSOFFLine = 'Offline';
  sdxPrintDialogPSOutOfMemory = 'Out of Memory';
  sdxPrintDialogPSOutBinFull = 'Output Bin Full';
  sdxPrintDialogPSPagePunt = 'Page Punt';
  sdxPrintDialogPSPaperJam = 'Paper Jam';
  sdxPrintDialogPSPaperOut = 'Paper Out';
  sdxPrintDialogPSPaperProblem = 'Paper Problem';
  sdxPrintDialogPSPrinting = 'Printing';
  sdxPrintDialogPSProcessing = 'Processing';
  sdxPrintDialogPSTonerLow = 'Toner Low';
  sdxPrintDialogPSUserIntervention = 'User Intervention';
  sdxPrintDialogPSWaiting = 'Waiting';
  sdxPrintDialogPSWarningUp = 'Warming Up';
  sdxPrintDialogPSReady = 'Ready';
  sdxPrintDialogPSPrintingAndWaiting = 'Printing: %d document(s) waiting';

  sdxLeftMargin = 'Left Margin';
  sdxTopMargin = 'Top Margin';
  sdxRightMargin = 'Right Margin';
  sdxBottomMargin = 'Bottom Margin';
  sdxGutterMargin = 'Gutter';
  sdxHeaderMargin = 'Header';
  sdxFooterMargin = 'Footer';

  sdxUnitsInches = '"';
  sdxUnitsCentimeters = 'cm';
  sdxUnitsMillimeters = 'mm';
  sdxUnitsPoints = 'pt';
  sdxUnitsPicas = 'pi';

  sdxUnitsDefaultName = 'Default';
  sdxUnitsInchesName = 'Inches';
  sdxUnitsCentimetersName = 'Centimeters';
  sdxUnitsMillimetersName = 'Millimeters';
  sdxUnitsPointsName = 'Points';
  sdxUnitsPicasName = 'Picas';

  sdxPrintPreview = 'Print Preview';
  sdxReportDesignerCaption = 'Format Report';
  sdxCompositionDesignerCaption = 'Composition Editor';

  sdxComponentNotSupportedByLink = 'Component "%s" not supported by TdxComponentPrinter';
  sdxComponentNotSupported = 'Component "%s" not supported by TdxComponentPrinter';
  sdxPrintDeviceNotReady = 'Printer has not been installed or is not ready';
  sdxUnableToGenerateReport = 'Unable to generate report';
  sdxPreviewNotRegistered = 'There is no registered preview form';
  sdxComponentNotAssigned = '%s' + #13#10 + 'Not assigned "Component" property';
  sdxPrintDeviceIsBusy = 'Printer is busy';
  sdxPrintDeviceError = 'Printer has encountered error !';
  sdxMissingComponent = 'Missing "Component" property';
  sdxDataProviderDontPresent = 'There are no Links with Assigned Component in Composition';
  sdxBuildingReport = 'Building report: Completed %d%%';
  sdxPrintingReport = 'Printing report: Completed %d page(s). Press ESC to abort...';
  sdxDefinePrintStylesMenuItem = 'Define Print &Styles...';
  sdxAbortPrinting = 'Abort printing ?';
  sdxStandardStyle = 'Standard Style';

  sdxFontStyleBold = 'Bold';
  sdxFontStyleItalic = 'Italic';
  sdxFontStyleUnderline = 'Underline';
  sdxFontStyleStrikeOut = 'StrikeOut';
  sdxPt = 'pt.';

  sdxNoPages = 'There are no pages to display';
  sdxPageWidth = 'Page Width';
  sdxWholePage = 'Whole Page';
  sdxTwoPages = 'Two Pages';
  sdxFourPages = 'Four Pages';
  sdxWidenToSourceWidth = 'Widen to Source Width';

  sdxMenuBar = 'MenuBar';
  sdxStandardBar = 'Standard';
  sdxHeaderFooterBar = 'Header and Footer';
  sdxShortcutMenusBar = 'Shortcut Menus';
  sdxAutoTextBar = 'AutoText';

  sdxMenuFile = '&File';
  sdxMenuFileDesign = '&Design...';
  sdxMenuFilePrint = '&Print...';
  sdxMenuFilePageSetup = 'Page Set&up...';
  sdxMenuPrintStyles = 'Print Styles';
  sdxMenuFileExit = '&Close';

  sdxMenuEdit = '&Edit';
  sdxMenuEditCut = 'Cu&t';
  sdxMenuEditCopy = '&Copy';
  sdxMenuEditPaste = '&Paste';
  sdxMenuEditDelete = '&Delete';
  sdxMenuEditFind = '&Find...';
  sdxMenuEditFindNext = 'Find Ne&xt';
  sdxMenuEditReplace = '&Replace...';

  sdxMenuLoad = '&Load...';
  sdxMenuPreview = 'Pre&view...';

  sdxMenuInsert = '&Insert';
  sdxMenuInsertAutoText = '&AutoText';
  sdxMenuInsertEditAutoTextEntries = 'AutoTe&xt...';
  sdxMenuInsertAutoTextEntries = 'List of AutoText Entries';
  sdxMenuInsertAutoTextEntriesSubItem = 'In&sert AutoText';
  sdxMenuInsertPageNumber = '&Page Number';
  sdxMenuInsertTotalPages = '&Number of Pages';
  sdxMenuInsertPageOfPages = 'Pa&ge Number of Pages';
  sdxMenuInsertDateTime = 'Date and Time';
  sdxMenuInsertDate = '&Date';
  sdxMenuInsertTime = '&Time';
  sdxMenuInsertUserName = '&User Name';
  sdxMenuInsertMachineName = '&Machine Name';

  sdxMenuView = '&View';
  sdxMenuViewMargins = '&Margins';
  sdxMenuViewFlatToolBarButtons = '&Flat ToolBar Buttons';
  sdxMenuViewLargeToolBarButtons = '&Large ToolBar Buttons';
  sdxMenuViewMarginsStatusBar = 'M&argins Bar';
  sdxMenuViewPagesStatusBar = '&Status Bar';
  sdxMenuViewToolBars = '&Toolbars';
  sdxMenuViewPagesHeaders = 'Page &Headers';
  sdxMenuViewPagesFooters = 'Page Foote&rs';
  sdxMenuViewSwitchToLeftPart = 'Switch to Left Part';
  sdxMenuViewSwitchToRightPart = 'Switch to Right Part';
  sdxMenuViewSwitchToCenterPart = 'Switch to Center Part';
  sdxMenuViewHFSwitchHeaderFooter = '&Show Header/Footer';
  sdxMenuViewHFClose = '&Close';

  sdxMenuZoom = '&Zoom';
  sdxMenuZoomPercent100 = 'Percent &100';
  sdxMenuZoomPageWidth = 'Page &Width';
  sdxMenuZoomWholePage = 'W&hole Page';
  sdxMenuZoomTwoPages = '&Two Pages';
  sdxMenuZoomFourPages = '&Four Pages';
  sdxMenuZoomMultiplyPages = '&Multiple Pages';
  sdxMenuZoomWidenToSourceWidth = 'Widen To S&ource Width';
  sdxMenuZoomSetup = '&Setup...';

  sdxMenuPages = '&Pages';

  sdxMenuGotoPage = '&Go';
  sdxMenuGotoPageFirst = '&First Page';
  sdxMenuGotoPagePrev = '&Previous Page';
  sdxMenuGotoPageNext = '&Next Page';
  sdxMenuGotoPageLast = '&Last Page';
  sdxMenuActivePage = '&Active Page:';

  sdxMenuFormat = 'F&ormat';
  sdxMenuFormatHeaderAndFooter = '&Header and Footer';
  sdxMenuFormatAutoTextEntries = '&Auto Text Entries...';
  sdxMenuFormatDateTime = 'Date And &Time...';
  sdxMenuFormatPageNumbering = 'Page &Numbering...';
  sdxMenuFormatPageBackground = 'Bac&kground...';
  sdxMenuFormatShrinkToPage = '&Fit to Page';
  sdxMenuShowEmptyPages = 'Show &Empty Pages';
  sdxMenuFormatHFBackground = 'Header/Footer Background...';
  sdxMenuFormatHFClear = 'Clear Text';

  sdxMenuTools = '&Tools';
  sdxMenuToolsCustomize = '&Customize...';
  sdxMenuToolsOptions = '&Options...';

  sdxMenuHelp = '&Help';
  sdxMenuHelpTopics = 'Help &Topics...';
  sdxMenuHelpAbout = '&About...';

  sdxMenuShortcutPreview = 'Preview';
  sdxMenuShortcutAutoText = 'AutoText';

  sdxMenuBuiltInMenus = 'Built-in Menus';
  sdxMenuShortCutMenus = 'Shortcut Menus';
  sdxMenuNewMenu = 'New Menu';

  { Hints }
  
  sdxHintFileDesign = 'Design Report';
  sdxHintFilePrint = 'Print';
  sdxHintFilePrintDialog = 'Print Dialog';
  sdxHintFilePageSetup = 'Page Setup';
  sdxHintFileExit = 'Close Preview';

  sdxHintEditFind = 'Find';
  sdxHintEditFindNext = 'Find Next';
  sdxHintEditReplace = 'Replace';

  sdxHintInsertEditAutoTextEntries = 'Edit AutoText Entries';
  sdxHintInsertPageNumber = 'Insert Page Number';
  sdxHintInsertTotalPages = 'Insert Number of Pages';
  sdxHintInsertPageOfPages = 'Insert Page Number of Pages';
  sdxHintInsertDateTime = 'Insert Date and Time';
  sdxHintInsertDate = 'Insert Date';
  sdxHintInsertTime = 'Insert Time';
  sdxHintInsertUserName = 'Insert User Name';
  sdxHintInsertMachineName = 'Insert Machine Name';

  sdxHintViewMargins = 'View Margins';
  sdxHintViewLargeButtons = 'View Large Buttons';
  sdxHintViewMarginsStatusBar = 'View Margins Status Bar';
  sdxHintViewPagesStatusBar = 'View Page Status Bar';
  sdxHintViewPagesHeaders = 'View Page Header';
  sdxHintViewPagesFooters = 'View Page Footer';
  sdxHintViewSwitchToLeftPart = 'Switch to Left Header/Footer Part';
  sdxHintViewSwitchToRightPart = 'Switch to Right Header/Footer Part';
  sdxHintViewSwitchToCenterPart = 'Switch to Center Header/Footer Part';
  sdxHintViewHFSwitchHeaderFooter = 'Switch Between Header and Footer';
  sdxHintViewHFClose = 'Close';

  sdxHintViewZoom = 'Zoom';
  sdxHintZoomPercent100 = 'Zoom 100%';
  sdxHintZoomPageWidth = 'Zoom Page Width';
  sdxHintZoomWholePage = 'Whole Page';
  sdxHintZoomTwoPages = 'Two Pages';
  sdxHintZoomFourPages = 'Four Pages';
  sdxHintZoomMultiplyPages = 'Multiple Pages';
  sdxHintZoomWidenToSourceWidth = 'Widen To Source Width';
  sdxHintZoomSetup = 'Setup Zoom Factor';

  sdxHintFormatDateTime = 'Format Date and Time';
  sdxHintFormatPageNumbering = 'Format Page Number';
  sdxHintFormatPageBackground = 'Background';
  sdxHintFormatShrinkToPage = 'Shrink To Page';
  sdxHintFormatHFBackground = 'Header/Footer Background';
  sdxHintFormatHFClear = 'Clear Header/Footer Text';

  sdxHintGotoPageFirst = 'First Page';
  sdxHintGotoPagePrev = 'Previous Page';
  sdxHintGotoPageNext = 'Next Page';
  sdxHintGotoPageLast = 'Last Page';
  sdxHintActivePage = 'Active Page';

  sdxHintToolsCustomize = 'Customize Toolbars';
  sdxHintToolsOptions = 'Options';

  sdxHintHelpTopics = 'Help Topics';
  sdxHintHelpAbout = 'About';

  sdxPopupMenuLargeButtons = '&Large Buttons';
  sdxPopupMenuFlatButtons = '&Flat Buttons';

  sdxPaperSize = 'Paper Size';
  sdxStatus = 'Status';
  sdxStatusReady = 'Ready';
  sdxStatusPrinting = 'Printing. Completed %d page(s)';
  sdxStatusGenerateReport = 'Generating Report. Completed %d%%';

  sdxHintDoubleClickForChangePaperSize = 'Double Click for Change Paper Size';
  sdxHintDoubleClickForChangeMargins = 'Double Click for Change Margins';

  { Date&Time Formats Dialog }
  
  sdxDTFormatsCaption = 'Date and Time';
  sdxDTFormatsAvailableDateFormats = '&Available Date Formats:';
  sdxDTFormatsAvailableTimeFormats = 'Available &Time Formats:';
  sdxDTFormatsAutoUpdate = '&Update Automatically';
  sdxDTFormatsChangeDefaultFormat =
    'Do you want to change the default date and time formats to match "%s"  - "%s" ?';

  { PageNumber Formats Dialog }
  
  sdxPNFormatsCaption = 'Page Number Format';
  sdxPageNumbering = 'Page Numbering';
  sdxPNFormatsNumberFormat = 'Number &Format:';
  sdxPNFormatsContinueFromPrevious = '&Continue from Previous Section';
  sdxPNFormatsStartAt = 'Start &At:';
  sdxPNFormatsChangeDefaultFormat =
    'Do you want to change the default Page numbering format to match "%s" ?';

  { Zoom Dialog }
  
  sdxZoomDlgCaption = 'Zoom';
  sdxZoomDlgZoomTo = ' Zoom To ';
  sdxZoomDlgPageWidth = 'Page &Width';
  sdxZoomDlgWholePage = 'W&hole Page';
  sdxZoomDlgTwoPages = '&Two Pages';
  sdxZoomDlgFourPages = '&Four Pages';
  sdxZoomDlgManyPages = '&Many Pages:';
  sdxZoomDlgPercent = 'P&ercent:';
  sdxZoomDlgPreview = ' Preview ';
  sdxZoomDlgFontPreview = ' 12pt Times New Roman ';
  sdxZoomDlgFontPreviewString = 'AaBbCcDdEeXxYyZz';

  { Select page X x Y }
  
  sdxPages = 'Pages';
  sdxCancel = 'Cancel';

  { preferences dialog }
  
  sdxPreferenceDlgCaption = 'Options';
  sdxPreferenceDlgTab1 = '&General';
  sdxPreferenceDlgTab2 = '';
  sdxPreferenceDlgTab3 = '';
  sdxPreferenceDlgTab4 = '';
  sdxPreferenceDlgTab5 = '';
  sdxPreferenceDlgTab6 = '';
  sdxPreferenceDlgTab7 = '';
  sdxPreferenceDlgTab8 = '';
  sdxPreferenceDlgTab9 = '';
  sdxPreferenceDlgTab10 = '';
  sdxPreferenceDlgShow = ' &Show ';
  sdxPreferenceDlgMargins = '&Margins ';
  sdxPreferenceDlgMarginsHints = 'Margins &Hints';
  sdxPreferenceDlgMargingWhileDragging = 'Margins Hints While &Dragging';
  sdxPreferenceDlgLargeBtns = '&Large Toolbar Buttons';
  sdxPreferenceDlgFlatBtns = '&Flat Toolbar Buttons';
  sdxPreferenceDlgMarginsColor = 'Margins &Color:';
  sdxPreferenceDlgMeasurementUnits = 'Measurement &Units:';
  sdxPreferenceDlgSaveForRunTimeToo = 'Save for &RunTime too';
  sdxPreferenceDlgZoomScroll = '&Zoom on roll with IntelliMouse';
  sdxPreferenceDlgZoomStep = 'Zoom Ste&p:';

  
  { Page Setup }
  
  sdxCloneStyleCaptionPrefix = 'Copy (%d) of ';
  sdxInvalideStyleCaption = 'The style name "%s" already exists. Please supply another name.';

  sdxPageSetupCaption = 'Page Setup';
  sdxStyleName = 'Style &Name:';

  sdxPage = '&Page';
  sdxMargins = '&Margins';
  sdxHeaderFooter = '&Header\Footer';
  sdxScaling = '&Scaling';

  sdxPaper = ' Paper ';
  sdxPaperType = 'T&ype';
  sdxPaperDimension = 'Dimension';
  sdxPaperWidth = '&Width:';
  sdxPaperHeight = 'H&eight:';
  sdxPaperSource = 'Paper so&urce';

  sdxOrientation = ' Orientation ';
  sdxPortrait = 'P&ortrait';
  sdxLandscape = '&Landscape';
  sdxPrintOrder = ' Print Order ';
  sdxDownThenOver = '&Down, then over';
  sdxOverThenDown = 'O&ver, then down';
  sdxShading = ' Shading ';
  sdxPrintUsingGrayShading = 'Print using &gray shading';

  sdxCenterOnPage = 'Center on page';
  sdxHorizontally = 'Hori&zontally';
  sdxVertically = '&Vertically';

  sdxHeader = 'Header ';
  sdxBtnHeaderFont = '&Font...';
  sdxBtnHeaderBackground = '&Background';
  sdxFooter = 'Footer ';
  sdxBtnFooterFont = 'Fo&nt...';
  sdxBtnFooterBackground = 'Back&ground';

  sdxTop = '&Top:';
  sdxLeft = '&Left:';
  sdxRight = 'Ri&ght:';
  sdxBottom = '&Bottom:';
  sdxHeader2 = 'H&eader:';
  sdxFooter2 = 'Foote&r:';

  sdxAlignment = 'Alignment';
  sdxVertAlignment = ' Vertical Alignment ';
  sdxReverseOnEvenPages = '&Reverse on even pages';

  sdxAdjustTo = '&Adjust To:';
  sdxFitTo = '&Fit To:';
  sdxPercentOfNormalSize = '% normal size';
  sdxPagesWideBy = 'page(s) &wide by';
  sdxTall = '&tall';

  sdxOf = 'Of';
  sdxLastPrinted = 'Last Printed ';
  sdxFileName = 'Filename ';
  sdxFileNameAndPath = 'Filename and path ';
  sdxPrintedBy = 'Printed By ';
  sdxPrintedOn = 'Printed On ';
  sdxCreatedBy = 'Created By ';
  sdxCreatedOn = 'Created On ';
  sdxConfidential = 'Confidential';

  { HF function }
  
  sdxHFFunctionNameUnknown = 'Unknown';
  sdxHFFunctionNamePageNumber = 'Page Number';
  sdxHFFunctionNameTotalPages = 'Total Pages';
  sdxHFFunctionNamePageOfPages = 'Page # of Pages #';
  sdxHFFunctionNameDateTime = 'Date and Time';
  sdxHFFunctionNameDate = 'Date';
  sdxHFFunctionNameTime = 'Time';
  sdxHFFunctionNameUserName = 'User Name';
  sdxHFFunctionNameMachineName = 'Machine Name';

  sdxHFFunctionHintPageNumber = 'Page Number';
  sdxHFFunctionHintTotalPages = 'Total Pages';
  sdxHFFunctionHintPageOfPages = 'Page # of Pages #';
  sdxHFFunctionHintDateTime = 'Date and Time Printed';
  sdxHFFunctionHintDate = 'Date Printed';
  sdxHFFunctionHintTime = 'Time Printed';
  sdxHFFunctionHintUserName = 'User Name';
  sdxHFFunctionHintMachineName = 'Machine Name';

  sdxHFFunctionTemplatePageNumber = 'Page #';
  sdxHFFunctionTemplateTotalPages = 'Total Pages';
  sdxHFFunctionTemplatePageOfPages = 'Page # of Pages #';
  sdxHFFunctionTemplateDateTime = 'Date & Time Printed';
  sdxHFFunctionTemplateDate = 'Date Printed';
  sdxHFFunctionTemplateTime = 'Time Printed';
  sdxHFFunctionTemplateUserName = 'User Name';
  sdxHFFunctionTemplateMachineName = 'Machine Name';

  { Designer strings }
  
  { Months }
  
  sdxJanuary = 'January';
  sdxFebruary = 'February';
  sdxMarch = 'March';
  sdxApril = 'April';
  sdxMay = 'May';
  sdxJune = 'June';
  sdxJuly = 'July';
  sdxAugust = 'August';
  sdxSeptember = 'September';
  sdxOctober = 'October';
  sdxNovember = 'November';
  sdxDecember = 'December';

  { World sides}
  
  sdxEast = 'East';
  sdxWest = 'West';
  sdxSouth = 'South';
  sdxNorth = 'North';

  sdxTotal = 'Total';

  { dxFlowChart }
  
  sdxPlan = 'Plan';
  sdxSwimmingPool = 'Swimming-pool';
  sdxAdministration = 'Administration';
  sdxPark = 'Park';
  sdxCarParking = 'Car-Parking';

  { dxOrgChart }
  
  sdxCorporateHeadquarters = 'Corporate' + #13#10 + 'Headquarters';
  sdxSalesAndMarketing = 'Sales and' + #13#10 + 'Marketing';
  sdxEngineering = 'Engineering';
  sdxFieldOfficeCanada = 'Field Office:' + #13#10 + 'Canada';

  { dxMasterView }
  
  sdxOrderNoCaption = 'OrderNo';
  sdxNameCaption = 'Name';
  sdxCountCaption = 'Count';
  sdxCompanyCaption = 'Company';
  sdxAddressCaption = 'Address';
  sdxPriceCaption = 'Price';
  sdxCashCaption = 'Cash';

  sdxName1 = 'Jennie Valentine';
  sdxName2 = 'Sam Hill';
  sdxCompany1 = 'Jennie Inc.';
  sdxCompany2 = 'Daimler-Chrysler AG';
  sdxAddress1 = '123 Home Lane';
  sdxAddress2 = '9333 Holmes Dr.';

  { dxTreeList }

  sdxCountIs = 'Count is: %d';
  sdxRegular = 'Regular';
  sdxIrregular = 'Irregular';

  sdxTLBand = 'Item Data';
  sdxTLColumnName = 'Name';
  sdxTLColumnAxisymmetric = 'Axisymmetric';
  sdxTLColumnItemShape = 'Shape';

  sdxItemShapeAsText = '(Graphic)';

  sdxItem1Name = 'Cylinder';
  sdxItem2Name = 'Cone';
  sdxItem3Name = 'Pyramid';
  sdxItem4Name = 'Box';
  sdxItem5Name = 'Free Surface';

  sdxItem1Description = '';
  sdxItem2Description = 'Axisymmetric geometry figure';
  sdxItem3Description = 'Axisymmetric geometry figure';
  sdxItem4Description = 'Acute-angled geometry figure';
  sdxItem5Description = '';
  sdxItem6Description = '';
  sdxItem7Description = 'Simple extrusion surface';


  { PS 2.3 }
  
  { Patterns common }
  
  sdxPatternIsNotRegistered = 'Pattern "%s" is not registered';

  { Excel edge patterns }
  
  sdxSolidEdgePattern = 'Solid';
  sdxThinSolidEdgePattern = 'Medium Solid';    
  sdxMediumSolidEdgePattern = 'Medium Solid';  
  sdxThickSolidEdgePattern = 'Thick Solid';
  sdxDottedEdgePattern = 'Dotted';
  sdxDashedEdgePattern = 'Dashed';
  sdxDashDotDotEdgePattern = 'Dash Dot Dot';
  sdxDashDotEdgePattern = 'Dash Dot';
  sdxSlantedDashDotEdgePattern = 'Slanted Dash Dot';
  sdxMediumDashDotDotEdgePattern = 'Medium Dash Dot Dot';
  sdxHairEdgePattern = 'Hair';
  sdxMediumDashDotEdgePattern = 'Medium Dash Dot';
  sdxMediumDashedEdgePattern = 'Medium Dashed';
  sdxDoubleLineEdgePattern = 'Double Line';

  { Excel fill patterns names} 
   
  sdxSolidFillPattern = 'Solid';
  sdxGray75FillPattern = '75% Gray';
  sdxGray50FillPattern = '50% Gray';
  sdxGray25FillPattern = '25% Gray';
  sdxGray125FillPattern = '12.5% Gray';
  sdxGray625FillPattern = '6.25% Gray';
  sdxHorizontalStripeFillPattern = 'Horizontal Stripe';
  sdxVerticalStripeFillPattern = 'Vertical Stripe';
  sdxReverseDiagonalStripeFillPattern = 'Reverse Diagonal Stripe';
  sdxDiagonalStripeFillPattern = 'Diagonal Stripe';
  sdxDiagonalCrossHatchFillPattern = 'Diagonal Cross Hatch';
  sdxThickCrossHatchFillPattern = 'Thick Cross Hatch';
  sdxThinHorizontalStripeFillPattern = 'Thin Horizontal Stripe';
  sdxThinVerticalStripeFillPattern = 'Thin Vertical Stripe';
  sdxThinReverseDiagonalStripeFillPattern = 'Thin Reverse Diagonal Stripe';
  sdxThinDiagonalStripeFillPattern = 'Thin Diagonal Stripe';
  sdxThinHorizontalCrossHatchFillPattern = 'Thin Horizontal Cross Hatch';
  sdxThinDiagonalCrossHatchFillPattern = 'Thin Diagonal Cross Hatch';
  
  { cxSpreadSheet } 
  
  sdxShowRowAndColumnHeadings = '&Row and column headings';
  sdxShowGridLines = 'GridLines';
  sdxSuppressSourceFormats = '&Suppress Source Formats';
  sdxRepeatHeaderRowAtTop = 'Repeat header row at top';
  sdxDataToPrintDoesnotExist = 
    'Can not activate ReportLink because PrintingSystem did not find anything to print.';
 
  { Designer strings } 
  
  { Short names of month }

  sdxJanuaryShort = 'Jan';
  sdxFebruaryShort = 'Feb';
  sdxMarchShort = 'March';  
  sdxAprilShort = 'April';  
  sdxMayShort = 'May';    
  sdxJuneShort = 'June';    
  sdxJulyShort = 'July';
  sdxAugustShort = 'Aug';
  sdxSeptemberShort = 'Sept';
  sdxOctoberShort = 'Oct';
  sdxNovemberShort = 'Nov';
  sdxDecemberShort = 'Dec';

  { TreeView }
  
  sdxTechnicalDepartment = 'Technical Department';
  sdxSoftwareDepartment = 'Software Department';
  sdxSystemProgrammers = 'Core Developers';
  sdxEndUserProgrammers = 'GUI Developers';
  sdxBetaTesters = 'Beta Testers';
  sdxHumanResourceDepartment = 'Human Resource Department';

  { misc. }
  sdxTreeLines = '&TreeLines';
  sdxTreeLinesColor = 'T&ree Line Color:';
  sdxExpandButtons = 'E&xpand Buttons';
  sdxCheckMarks = 'Check Marks';
  sdxTreeEffects = 'Tree Effects';
  sdxAppearance = 'Appearance';

  { Designer previews }
  
  sdxCarLevelCaption = 'Cars';
  
  sdxManufacturerBandCaption = 'Manufacturer Data';  
  sdxModelBandCaption = 'Car Data';
  
  sdxManufacturerNameColumnCaption = 'Name';
  sdxManufacturerLogoColumnCaption = 'Logo';  
  sdxManufacturerCountryColumnCaption = 'Country';  
  sdxCarModelColumnCaption = 'Model';
  sdxCarIsSUVColumnCaption = 'SUV';
  sdxCarPhotoColumnCaption = 'Photo';  

  sdxCarManufacturerName1 = 'BMW';
  sdxCarManufacturerName2 = 'Ford';
  sdxCarManufacturerName3 = 'Audi';
  sdxCarManufacturerName4 = 'Land Rover';

  sdxCarManufacturerCountry1 = 'Germany';
  sdxCarManufacturerCountry2 = 'United States';
  sdxCarManufacturerCountry3 = 'Germany';
  sdxCarManufacturerCountry4 = 'United Kingdom';
  
  sdxCarModel1 = 'X5 4.6is';
  sdxCarModel2 = 'Excursion';
  sdxCarModel3 = 'S8 Quattro';
  sdxCarModel4 = 'G4 Challenge';
  
  sdxTrue = 'True';
  sdxFalse = 'False';  

  { PS 2.4 }
  
  { dxPrnDev.pas }
  
  sdxAuto = 'Auto'; 
  sdxCustom = 'Custom'; 
  sdxEnv = 'Env';
  
  { Grid 4 }
  
  sdxLookAndFeelFlat = 'Flat';
  sdxLookAndFeelStandard = 'Standard';
  sdxLookAndFeelUltraFlat = 'UltraFlat';    

  sdxViewTab = 'View';
  sdxBehaviorsTab = 'Behaviors';
  sdxPreviewTab = 'Preview';
  sdxCardsTab = 'Cards';

  sdxFormatting = 'Formatting';
  sdxLookAndFeel = 'Look and Feel';
  sdxLevelCaption = '&Caption';
  sdxFilterBar = '&Filter Bar';  
  sdxRefinements = 'Refinements';
  sdxProcessSelection = 'Process &Selection';
  sdxProcessExactSelection = 'Process E&xact Selection';
  sdxExpanding = 'Expanding';
  sdxGroups = '&Groups';
  sdxDetails = '&Details';
  sdxStartFromActiveDetails = 'Start from Active Details';
  sdxOnlyActiveDetails = 'Only Active Details';
  sdxVisible = '&Visible';
  sdxPreviewAutoHeight = 'A&uto Height';
  sdxPreviewMaxLineCount = '&Max Line Count: ';
  sdxSizes = 'Sizes';
  sdxKeepSameWidth = '&Keep Same Width';
  sdxKeepSameHeight = 'Keep Same &Height';
  sdxFraming = 'Framing';  
  sdxSpacing = 'Spacing';
  sdxShadow = 'Shadow';
  sdxDepth = '&Depth:';
  sdxPosition = '&Position';
  sdxPositioning = 'Positioning';
  sdxHorizontal = 'H&orizontal:';
  sdxVertical = 'V&ertical:';

  sdxSummaryFormat = 'Count = 0';

  sdxCannotUseOnEveryPageMode = 'Cannot Use OnEveryPage Mode'+ #13#10 +
    #13#10 + 
    'You should or(and)' + #13#10 +
    '  - Collapse all Master Records' + #13#10 +
    '  - Toggle "Unwrap" Option off on "Behaviors" Tab';

  sdxIncorrectBandHeadersState = 'Cannot Use BandHeaders OnEveryPage Mode' + #13#10 +
    #13#10 +
    'You should either:' + #13#10 +  
    '  - Set Caption OnEveryPage Option On' + #13#10 + 
    '  - Set Caption Visible Option Off';
  sdxIncorrectHeadersState = 'Cannot Use Headers OnEveryPage Mode' + #13#10 +
    #13#10 +
    'You should either:' + #13#10 +  
    '  - Set Caption and Band OnEveryPage Option On' + #13#10 +
    '  - Set Caption and Band Visible Option Off';
  sdxIncorrectFootersState = 'Cannot Use Footers OnEveryPage Mode' + #13#10 +
    #13#10 +
    'You should either:' + #13#10 +  
    '  - Set FilterBar OnEveryPage Option On' + #13#10 +
    '  - Set FilterBar Visible Option Off';

  { PS 3 } 

  sdxTPicture = 'TPicture';
  sdxCopy = '&Copy';
  sdxSave = '&Save...';
  sdxBaseStyle = 'Base Style';
  
  { shapes } 
 
  sdxRectangle = 'Rectangle';
  sdxSquare = 'Square';
  sdxEllipse = 'Ellipse';
  sdxCircle = 'Circle';
  sdxRoundRect = 'RoundRect';
  sdxRoundSquare = 'RoundSquare';

  { standard pattern names}
    
  sdxHorizontalFillPattern = 'Horizontal';
  sdxVerticalFillPattern = 'Vertical';
  sdxFDiagonalFillPattern = 'FDiagonal';
  sdxBDiagonalFillPattern = 'BDiagonal';
  sdxCrossFillPattern = 'Cross';
  sdxDiagCrossFillPattern = 'DiagCros';
  
  { explorer }
                                                             
  sdxCyclicIDReferences = 'Cyclic ID references %s and %s';
  sdxLoadReportDataToFileTitle = 'Load Report';
  sdxSaveReportDataToFileTitle = 'Save Report As';
  sdxInvalidExternalStorage = 'Invalid External Storage';
  sdxLinkIsNotIncludedInUsesClause = 'ReportFile contains ReportLink "%0:s"' + #13#10 + 
    'Unit with declaration of "%0:s" must be included in uses clause';
  sdxInvalidStorageVersion = 'Invalid Storage Verison: %d';
  sdxPSReportFiles = 'Report Files';
  sdxReportFileLoadError = 'Cannot load Report File "%s".' + #13#10 + 
    'File is corruted or is locked by another User or Application.' + #13#10 + 
    #13#10 +
    'Original Report will be restored.';
  
  sdxNone = '(None)';
  sdxReportDocumentIsCorrupted = '(File is not a ReportDocument or Corrupted)';
  
  sdxCloseExplorerHint = 'Close Explorer';
  sdxExplorerCaption = 'Explorer';
  sdxExplorerRootFolderCaption = 'Root';
  sdxNewExplorerFolderItem = 'New Folder';
  sdxCopyOfItem = 'Copy of ';
  sdxReportExplorer = 'Report Explorer';
                                
  sdxDataLoadErrorText = 'Cannot load Report Data';
  sdxDBBasedExplorerItemDataLoadError = 'Cannot load Report Data.' + #13#10 + 
    'Data are corrupted or are locked';
  sdxFileBasedExplorerItemDataLoadError = 'Cannot load Report Data.' + #13#10 + 
    'File is corruted or is locked by another User or Application';
  sdxDeleteNonEmptyFolderMessageText = 'Folder "%s" is not Empty. Delete anyway?';
  sdxDeleteFolderMessageText = 'Delete Folder "%s" ?';
  sdxDeleteItemMessageText = 'Delete Item "%s" ?';
  sdxCannotRenameFolderText = 'Cannot rename folder "%s". A folder with name "%s" already exists. Specify a different name.';
  sdxCannotRenameItemText = 'Cannot rename item "%s". An item with name "%s" already exists. Specify a different name.';
  sdxOverwriteFolderMessageText = 'This folder "%s" already contains folder named "%s".' + #13#10#13#10 + 
    'If the items in existing folder have the same name as items in the' + #13#10 + 
    'folder you are moving or copying, they will be replaced. Do you still?' + #13#10 +
    'want to move or copy the folder?';
  sdxOverwriteItemMessageText = 'This Folder "%s" already contains item named "%s".' + #13#10#13#10 + 
    'Would you like to overwrite existing item?';
  sdxSelectNewRoot = 'Select new Root Directory where the Reports will be stored';
  sdxInvalidFolderName = 'Invalid Folder Name "%s"';
  sdxInvalidReportName = 'Invalid Report Name "%s"';
  
  sdxExplorerBar = 'Explorer';

  sdxMenuFileSave = '&Save';
  sdxMenuFileSaveAs = 'Save &As...';
  sdxMenuFileLoad = '&Load';
  sdxMenuFileClose = 'U&nload';
  sdxHintFileSave = 'Save Report';
  sdxHintFileSaveAs = 'Save Report As';
  sdxHintFileLoad = 'Load Report';
  sdxHintFileClose = 'Unload Report';
  
  sdxMenuExplorer = 'E&xplorer';
  sdxMenuExplorerCreateFolder = 'Create &Folder';
  sdxMenuExplorerDelete = '&Delete...';
  sdxMenuExplorerRename = 'Rena&me';
  sdxMenuExplorerProperties = '&Properties...';
  sdxMenuExplorerRefresh = 'Refresh';
  sdxMenuExplorerChangeRootPath = 'Change Root...';
  sdxMenuExplorerSetAsRoot = 'Set As Root';
  sdxMenuExplorerGoToUpOneLevel = 'Up One Level';
  sdxHintExplorerCreateFolder = 'Create New Folder';
  sdxHintExplorerDelete = 'Delete';
  sdxHintExplorerRename = 'Rename';
  sdxHintExplorerProperties = 'Properties';
  sdxHintExplorerRefresh = 'Refresh';
  sdxHintExplorerChangeRootPath = 'Change Root';
  sdxHintExplorerSetAsRoot = 'Set Current Folder as Root';
  sdxHintExplorerGoToUpOneLevel = 'Up One Level';
  
  sdxMenuViewExplorer = 'E&xplorer';
  sdxHintViewExplorer = 'Show Explorer';

  sdxSummary = 'Summary';
  sdxCreator = 'Creato&r:';
  sdxCreationDate = 'Create&d:';
 
  sdxMenuViewThumbnails = 'Th&umbnails';
  sdxHintViewThumbnails = 'Show Thumbnails';
  
  sdxMenuFormatTitle = 'T&itle...';
  sdxHintFormatTitle = 'Format Report Title';

  sdxHalf = 'Half';
  sdxPredefinedFunctions = ' Predefined Functions '; // dxPgsDlg.pas
  sdxZoomParameters = ' Zoom &Parameters ';          // dxPSPrvwOpt.pas

  sdxWrapData = '&Wrap Data';

  sdxMenuShortcutExplorer = 'Explorer';  
  sdxExplorerToolBar = 'Explorer';

  sdxMenuSmallThumbnails = '&Small Thumbnails';
  sdxMenuLargeThumbnails = '&Large Thumbnails';

  sdxMenuShortcutThumbnails = 'Thumbnails';
  
  { TreeView New}
  
  sdxButtons = 'Buttons';
  
  { ListView }

  sdxBtnHeadersFont = '&Headers Font...';
  sdxHeadersTransparent = 'Transparent &Headers';
  sdxHintListViewDesignerMessage = ' Most Options Are Being Taken Into Account Only In Detailed View';
  sdxColumnHeaders = '&Column Headers';
  
  { Group LookAndFeel Names }

  sdxReportGroupNullLookAndFeel = 'Null';
  sdxReportGroupStandardLookAndFeel = 'Standard';
  sdxReportGroupOfficeLookAndFeel = 'Office';  
  sdxReportGroupWebLookAndFeel = 'Web';
  
  sdxLayoutGroupDefaultCaption = 'Layout Group';
  sdxLayoutItemDefaultCaption = 'Layout Item';

  { Designer Previews}

  { Localize if you want (they are used inside preview in FormatReport dialog) }
    
  sdxCarManufacturerName5 = 'Volkswagen';
  sdxCarManufacturerName6 = 'Mazda';
  sdxCarManufacturerName7 = 'Aston Martin';
  sdxCarManufacturerName8 = 'Volvo';
  sdxCarManufacturerName9 = 'DaimlerChrysler AG';
  
  sdxCarManufacturerCountry5 = 'Germany';
  sdxCarManufacturerCountry6 = 'Japan';
  sdxCarManufacturerCountry7 = 'United Kingdom';
  sdxCarManufacturerCountry8 = 'Sweden';
  sdxCarManufacturerCountry9 = 'Germany';
  
  sdxCarModel5 = 'Golf GTI';
  sdxCarModel6 = 'Mazda RX-8';
  sdxCarModel7 = 'V12 Vanquish';
  sdxCarModel8 = 'S80';
  sdxCarModel9 = 'Maybach 62';

  sdxLuxurySedans = 'Luxury Sedans';
  sdxCarManufacturer = 'Manufacturer';
  sdxCarModel = 'Model';
  sdxCarEngine = 'Engine';
  sdxCarTransmission = 'Transmission';
  sdxCarTires = 'Tires';
  sdx760V12Manufacturer = 'BMW';
  sdx760V12Model = '760Li V12';
  sdx760V12Engine = '6.0L DOHC V12 438 HP 48V DI Valvetronic 12-cylinder engine with 6.0-liter displacement, dual overhead cam valvetrain';
  sdx760V12Transmission = 'Elec 6-Speed Automatic w/Steptronic';
  sdx760V12Tires = 'P245/45R19 Fr - P275/40R19 Rr Performance. Low Profile tires with 245mm width, 19.0" rim';
      
  { Styles }

  sdxBandHeaderStyle = 'BandHeader';
  sdxCaptionStyle = 'Caption';
  sdxCardCaptionRowStyle = 'Card Caption Row';
  sdxCardRowCaptionStyle = 'Card Row Caption';
  sdxCategoryStyle = 'Category';
  sdxContentStyle = 'Content';
  sdxContentEvenStyle = 'Content Even Rows';
  sdxContentOddStyle = 'Content Odd Rows';
  sdxFilterBarStyle = 'Filter Bar';
  sdxFooterStyle = 'Footer';
  sdxFooterRowStyle = 'Footer Row';
  sdxGroupStyle = 'Group';
  sdxHeaderStyle = 'Header';
  sdxIndentStyle = 'Indent';
  sdxPreviewStyle = 'Preview';
  sdxSelectionStyle = 'Selection';

  sdxStyles = 'Styles';
  sdxStyleSheets = 'Style Sheets';
  sdxBtnTexture = '&Texture...';
  sdxBtnTextureClear = 'Cle&ar';
  sdxBtnColor = 'Co&lor...';
  sdxBtnSaveAs = 'Save &As...';
  sdxBtnRename = '&Rename...';
  
  sdxLoadBitmapDlgTitle = 'Load Bitmap';

  sdxDeleteStyleSheet = 'Delete StyleSheet Named "%s"?';
  sdxUnnamedStyleSheet = 'Unnamed';
  sdxCreateNewStyleQueryNamePrompt = 'Enter New StyleSheet Name: ';
  sdxStyleSheetNameAlreadyExists = 'StyleSheet named "%s" Already Exists';

  sdxCannotLoadImage = 'Cannot Load Image "%s"';
  sdxUseNativeStyles = '&Use Native Styles';
  sdxSuppressBackgroundBitmaps = '&Suppress Background Texture';
  sdxConsumeSelectionStyle = 'Consume Selection Style';
  
  { Grid4 new }

  sdxSize = 'Size';
  sdxLevels = 'Levels';
  sdxUnwrap = '&Unwrap';
  sdxUnwrapTopLevel = 'Un&wrap Top Level';
  sdxRiseActiveToTop = 'Rise Active Level onto Top';
  sdxCannotUseOnEveryPageModeInAggregatedState = 'Cannot Use OnEveryPage Mode'+ #13#10 + 'While Performing in Aggregated State';

  sdxPagination = 'Pagination';
  sdxByBands = 'By Bands';
  sdxByColumns = 'By Columns';
  sdxByRows = 'By &Rows';
  sdxByTopLevelGroups = 'By TopLevel Groups'; 
  sdxOneGroupPerPage = 'One Group Per Page'; 

  {* For those who will translate *}
  {* You should also check "sdxCannotUseOnEveryPageMode" resource string - see above *}
  {* I was changed to "- Toggle "Unwrap" Option off on "Behaviors" Tab'" was added *}
   
  { TL 4 }
  sdxBorders = 'Borders';
  sdxExplicitlyExpandNodes = 'Explicitly Expand Nodes';
  sdxNodes = '&Nodes';
  sdxSeparators = 'Separators';
  sdxThickness = 'Thickness';
  sdxTLIncorrectHeadersState = 'Cannot Use Headers OnEveryPage Mode' + #13#10 +
    #13#10 +
    'You should either:' + #13#10 +  
    '  - Set Band OnEveryPage Option On' + #13#10 +
    '  - Set Band Visible Option Off';

  { cxVerticalGrid } 

  sdxRows = '&Rows'; 

  sdxBestFit = '&Best Fit';
  sdxKeepSameRecordWidths = '&Keep Same Record Widths';
  sdxWrapRecords = '&Wrap Records';

  sdxByWrapping = 'By &Wrapping';
  sdxOneWrappingPerPage = '&One Wrapping Per Page';

  { Container Designer }
  
  sdxPaginateByControlDetails = 'Control Details';
  sdxPaginateByControls = 'Controls';
  sdxPaginateByGroups = 'Groups';
  sdxPaginateByItems = 'Items';
  
  sdxControlsPlace = 'Controls Place';
  sdxExpandHeight = 'Expand Height';
  sdxExpandWidth = 'Expand Width';
  sdxShrinkHeight = 'Shrink Height';
  sdxShrinkWidth = 'Shrink Width';
  
  sdxCheckAll = 'Check &All';
  sdxCheckAllChildren = 'Check All &Children';
  sdxControlsTab = 'Controls';
  sdxExpandAll = 'E&xpand All';
  sdxHiddenControlsTab = 'Hidden Controls';
  sdxReportLinksTab = 'Aggregated Designers';
  sdxTransparents = 'Transparents';
  sdxUncheckAllChildren = 'Uncheck &All Children';
  
  sdxRoot = '&Root';
  sdxRootBorders = 'Root &Borders';
  sdxControls = '&Controls';
  sdxContainers = 'C&ontainers';

  sdxHideCustomContainers = '&Hide Custom Containers';

  { General }
  
  // FileSize abbreviation

  sdxBytes = 'Bytes';
  sdxKiloBytes = 'KB';
  sdxMegaBytes = 'MB';
  sdxGigoBytes = 'GB';



  //********** dxsbstrs
  DXSB_NEWITEM               = 'New item';

  DXSB_DEFAULTGROUP          = 'Default';
  DXSB_DEFAULTITEMCAPTION    = 'New Item';
  DXSB_DEFAULTGROUPCAPTION   = 'New Group';

  //PopupMenu
  DXSB_ADDGROUP              = 'Add Group';
  DXSB_REMOVEGROUP           = 'Remove Group';
  DXSB_RENAMEGROUP           = 'Rename Group';
  DXSB_REMOVEITEM            = 'Remove ShortCut';
  DXSB_RENAMEITEM            = 'Rename ShortCut';
  DXSB_LARGEICONTYPE         = 'Large Icons';
  DXSB_SMALLICONTYPE         = 'Small Icons';
  DXSB_CUSTOMIZE             = 'Customize...';
  DXSB_CUSTOMIZECLOSEBUTTON  = 'Close';

  DXSB_CANTDELETEGROUP  = 'Can''t delete the group. It has items.';



   *)
End;




function TCorp_Const_StringCollection.GetMessByName(NameInp: String): String;
Var CorpConstTmp: TCorp_Const_StringCollectionItem;
begin
  CorpConstTmp:=GetItemByName(NameInp);
  if not Assigned(CorpConstTmp)
  then Result:=''{NameInp}
  else Result:=CorpConstTmp.MessString;
end;

Function Corp_StrMess(IndexInp: String): String;
//     
Begin
   Result:=Corp_Const_String.GetMessByName(Trim(IndexInp));
End;



Procedure cxSetResourceStringLang(const ResString: Pointer; const Value: string);
Var StrTmp: String;
Begin
  StrTmp:=Corp_StrMess('scxUnsupportedExport');

  if Trim(StrTmp)<>'' then
  begin
    cxSetResourceString(@ResString, Value);
  end;
End;


Procedure SetResourceLangQuantum;
//      
Begin

  cxSetResourceStringLang(@scxUnsupportedExport, Corp_StrMess('scxUnsupportedExport'));
  cxSetResourceStringLang(@scxStyleManagerKill, Corp_StrMess('scxStyleManagerKill'));
  cxSetResourceStringLang(@scxStyleManagerCreate, Corp_StrMess('scxStyleManagerCreate'));
  cxSetResourceStringLang(@scxExportToHtml, Corp_StrMess('scxExportToHtml'));
  cxSetResourceStringLang(@scxExportToXml, Corp_StrMess('scxExportToXml'));
  cxSetResourceStringLang(@scxExportToText, Corp_StrMess('scxExportToText'));
  cxSetResourceStringLang(@scxEmptyExportCache, Corp_StrMess('scxEmptyExportCache'));
  cxSetResourceStringLang(@scxIncorrectUnion, Corp_StrMess('scxIncorrectUnion'));
  cxSetResourceStringLang(@scxIllegalWidth, Corp_StrMess('scxIllegalWidth'));
  cxSetResourceStringLang(@scxInvalidColumnRowCount, Corp_StrMess('scxInvalidColumnRowCount'));
  cxSetResourceStringLang(@scxIllegalHeight, Corp_StrMess('scxIllegalHeight'));
  cxSetResourceStringLang(@scxInvalidColumnIndex, Corp_StrMess('scxInvalidColumnIndex'));
  cxSetResourceStringLang(@scxInvalidRowIndex, Corp_StrMess('scxInvalidRowIndex'));
  cxSetResourceStringLang(@scxInvalidStyleIndex, Corp_StrMess('scxInvalidStyleIndex'));
  cxSetResourceStringLang(@scxExportToExcel, Corp_StrMess('scxExportToExcel'));
  cxSetResourceStringLang(@scxWorkbookWrite, Corp_StrMess('scxWorkbookWrite'));
  cxSetResourceStringLang(@scxInvalidCellDimension, Corp_StrMess('scxInvalidCellDimension'));
  cxSetResourceStringLang(@scxBoolTrue, Corp_StrMess('scxBoolTrue'));
  cxSetResourceStringLang(@scxBoolFalse, Corp_StrMess('scxBoolFalse'));
  cxSetResourceStringLang(@cxSGridNone, Corp_StrMess('cxSGridNone'));
  cxSetResourceStringLang(@cxSGridSortColumnAsc, Corp_StrMess('cxSGridSortColumnAsc'));
  cxSetResourceStringLang(@cxSGridSortColumnDesc, Corp_StrMess('cxSGridSortColumnDesc'));
  cxSetResourceStringLang(@cxSGridClearSorting, Corp_StrMess('cxSGridClearSorting'));
  cxSetResourceStringLang(@cxSGridGroupByThisField, Corp_StrMess('cxSGridGroupByThisField'));
  cxSetResourceStringLang(@cxSGridRemoveThisGroupItem, Corp_StrMess('cxSGridRemoveThisGroupItem'));
  cxSetResourceStringLang(@cxSGridGroupByBox, Corp_StrMess('cxSGridGroupByBox'));
  cxSetResourceStringLang(@cxSGridAlignmentSubMenu, Corp_StrMess('cxSGridAlignmentSubMenu'));
  cxSetResourceStringLang(@cxSGridAlignLeft, Corp_StrMess('cxSGridAlignLeft'));
  cxSetResourceStringLang(@cxSGridAlignRight, Corp_StrMess('cxSGridAlignRight'));
  cxSetResourceStringLang(@cxSGridAlignCenter, Corp_StrMess('cxSGridAlignCenter'));
  cxSetResourceStringLang(@cxSGridRemoveColumn, Corp_StrMess('cxSGridRemoveColumn'));
  cxSetResourceStringLang(@cxSGridFieldChooser, Corp_StrMess('cxSGridFieldChooser'));
  cxSetResourceStringLang(@cxSGridBestFit, Corp_StrMess('cxSGridBestFit'));
  cxSetResourceStringLang(@cxSGridBestFitAllColumns, Corp_StrMess('cxSGridBestFitAllColumns'));
  cxSetResourceStringLang(@cxSGridShowFooter, Corp_StrMess('cxSGridShowFooter'));
  cxSetResourceStringLang(@cxSGridShowGroupFooter, Corp_StrMess('cxSGridShowGroupFooter'));
  cxSetResourceStringLang(@cxSGridSumMenuItem, Corp_StrMess('cxSGridSumMenuItem'));
  cxSetResourceStringLang(@cxSGridMinMenuItem, Corp_StrMess('cxSGridMinMenuItem'));
  cxSetResourceStringLang(@cxSGridMaxMenuItem, Corp_StrMess('cxSGridMaxMenuItem'));
  cxSetResourceStringLang(@cxSGridCountMenuItem, Corp_StrMess('cxSGridCountMenuItem'));
  cxSetResourceStringLang(@cxSGridAvgMenuItem, Corp_StrMess('cxSGridAvgMenuItem'));
  cxSetResourceStringLang(@cxSGridNoneMenuItem, Corp_StrMess('cxSGridNoneMenuItem'));

{  cxSetResourceStringLang(@, Corp_StrMess(''));
  cxSetResourceStringLang(@, Corp_StrMess(''));
  cxSetResourceStringLang(@, Corp_StrMess(''));
  cxSetResourceStringLang(@, Corp_StrMess(''));
  cxSetResourceStringLang(@, Corp_StrMess(''));
  cxSetResourceStringLang(@, Corp_StrMess(''));}



  // cxDataConsts.pas
  cxSetResourceStringLang(@cxSDataReadError, Corp_StrMess('cxSDataReadError'));
  cxSetResourceStringLang(@cxSDataWriteError, Corp_StrMess('cxSDataWriteError'));
  cxSetResourceStringLang(@cxSDataItemExistError, Corp_StrMess('cxSDataItemExistError'));
  cxSetResourceStringLang(@cxSDataRecordIndexError, Corp_StrMess('cxSDataRecordIndexError'));
  cxSetResourceStringLang(@cxSDataItemIndexError, Corp_StrMess('cxSDataItemIndexError'));
  cxSetResourceStringLang(@cxSDataProviderModeError, Corp_StrMess('cxSDataProviderModeError'));
  cxSetResourceStringLang(@cxSDataInvalidStreamFormat, Corp_StrMess('cxSDataInvalidStreamFormat'));
  cxSetResourceStringLang(@cxSDataRowIndexError, Corp_StrMess('cxSDataRowIndexError'));
  cxSetResourceStringLang(@cxSDataCustomDataSourceInvalidCompare, Corp_StrMess('cxSDataCustomDataSourceInvalidCompare'));
  // DB
  cxSetResourceStringLang(@cxSDBDetailFilterControllerNotFound, Corp_StrMess('cxSDBDetailFilterControllerNotFound'));
  cxSetResourceStringLang(@cxSDBNotInGridMode, Corp_StrMess('cxSDBNotInGridMode'));


  // cxEditConsts.Pas
  cxSetResourceStringLang(@cxSEditDateConvertError, Corp_StrMess('cxSEditDateConvertError'));
  cxSetResourceStringLang(@cxSEditInvalidRepositoryItem, Corp_StrMess('cxSEditInvalidRepositoryItem'));
  cxSetResourceStringLang(@cxSEditNumericValueConvertError, Corp_StrMess('cxSEditNumericValueConvertError'));
  cxSetResourceStringLang(@cxSEditPopupCircularReferencingError, Corp_StrMess('cxSEditPopupCircularReferencingError'));
  cxSetResourceStringLang(@cxSEditPostError, Corp_StrMess('cxSEditPostError'));
  cxSetResourceStringLang(@cxSEditTimeConvertError, Corp_StrMess('cxSEditTimeConvertError'));
  cxSetResourceStringLang(@cxSEditValidateErrorText, Corp_StrMess('cxSEditValidateErrorText'));
  cxSetResourceStringLang(@cxSEditValueOutOfBounds, Corp_StrMess('cxSEditValueOutOfBounds'));

  // TODO
{  cxSEditCheckBoxChecked             = 'True';
  cxSEditCheckBoxGrayed              = '';
  cxSEditCheckBoxUnchecked           = 'False';
  cxSRadioGroupDefaultCaption        = '';}

  cxSetResourceStringLang(@cxSTextTrue, Corp_StrMess('cxSTextTrue'));
  cxSetResourceStringLang(@cxSTextFalse, Corp_StrMess('cxSTextFalse'));

  // blob
  cxSetResourceStringLang(@cxSBlobButtonOK, Corp_StrMess('cxSBlobButtonOK'));
  cxSetResourceStringLang(@cxSBlobButtonCancel, Corp_StrMess('cxSBlobButtonCancel'));
  cxSetResourceStringLang(@cxSBlobButtonClose, Corp_StrMess('cxSBlobButtonClose'));
  cxSetResourceStringLang(@cxSBlobMemo, Corp_StrMess('cxSBlobMemo'));
  cxSetResourceStringLang(@cxSBlobMemoEmpty, Corp_StrMess('cxSBlobMemoEmpty'));
  cxSetResourceStringLang(@cxSBlobPicture, Corp_StrMess('cxSBlobPicture'));
  cxSetResourceStringLang(@cxSBlobPictureEmpty, Corp_StrMess('cxSBlobPictureEmpty'));

  // popup menu items
  cxSetResourceStringLang(@cxSMenuItemCaptionCut, Corp_StrMess('cxSMenuItemCaptionCut'));
  cxSetResourceStringLang(@cxSMenuItemCaptionCopy, Corp_StrMess('cxSMenuItemCaptionCopy'));
  cxSetResourceStringLang(@cxSMenuItemCaptionPaste, Corp_StrMess('cxSMenuItemCaptionPaste'));
  cxSetResourceStringLang(@cxSMenuItemCaptionDelete, Corp_StrMess('cxSMenuItemCaptionDelete'));
  cxSetResourceStringLang(@cxSMenuItemCaptionLoad, Corp_StrMess('cxSMenuItemCaptionLoad'));
  cxSetResourceStringLang(@cxSMenuItemCaptionSave, Corp_StrMess('cxSMenuItemCaptionSave'));

  // date
  cxSetResourceStringLang(@cxSDatePopupClear, Corp_StrMess('cxSDatePopupClear'));
  cxSetResourceStringLang(@cxSDatePopupNow, Corp_StrMess('cxSDatePopupNow'));
  cxSetResourceStringLang(@cxSDatePopupOK, Corp_StrMess('cxSDatePopupOK'));
  cxSetResourceStringLang(@cxSDatePopupToday, Corp_StrMess('cxSDatePopupToday'));
  cxSetResourceStringLang(@cxSDateError, Corp_StrMess('cxSDateError'));
  // smart input consts
  cxSetResourceStringLang(@cxSDateToday, Corp_StrMess('cxSDateToday'));
  cxSetResourceStringLang(@cxSDateYesterday, Corp_StrMess('cxSDateYesterday'));
  cxSetResourceStringLang(@cxSDateTomorrow, Corp_StrMess('cxSDateTomorrow'));
  cxSetResourceStringLang(@cxSDateSunday, Corp_StrMess('cxSDateSunday'));
  cxSetResourceStringLang(@cxSDateMonday, Corp_StrMess('cxSDateMonday'));
  cxSetResourceStringLang(@cxSDateTuesday, Corp_StrMess('cxSDateTuesday'));
  cxSetResourceStringLang(@cxSDateWednesday, Corp_StrMess('cxSDateWednesday'));
  cxSetResourceStringLang(@cxSDateThursday, Corp_StrMess('cxSDateThursday'));
  cxSetResourceStringLang(@cxSDateFriday, Corp_StrMess('cxSDateFriday'));
  cxSetResourceStringLang(@cxSDateSaturday, Corp_StrMess('cxSDateSaturday'));
  cxSetResourceStringLang(@cxSDateFirst, Corp_StrMess('cxSDateFirst'));
  cxSetResourceStringLang(@cxSDateSecond, Corp_StrMess('cxSDateSecond'));
  cxSetResourceStringLang(@cxSDateThird, Corp_StrMess('cxSDateThird'));
  cxSetResourceStringLang(@cxSDateFourth, Corp_StrMess('cxSDateFourth'));
  cxSetResourceStringLang(@cxSDateFifth, Corp_StrMess('cxSDateFifth'));
  cxSetResourceStringLang(@cxSDateSixth, Corp_StrMess('cxSDateSixth'));
  cxSetResourceStringLang(@cxSDateSeventh, Corp_StrMess('cxSDateSeventh'));
  cxSetResourceStringLang(@cxSDateBOM, Corp_StrMess('cxSDateBOM'));
  cxSetResourceStringLang(@cxSDateEOM, Corp_StrMess('cxSDateEOM'));
  cxSetResourceStringLang(@cxSDateNow, Corp_StrMess('cxSDateNow'));

  // calculator
  cxSetResourceStringLang(@scxSCalcError, Corp_StrMess('scxSCalcError'));


  cxSetResourceStringLang(@cxSCheckComboBoxStates0PropertyDlgCaption, Corp_StrMess('cxSCheckComboBoxStates0PropertyDlgCaption'));
  cxSetResourceStringLang(@cxSCheckGroupStates0PropertyDlgCaption, Corp_StrMess('cxSCheckGroupStates0PropertyDlgCaption'));

  cxSetResourceStringLang(@cxSEditRichEditLibraryError, Corp_StrMess('cxSEditRichEditLibraryError'));
  cxSetResourceStringLang(@cxSEditRichEditLineInsertionError, Corp_StrMess('cxSEditRichEditLineInsertionError'));
  cxSetResourceStringLang(@cxSEditRichEditLoadFail, Corp_StrMess('cxSEditRichEditLoadFail'));
  cxSetResourceStringLang(@cxSEditRichEditSaveFail, Corp_StrMess('cxSEditRichEditSaveFail'));
  cxSetResourceStringLang(@scxSEditRepositoryRichEditItem, Corp_StrMess('scxSEditRepositoryRichEditItem'));


  // cxFilterConsts
  // base operators
  cxSetResourceStringLang(@cxSFilterOperatorEqual, Corp_StrMess('cxSFilterOperatorEqual'));
  cxSetResourceStringLang(@cxSFilterOperatorNotEqual, Corp_StrMess('cxSFilterOperatorNotEqual'));
  cxSetResourceStringLang(@cxSFilterOperatorLess, Corp_StrMess('cxSFilterOperatorLess'));
  cxSetResourceStringLang(@cxSFilterOperatorLessEqual, Corp_StrMess('cxSFilterOperatorLessEqual'));
  cxSetResourceStringLang(@cxSFilterOperatorGreater, Corp_StrMess('cxSFilterOperatorGreater'));
  cxSetResourceStringLang(@cxSFilterOperatorGreaterEqual, Corp_StrMess('cxSFilterOperatorGreaterEqual'));
  cxSetResourceStringLang(@cxSFilterOperatorLike, Corp_StrMess('cxSFilterOperatorLike'));
  cxSetResourceStringLang(@cxSFilterOperatorNotLike, Corp_StrMess('cxSFilterOperatorNotLike'));
  cxSetResourceStringLang(@cxSFilterOperatorBetween, Corp_StrMess('cxSFilterOperatorBetween'));
  cxSetResourceStringLang(@cxSFilterOperatorNotBetween, Corp_StrMess('cxSFilterOperatorNotBetween'));
  cxSetResourceStringLang(@cxSFilterOperatorInList, Corp_StrMess('cxSFilterOperatorInList'));
  cxSetResourceStringLang(@cxSFilterOperatorNotInList, Corp_StrMess('cxSFilterOperatorNotInList'));

  cxSetResourceStringLang(@cxSFilterOperatorYesterday, Corp_StrMess('cxSFilterOperatorYesterday'));
  cxSetResourceStringLang(@cxSFilterOperatorToday, Corp_StrMess('cxSFilterOperatorToday'));
  cxSetResourceStringLang(@cxSFilterOperatorTomorrow, Corp_StrMess('cxSFilterOperatorTomorrow'));

  cxSetResourceStringLang(@cxSFilterOperatorLastWeek, Corp_StrMess('cxSFilterOperatorLastWeek'));
  cxSetResourceStringLang(@cxSFilterOperatorLastMonth, Corp_StrMess('cxSFilterOperatorLastMonth'));
  cxSetResourceStringLang(@cxSFilterOperatorLastYear, Corp_StrMess('cxSFilterOperatorLastYear'));

  cxSetResourceStringLang(@cxSFilterOperatorThisWeek, Corp_StrMess('cxSFilterOperatorThisWeek'));
  cxSetResourceStringLang(@cxSFilterOperatorThisMonth, Corp_StrMess('cxSFilterOperatorThisMonth'));
  cxSetResourceStringLang(@cxSFilterOperatorThisYear, Corp_StrMess('cxSFilterOperatorThisYear'));

  cxSetResourceStringLang(@cxSFilterOperatorNextWeek, Corp_StrMess('cxSFilterOperatorNextWeek'));
  cxSetResourceStringLang(@cxSFilterOperatorNextMonth, Corp_StrMess('cxSFilterOperatorNextMonth'));
  cxSetResourceStringLang(@cxSFilterOperatorNextYear, Corp_StrMess('cxSFilterOperatorNextYear'));

  cxSetResourceStringLang(@cxSFilterAndCaption, Corp_StrMess('cxSFilterAndCaption'));
  cxSetResourceStringLang(@cxSFilterOrCaption, Corp_StrMess('cxSFilterOrCaption'));
  cxSetResourceStringLang(@cxSFilterNotCaption, Corp_StrMess('cxSFilterNotCaption'));
  cxSetResourceStringLang(@cxSFilterBlankCaption, Corp_StrMess('cxSFilterBlankCaption'));

  // derived
  cxSetResourceStringLang(@cxSFilterOperatorIsNull, Corp_StrMess('cxSFilterOperatorIsNull'));
  cxSetResourceStringLang(@cxSFilterOperatorIsNotNull, Corp_StrMess('cxSFilterOperatorIsNotNull'));
  cxSetResourceStringLang(@cxSFilterOperatorBeginsWith, Corp_StrMess('cxSFilterOperatorBeginsWith'));
  cxSetResourceStringLang(@cxSFilterOperatorDoesNotBeginWith, Corp_StrMess('cxSFilterOperatorDoesNotBeginWith'));
  cxSetResourceStringLang(@cxSFilterOperatorEndsWith, Corp_StrMess('cxSFilterOperatorEndsWith'));
  cxSetResourceStringLang(@cxSFilterOperatorDoesNotEndWith, Corp_StrMess('cxSFilterOperatorDoesNotEndWith'));
  cxSetResourceStringLang(@cxSFilterOperatorContains, Corp_StrMess('cxSFilterOperatorContains'));
  cxSetResourceStringLang(@cxSFilterOperatorDoesNotContain, Corp_StrMess('cxSFilterOperatorDoesNotContain'));
  // filter listbox's values
  cxSetResourceStringLang(@cxSFilterBoxAllCaption, Corp_StrMess('cxSFilterBoxAllCaption'));
  cxSetResourceStringLang(@cxSFilterBoxCustomCaption, Corp_StrMess('cxSFilterBoxCustomCaption'));
  cxSetResourceStringLang(@cxSFilterBoxBlanksCaption, Corp_StrMess('cxSFilterBoxBlanksCaption'));
  cxSetResourceStringLang(@cxSFilterBoxNonBlanksCaption, Corp_StrMess('cxSFilterBoxNonBlanksCaption'));


  // cxFilterControlStrs.pas
  // cxFilterBoolOperator
  cxSetResourceStringLang(@cxSFilterBoolOperatorAnd, Corp_StrMess('cxSFilterBoolOperatorAnd'));        // all
  cxSetResourceStringLang(@cxSFilterBoolOperatorOr, Corp_StrMess('cxSFilterBoolOperatorOr'));          // any
  cxSetResourceStringLang(@cxSFilterBoolOperatorNotAnd, Corp_StrMess('cxSFilterBoolOperatorNotAnd')); // not all
  cxSetResourceStringLang(@cxSFilterBoolOperatorNotOr, Corp_StrMess('cxSFilterBoolOperatorNotOr'));   // not any
  //
  cxSetResourceStringLang(@cxSFilterRootButtonCaption, Corp_StrMess('cxSFilterRootButtonCaption'));
  cxSetResourceStringLang(@cxSFilterAddCondition, Corp_StrMess('cxSFilterAddCondition'));
  cxSetResourceStringLang(@cxSFilterAddGroup, Corp_StrMess('cxSFilterAddGroup'));
  cxSetResourceStringLang(@cxSFilterRemoveRow, Corp_StrMess('cxSFilterRemoveRow'));
  cxSetResourceStringLang(@cxSFilterClearAll, Corp_StrMess('cxSFilterClearAll'));
  cxSetResourceStringLang(@cxSFilterFooterAddCondition, Corp_StrMess('cxSFilterFooterAddCondition'));

  cxSetResourceStringLang(@cxSFilterGroupCaption, Corp_StrMess('cxSFilterGroupCaption'));
  cxSetResourceStringLang(@cxSFilterRootGroupCaption, Corp_StrMess('cxSFilterRootGroupCaption'));
  cxSetResourceStringLang(@cxSFilterControlNullString, Corp_StrMess('cxSFilterControlNullString'));

  cxSetResourceStringLang(@cxSFilterErrorBuilding, Corp_StrMess('cxSFilterErrorBuilding'));

  //FilterDialog
  cxSetResourceStringLang(@cxSFilterDialogCaption, Corp_StrMess('cxSFilterDialogCaption'));
  cxSetResourceStringLang(@cxSFilterDialogInvalidValue, Corp_StrMess('cxSFilterDialogInvalidValue'));
  cxSetResourceStringLang(@cxSFilterDialogUse, Corp_StrMess('cxSFilterDialogUse'));
  cxSetResourceStringLang(@cxSFilterDialogSingleCharacter, Corp_StrMess('cxSFilterDialogSingleCharacter'));
  cxSetResourceStringLang(@cxSFilterDialogCharactersSeries, Corp_StrMess('cxSFilterDialogCharactersSeries'));
  cxSetResourceStringLang(@cxSFilterDialogOperationAnd, Corp_StrMess('cxSFilterDialogOperationAnd'));
  cxSetResourceStringLang(@cxSFilterDialogOperationOr, Corp_StrMess('cxSFilterDialogOperationOr'));
  cxSetResourceStringLang(@cxSFilterDialogRows, Corp_StrMess('cxSFilterDialogRows'));

  // FilterControlDialog
  cxSetResourceStringLang(@cxSFilterControlDialogCaption, Corp_StrMess('cxSFilterControlDialogCaption'));
  cxSetResourceStringLang(@cxSFilterControlDialogNewFile, Corp_StrMess('cxSFilterControlDialogNewFile'));
  cxSetResourceStringLang(@cxSFilterControlDialogOpenDialogCaption, Corp_StrMess('cxSFilterControlDialogOpenDialogCaption'));
  cxSetResourceStringLang(@cxSFilterControlDialogSaveDialogCaption, Corp_StrMess('cxSFilterControlDialogSaveDialogCaption'));
  cxSetResourceStringLang(@cxSFilterControlDialogActionSaveCaption, Corp_StrMess('cxSFilterControlDialogActionSaveCaption'));
  cxSetResourceStringLang(@cxSFilterControlDialogActionOpenCaption, Corp_StrMess('cxSFilterControlDialogActionOpenCaption'));
  cxSetResourceStringLang(@cxSFilterControlDialogActionApplyCaption, Corp_StrMess('cxSFilterControlDialogActionApplyCaption'));
  cxSetResourceStringLang(@cxSFilterControlDialogActionOkCaption, Corp_StrMess('cxSFilterControlDialogActionOkCaption'));
  cxSetResourceStringLang(@cxSFilterControlDialogActionCancelCaption, Corp_StrMess('cxSFilterControlDialogActionCancelCaption'));
  cxSetResourceStringLang(@cxSFilterControlDialogFileExt, Corp_StrMess('cxSFilterControlDialogFileExt'));
  cxSetResourceStringLang(@cxSFilterControlDialogFileFilter, Corp_StrMess('cxSFilterControlDialogFileFilter'));


  //****** cxGridStrs
  cxSetResourceStringLang(@scxGridRecursiveLevels, Corp_StrMess('scxGridRecursiveLevels'));

  cxSetResourceStringLang(@scxGridDeletingConfirmationCaption, Corp_StrMess('scxGridDeletingConfirmationCaption'));
  cxSetResourceStringLang(@scxGridDeletingFocusedConfirmationText, Corp_StrMess('scxGridDeletingFocusedConfirmationText'));
  cxSetResourceStringLang(@scxGridDeletingSelectedConfirmationText, Corp_StrMess('scxGridDeletingSelectedConfirmationText'));

  cxSetResourceStringLang(@scxGridNewItemRowInfoText, Corp_StrMess('scxGridNewItemRowInfoText'));

  cxSetResourceStringLang(@scxGridFilterIsEmpty, Corp_StrMess('scxGridFilterIsEmpty'));

  cxSetResourceStringLang(@scxGridCustomizationFormCaption, Corp_StrMess('scxGridCustomizationFormCaption'));
  cxSetResourceStringLang(@scxGridCustomizationFormColumnsPageCaption, Corp_StrMess('scxGridCustomizationFormColumnsPageCaption'));
  cxSetResourceStringLang(@scxGridGroupByBoxCaption, Corp_StrMess('scxGridGroupByBoxCaption'));
  cxSetResourceStringLang(@scxGridFilterCustomizeButtonCaption, Corp_StrMess('scxGridFilterCustomizeButtonCaption'));

  cxSetResourceStringLang(@scxGridCustomizationFormBandsPageCaption, Corp_StrMess('scxGridCustomizationFormBandsPageCaption'));

  cxSetResourceStringLang(@scxGridConverterIntermediaryMissing, Corp_StrMess('scxGridConverterIntermediaryMissing'));
  cxSetResourceStringLang(@scxGridConverterNotExistGrid, Corp_StrMess('scxGridConverterNotExistGrid'));
  cxSetResourceStringLang(@scxGridConverterNotExistComponent, Corp_StrMess('scxGridConverterNotExistComponent'));
  cxSetResourceStringLang(@scxImportErrorCaption, Corp_StrMess('scxImportErrorCaption'));

  cxSetResourceStringLang(@scxNotExistGridView, Corp_StrMess('scxNotExistGridView'));
  cxSetResourceStringLang(@scxNotExistGridLevel, Corp_StrMess('scxNotExistGridLevel'));
  cxSetResourceStringLang(@scxCantCreateExportOutputFile, Corp_StrMess('scxCantCreateExportOutputFile'));

  cxSetResourceStringLang(@cxSEditRepositoryExtLookupComboBoxItem, Corp_StrMess('cxSEditRepositoryExtLookupComboBoxItem'));


  //************ cxLibraryStrs.Pas
  cxSetResourceStringLang(@scxCantCreateRegistryKey, Corp_StrMess('scxCantCreateRegistryKey'));
  cxSetResourceStringLang(@scxConverterCantCreateStyleRepository, Corp_StrMess('scxConverterCantCreateStyleRepository'));


  //************ cxNavigator
  cxSetResourceStringLang(@cxNavigatorHint_First, Corp_StrMess('cxNavigatorHint_First'));
  cxSetResourceStringLang(@cxNavigatorHint_Prior, Corp_StrMess('cxNavigatorHint_Prior'));
  cxSetResourceStringLang(@cxNavigatorHint_PriorPage, Corp_StrMess('cxNavigatorHint_PriorPage'));
  cxSetResourceStringLang(@cxNavigatorHint_Next, Corp_StrMess('cxNavigatorHint_Next'));
  cxSetResourceStringLang(@cxNavigatorHint_NextPage, Corp_StrMess('cxNavigatorHint_NextPage'));
  cxSetResourceStringLang(@cxNavigatorHint_Last, Corp_StrMess('cxNavigatorHint_Last'));
  cxSetResourceStringLang(@cxNavigatorHint_Insert, Corp_StrMess('cxNavigatorHint_Insert'));
  cxSetResourceStringLang(@cxNavigatorHint_Delete, Corp_StrMess('cxNavigatorHint_Delete'));
  cxSetResourceStringLang(@cxNavigatorHint_Edit, Corp_StrMess('cxNavigatorHint_Edit'));
  cxSetResourceStringLang(@cxNavigatorHint_Post, Corp_StrMess('cxNavigatorHint_Post'));
  cxSetResourceStringLang(@cxNavigatorHint_Cancel, Corp_StrMess('cxNavigatorHint_Cancel'));
  cxSetResourceStringLang(@cxNavigatorHint_Refresh, Corp_StrMess('cxNavigatorHint_Refresh'));
  cxSetResourceStringLang(@cxNavigatorHint_SaveBookmark, Corp_StrMess('cxNavigatorHint_SaveBookmark'));
  cxSetResourceStringLang(@cxNavigatorHint_GotoBookmark, Corp_StrMess('cxNavigatorHint_GotoBookmark'));
  cxSetResourceStringLang(@cxNavigatorHint_Filter, Corp_StrMess('cxNavigatorHint_Filter'));
  cxSetResourceStringLang(@cxNavigator_DeleteRecordQuestion, Corp_StrMess('cxNavigator_DeleteRecordQuestion'));




  //********** dxBarStrs
  cxSetResourceStringLang(@dxSBAR_LOOKUPDIALOGCAPTION, Corp_StrMess('dxSBAR_LOOKUPDIALOGCAPTION'));
  cxSetResourceStringLang(@dxSBAR_LOOKUPDIALOGOK, Corp_StrMess('dxSBAR_LOOKUPDIALOGOK'));
  cxSetResourceStringLang(@dxSBAR_LOOKUPDIALOGCANCEL, Corp_StrMess('dxSBAR_LOOKUPDIALOGCANCEL'));

  cxSetResourceStringLang(@dxSBAR_DIALOGOK, Corp_StrMess('dxSBAR_DIALOGOK'));
  cxSetResourceStringLang(@dxSBAR_DIALOGCANCEL, Corp_StrMess('dxSBAR_DIALOGCANCEL'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_0, Corp_StrMess('dxSBAR_COLOR_STR_0'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_1, Corp_StrMess('dxSBAR_COLOR_STR_1'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_2, Corp_StrMess('dxSBAR_COLOR_STR_2'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_3, Corp_StrMess('dxSBAR_COLOR_STR_3'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_4, Corp_StrMess('dxSBAR_COLOR_STR_4'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_5, Corp_StrMess('dxSBAR_COLOR_STR_5'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_6, Corp_StrMess('dxSBAR_COLOR_STR_6'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_7, Corp_StrMess('dxSBAR_COLOR_STR_7'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_8, Corp_StrMess('dxSBAR_COLOR_STR_8'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_9, Corp_StrMess('dxSBAR_COLOR_STR_9'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_10, Corp_StrMess('dxSBAR_COLOR_STR_10'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_11, Corp_StrMess('dxSBAR_COLOR_STR_11'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_12, Corp_StrMess('dxSBAR_COLOR_STR_12'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_13, Corp_StrMess('dxSBAR_COLOR_STR_13'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_14, Corp_StrMess('dxSBAR_COLOR_STR_14'));
  cxSetResourceStringLang(@dxSBAR_COLOR_STR_15, Corp_StrMess('dxSBAR_COLOR_STR_15'));
  cxSetResourceStringLang(@dxSBAR_COLORAUTOTEXT, Corp_StrMess('dxSBAR_COLORAUTOTEXT'));
  cxSetResourceStringLang(@dxSBAR_COLORCUSTOMTEXT, Corp_StrMess('dxSBAR_COLORCUSTOMTEXT'));
  cxSetResourceStringLang(@dxSBAR_DATETODAY, Corp_StrMess('dxSBAR_DATETODAY'));
  cxSetResourceStringLang(@dxSBAR_DATECLEAR, Corp_StrMess('dxSBAR_DATECLEAR'));
  cxSetResourceStringLang(@dxSBAR_DATEDIALOGCAPTION, Corp_StrMess('dxSBAR_DATEDIALOGCAPTION'));
  cxSetResourceStringLang(@dxSBAR_TREEVIEWDIALOGCAPTION, Corp_StrMess('dxSBAR_TREEVIEWDIALOGCAPTION'));
  cxSetResourceStringLang(@dxSBAR_IMAGEDIALOGCAPTION, Corp_StrMess('dxSBAR_IMAGEDIALOGCAPTION'));
  cxSetResourceStringLang(@dxSBAR_IMAGEINDEX, Corp_StrMess('dxSBAR_IMAGEINDEX'));
  cxSetResourceStringLang(@dxSBAR_IMAGETEXT, Corp_StrMess('dxSBAR_IMAGETEXT'));
  cxSetResourceStringLang(@dxSBAR_PLACEFORCONTROL, Corp_StrMess('dxSBAR_PLACEFORCONTROL'));
  cxSetResourceStringLang(@dxSBAR_CANTASSIGNCONTROL, Corp_StrMess('dxSBAR_CANTASSIGNCONTROL'));

  cxSetResourceStringLang(@dxSBAR_WANTTORESETTOOLBAR, Corp_StrMess('dxSBAR_WANTTORESETTOOLBAR'));
  cxSetResourceStringLang(@dxSBAR_WANTTORESETUSAGEDATA, Corp_StrMess('dxSBAR_WANTTORESETUSAGEDATA'));
  cxSetResourceStringLang(@dxSBAR_BARMANAGERMORETHENONE, Corp_StrMess('dxSBAR_BARMANAGERMORETHENONE'));
  cxSetResourceStringLang(@dxSBAR_BARMANAGERBADOWNER, Corp_StrMess('dxSBAR_BARMANAGERBADOWNER'));
  cxSetResourceStringLang(@dxSBAR_NOBARMANAGERS, Corp_StrMess('dxSBAR_NOBARMANAGERS'));
  cxSetResourceStringLang(@dxSBAR_WANTTODELETETOOLBAR, Corp_StrMess('dxSBAR_WANTTODELETETOOLBAR'));
  cxSetResourceStringLang(@dxSBAR_WANTTODELETECATEGORY, Corp_StrMess('dxSBAR_WANTTODELETECATEGORY'));
  cxSetResourceStringLang(@dxSBAR_WANTTOCLEARCOMMANDS, Corp_StrMess('dxSBAR_WANTTOCLEARCOMMANDS'));
  cxSetResourceStringLang(@dxSBAR_RECURSIVESUBITEMS, Corp_StrMess('dxSBAR_RECURSIVESUBITEMS'));
  cxSetResourceStringLang(@dxSBAR_COMMANDNAMECANNOTBEBLANK, Corp_StrMess('dxSBAR_COMMANDNAMECANNOTBEBLANK'));
  cxSetResourceStringLang(@dxSBAR_TOOLBAREXISTS, Corp_StrMess('dxSBAR_TOOLBAREXISTS'));
  cxSetResourceStringLang(@dxSBAR_RECURSIVEGROUPS, Corp_StrMess('dxSBAR_RECURSIVEGROUPS'));

  cxSetResourceStringLang(@dxSBAR_DEFAULTCATEGORYNAME, Corp_StrMess('dxSBAR_DEFAULTCATEGORYNAME'));

  cxSetResourceStringLang(@dxSBAR_CP_ADDSUBITEM, Corp_StrMess('dxSBAR_CP_ADDSUBITEM'));
  cxSetResourceStringLang(@dxSBAR_CP_ADDBUTTON, Corp_StrMess('dxSBAR_CP_ADDBUTTON'));
  cxSetResourceStringLang(@dxSBAR_CP_ADDITEM, Corp_StrMess('dxSBAR_CP_ADDITEM'));
  cxSetResourceStringLang(@dxSBAR_CP_DELETEBAR, Corp_StrMess('dxSBAR_CP_DELETEBAR'));

  cxSetResourceStringLang(@dxSBAR_CP_RESET, Corp_StrMess('dxSBAR_CP_RESET'));
  cxSetResourceStringLang(@dxSBAR_CP_DELETE, Corp_StrMess('dxSBAR_CP_DELETE'));
  cxSetResourceStringLang(@dxSBAR_CP_NAME, Corp_StrMess('dxSBAR_CP_NAME'));
  cxSetResourceStringLang(@dxSBAR_CP_CAPTION, Corp_StrMess('dxSBAR_CP_CAPTION')); // is the same as dxSBAR_CP_NAME (at design-time)
  cxSetResourceStringLang(@dxSBAR_CP_DEFAULTSTYLE, Corp_StrMess('dxSBAR_CP_DEFAULTSTYLE'));
  cxSetResourceStringLang(@dxSBAR_CP_TEXTONLYALWAYS, Corp_StrMess('dxSBAR_CP_TEXTONLYALWAYS'));
  cxSetResourceStringLang(@dxSBAR_CP_TEXTONLYINMENUS, Corp_StrMess('dxSBAR_CP_TEXTONLYINMENUS'));
  cxSetResourceStringLang(@dxSBAR_CP_IMAGEANDTEXT, Corp_StrMess('dxSBAR_CP_IMAGEANDTEXT'));
  cxSetResourceStringLang(@dxSBAR_CP_BEGINAGROUP, Corp_StrMess('dxSBAR_CP_BEGINAGROUP'));
  cxSetResourceStringLang(@dxSBAR_CP_VISIBLE, Corp_StrMess('dxSBAR_CP_VISIBLE'));
  cxSetResourceStringLang(@dxSBAR_CP_MOSTRECENTLYUSED, Corp_StrMess('dxSBAR_CP_MOSTRECENTLYUSED'));

  cxSetResourceStringLang(@dxSBAR_ADDEX, Corp_StrMess('dxSBAR_ADDEX'));
  cxSetResourceStringLang(@dxSBAR_RENAMEEX, Corp_StrMess('dxSBAR_RENAMEEX'));
  cxSetResourceStringLang(@dxSBAR_DELETE, Corp_StrMess('dxSBAR_DELETE'));
  cxSetResourceStringLang(@dxSBAR_CLEAR, Corp_StrMess('dxSBAR_CLEAR'));
  cxSetResourceStringLang(@dxSBAR_VISIBLE, Corp_StrMess('dxSBAR_VISIBLE'));
  cxSetResourceStringLang(@dxSBAR_OK, Corp_StrMess('dxSBAR_OK'));
  cxSetResourceStringLang(@dxSBAR_CANCEL, Corp_StrMess('dxSBAR_CANCEL'));
  cxSetResourceStringLang(@dxSBAR_SUBMENUEDITOR, Corp_StrMess('dxSBAR_SUBMENUEDITOR'));
  cxSetResourceStringLang(@dxSBAR_SUBMENUEDITORCAPTION, Corp_StrMess('dxSBAR_SUBMENUEDITORCAPTION'));
  cxSetResourceStringLang(@dxSBAR_INSERTEX, Corp_StrMess('dxSBAR_INSERTEX'));

  cxSetResourceStringLang(@dxSBAR_MOVEUP, Corp_StrMess('dxSBAR_MOVEUP'));
  cxSetResourceStringLang(@dxSBAR_MOVEDOWN, Corp_StrMess('dxSBAR_MOVEDOWN'));
  cxSetResourceStringLang(@dxSBAR_POPUPMENUEDITOR, Corp_StrMess('dxSBAR_POPUPMENUEDITOR'));
  cxSetResourceStringLang(@dxSBAR_TABSHEET1, Corp_StrMess('dxSBAR_TABSHEET1'));
  cxSetResourceStringLang(@dxSBAR_TABSHEET2, Corp_StrMess('dxSBAR_TABSHEET2'));
  cxSetResourceStringLang(@dxSBAR_TABSHEET3, Corp_StrMess('dxSBAR_TABSHEET3'));
  cxSetResourceStringLang(@dxSBAR_TOOLBARS, Corp_StrMess('dxSBAR_TOOLBARS'));
  cxSetResourceStringLang(@dxSBAR_TNEW, Corp_StrMess('dxSBAR_TNEW'));
  cxSetResourceStringLang(@dxSBAR_TRENAME, Corp_StrMess('dxSBAR_TRENAME'));
  cxSetResourceStringLang(@dxSBAR_TDELETE, Corp_StrMess('dxSBAR_TDELETE'));
  cxSetResourceStringLang(@dxSBAR_TRESET, Corp_StrMess('dxSBAR_TRESET'));
  cxSetResourceStringLang(@dxSBAR_CLOSE, Corp_StrMess('dxSBAR_CLOSE'));
  cxSetResourceStringLang(@dxSBAR_CAPTION, Corp_StrMess('dxSBAR_CAPTION'));
  cxSetResourceStringLang(@dxSBAR_CATEGORIES, Corp_StrMess('dxSBAR_CATEGORIES'));
  cxSetResourceStringLang(@dxSBAR_COMMANDS, Corp_StrMess('dxSBAR_COMMANDS'));
  cxSetResourceStringLang(@dxSBAR_DESCRIPTION, Corp_StrMess('dxSBAR_DESCRIPTION'));

  cxSetResourceStringLang(@dxSBAR_CUSTOMIZE, Corp_StrMess('dxSBAR_CUSTOMIZE'));
  cxSetResourceStringLang(@dxSBAR_ADDREMOVEBUTTONS, Corp_StrMess('dxSBAR_ADDREMOVEBUTTONS'));
  cxSetResourceStringLang(@dxSBAR_MOREBUTTONS, Corp_StrMess('dxSBAR_MOREBUTTONS'));
  cxSetResourceStringLang(@dxSBAR_RESETTOOLBAR, Corp_StrMess('dxSBAR_RESETTOOLBAR'));
  cxSetResourceStringLang(@dxSBAR_EXPAND, Corp_StrMess('dxSBAR_EXPAND'));
  cxSetResourceStringLang(@dxSBAR_DRAGTOMAKEMENUFLOAT, Corp_StrMess('dxSBAR_DRAGTOMAKEMENUFLOAT'));

  cxSetResourceStringLang(@dxSBAR_TOOLBARNEWNAME, Corp_StrMess('dxSBAR_TOOLBARNEWNAME'));
  cxSetResourceStringLang(@dxSBAR_CATEGORYADD, Corp_StrMess('dxSBAR_CATEGORYADD'));
  cxSetResourceStringLang(@dxSBAR_CATEGORYINSERT, Corp_StrMess('dxSBAR_CATEGORYINSERT'));
  cxSetResourceStringLang(@dxSBAR_CATEGORYRENAME, Corp_StrMess('dxSBAR_CATEGORYRENAME'));
  cxSetResourceStringLang(@dxSBAR_TOOLBARADD, Corp_StrMess('dxSBAR_TOOLBARADD'));
  cxSetResourceStringLang(@dxSBAR_TOOLBARRENAME, Corp_StrMess('dxSBAR_TOOLBARRENAME'));
  cxSetResourceStringLang(@dxSBAR_CATEGORYNAME, Corp_StrMess('dxSBAR_CATEGORYNAME'));
  cxSetResourceStringLang(@dxSBAR_TOOLBARNAME, Corp_StrMess('dxSBAR_TOOLBARNAME'));
  cxSetResourceStringLang(@dxSBAR_CUSTOMIZINGFORM, Corp_StrMess('dxSBAR_CUSTOMIZINGFORM'));

  cxSetResourceStringLang(@dxSBAR_MODIFY, Corp_StrMess('dxSBAR_MODIFY'));
  cxSetResourceStringLang(@dxSBAR_PERSMENUSANDTOOLBARS, Corp_StrMess('dxSBAR_PERSMENUSANDTOOLBARS'));
  cxSetResourceStringLang(@dxSBAR_MENUSSHOWRECENTITEMS, Corp_StrMess('dxSBAR_MENUSSHOWRECENTITEMS'));
  cxSetResourceStringLang(@dxSBAR_SHOWFULLMENUSAFTERDELAY, Corp_StrMess('dxSBAR_SHOWFULLMENUSAFTERDELAY'));
  cxSetResourceStringLang(@dxSBAR_RESETUSAGEDATA, Corp_StrMess('dxSBAR_RESETUSAGEDATA'));

  cxSetResourceStringLang(@dxSBAR_OTHEROPTIONS, Corp_StrMess('dxSBAR_OTHEROPTIONS'));
  cxSetResourceStringLang(@dxSBAR_LARGEICONS, Corp_StrMess('dxSBAR_LARGEICONS'));
  cxSetResourceStringLang(@dxSBAR_HINTOPT1, Corp_StrMess('dxSBAR_HINTOPT1'));
  cxSetResourceStringLang(@dxSBAR_HINTOPT2, Corp_StrMess('dxSBAR_HINTOPT2'));
  cxSetResourceStringLang(@dxSBAR_MENUANIMATIONS, Corp_StrMess('dxSBAR_MENUANIMATIONS'));
  cxSetResourceStringLang(@dxSBAR_MENUANIM1, Corp_StrMess('dxSBAR_MENUANIM1'));
  cxSetResourceStringLang(@dxSBAR_MENUANIM2, Corp_StrMess('dxSBAR_MENUANIM2'));
  cxSetResourceStringLang(@dxSBAR_MENUANIM3, Corp_StrMess('dxSBAR_MENUANIM3'));
  cxSetResourceStringLang(@dxSBAR_MENUANIM4, Corp_StrMess('dxSBAR_MENUANIM4'));
  cxSetResourceStringLang(@dxSBAR_MENUANIM5, Corp_StrMess('dxSBAR_MENUANIM5'));


  //****************** dxDockConsts
  cxSetResourceStringLang(@sdxInvalidLayoutSiteDeleting, Corp_StrMess('sdxInvalidLayoutSiteDeleting'));
  cxSetResourceStringLang(@sdxInvalidFloatSiteDeleting, Corp_StrMess('sdxInvalidFloatSiteDeleting'));
  cxSetResourceStringLang(@sdxInvalidFloatingDeleting, Corp_StrMess('sdxInvalidFloatingDeleting'));
  cxSetResourceStringLang(@sdxInvalidParentAssigning, Corp_StrMess('sdxInvalidParentAssigning'));
  cxSetResourceStringLang(@sdxInvalidOwner, Corp_StrMess('sdxInvalidOwner'));
  cxSetResourceStringLang(@sdxInvalidParent, Corp_StrMess('sdxInvalidParent'));
  cxSetResourceStringLang(@sdxInvalidDockSiteParent, Corp_StrMess('sdxInvalidDockSiteParent'));
  cxSetResourceStringLang(@sdxInvalidFloatSiteParent, Corp_StrMess('sdxInvalidFloatSiteParent'));
  cxSetResourceStringLang(@sdxInvalidPanelChild, Corp_StrMess('sdxInvalidPanelChild'));
  cxSetResourceStringLang(@sdxInvalidSiteChild, Corp_StrMess('sdxInvalidSiteChild'));
  cxSetResourceStringLang(@sdxInvaldZoneOwner, Corp_StrMess('sdxInvaldZoneOwner'));
  cxSetResourceStringLang(@sdxInternalErrorAutoHide, Corp_StrMess('sdxInternalErrorAutoHide'));
  cxSetResourceStringLang(@sdxInternalErrorPainter, Corp_StrMess('sdxInternalErrorPainter'));
  cxSetResourceStringLang(@sdxInternalErrorLayout, Corp_StrMess('sdxInternalErrorLayout'));
  cxSetResourceStringLang(@sdxInternalErrorCreateLayout, Corp_StrMess('sdxInternalErrorCreateLayout'));
  cxSetResourceStringLang(@sdxInternalErrorDestroyLayout, Corp_StrMess('sdxInternalErrorDestroyLayout'));
  cxSetResourceStringLang(@sdxManagerError, Corp_StrMess('sdxManagerError'));
  cxSetResourceStringLang(@sdxAncestorError, Corp_StrMess('sdxAncestorError'));



  //**************** dxExtCtrlsStrs
  cxSetResourceStringLang(@sdxAutoColorText, Corp_StrMess('sdxAutoColorText'));
  cxSetResourceStringLang(@sdxCustomColorText, Corp_StrMess('sdxCustomColorText'));

  cxSetResourceStringLang(@sdxSysColorScrollBar, Corp_StrMess('sdxSysColorScrollBar'));
  cxSetResourceStringLang(@sdxSysColorBackground, Corp_StrMess('sdxSysColorBackground'));
  cxSetResourceStringLang(@sdxSysColorActiveCaption, Corp_StrMess('sdxSysColorActiveCaption'));
  cxSetResourceStringLang(@sdxSysColorInactiveCaption, Corp_StrMess('sdxSysColorInactiveCaption'));
  cxSetResourceStringLang(@sdxSysColorMenu, Corp_StrMess('sdxSysColorMenu'));
  cxSetResourceStringLang(@sdxSysColorWindow, Corp_StrMess('sdxSysColorWindow'));
  cxSetResourceStringLang(@sdxSysColorWindowFrame, Corp_StrMess('sdxSysColorWindowFrame'));
  cxSetResourceStringLang(@sdxSysColorMenuText, Corp_StrMess('sdxSysColorMenuText'));
  cxSetResourceStringLang(@sdxSysColorWindowText, Corp_StrMess('sdxSysColorWindowText'));
  cxSetResourceStringLang(@sdxSysColorCaptionText, Corp_StrMess('sdxSysColorCaptionText'));
  cxSetResourceStringLang(@sdxSysColorActiveBorder, Corp_StrMess('sdxSysColorActiveBorder'));
  cxSetResourceStringLang(@sdxSysColorInactiveBorder, Corp_StrMess('sdxSysColorInactiveBorder'));
  cxSetResourceStringLang(@sdxSysColorAppWorkSpace, Corp_StrMess('sdxSysColorAppWorkSpace'));
  cxSetResourceStringLang(@sdxSysColorHighLight, Corp_StrMess('sdxSysColorHighLight'));
  cxSetResourceStringLang(@sdxSysColorHighLighText, Corp_StrMess('sdxSysColorHighLighText'));
  cxSetResourceStringLang(@sdxSysColorBtnFace, Corp_StrMess('sdxSysColorBtnFace'));
  cxSetResourceStringLang(@sdxSysColorBtnShadow, Corp_StrMess('sdxSysColorBtnShadow'));
  cxSetResourceStringLang(@sdxSysColorGrayText, Corp_StrMess('sdxSysColorGrayText'));
  cxSetResourceStringLang(@sdxSysColorBtnText, Corp_StrMess('sdxSysColorBtnText'));
  cxSetResourceStringLang(@sdxSysColorInactiveCaptionText, Corp_StrMess('sdxSysColorInactiveCaptionText'));
  cxSetResourceStringLang(@sdxSysColorBtnHighligh, Corp_StrMess('sdxSysColorBtnHighligh'));
  cxSetResourceStringLang(@sdxSysColor3DDkShadow, Corp_StrMess('sdxSysColor3DDkShadow'));
  cxSetResourceStringLang(@sdxSysColor3DLight, Corp_StrMess('sdxSysColor3DLight'));
  cxSetResourceStringLang(@sdxSysColorInfoText, Corp_StrMess('sdxSysColorInfoText'));
  cxSetResourceStringLang(@sdxSysColorInfoBk, Corp_StrMess('sdxSysColorInfoBk'));

  cxSetResourceStringLang(@sdxPureColorBlack, Corp_StrMess('sdxPureColorBlack'));
  cxSetResourceStringLang(@sdxPureColorRed, Corp_StrMess('sdxPureColorRed'));
  cxSetResourceStringLang(@sdxPureColorLime, Corp_StrMess('sdxPureColorLime'));
  cxSetResourceStringLang(@sdxPureColorYellow, Corp_StrMess('sdxPureColorYellow'));
  cxSetResourceStringLang(@sdxPureColorGreen, Corp_StrMess('sdxPureColorGreen'));
  cxSetResourceStringLang(@sdxPureColorTeal, Corp_StrMess('sdxPureColorTeal'));
  cxSetResourceStringLang(@sdxPureColorAqua, Corp_StrMess('sdxPureColorAqua'));
  cxSetResourceStringLang(@sdxPureColorBlue, Corp_StrMess('sdxPureColorBlue'));
  cxSetResourceStringLang(@sdxPureColorWhite, Corp_StrMess('sdxPureColorWhite'));
  cxSetResourceStringLang(@sdxPureColorOlive, Corp_StrMess('sdxPureColorOlive'));
  cxSetResourceStringLang(@sdxPureColorMoneyGreen, Corp_StrMess('sdxPureColorMoneyGreen'));
  cxSetResourceStringLang(@sdxPureColorNavy, Corp_StrMess('sdxPureColorNavy'));
  cxSetResourceStringLang(@sdxPureColorSkyBlue, Corp_StrMess('sdxPureColorSkyBlue'));
  cxSetResourceStringLang(@sdxPureColorGray, Corp_StrMess('sdxPureColorGray'));
  cxSetResourceStringLang(@sdxPureColorMedGray, Corp_StrMess('sdxPureColorMedGray'));
  cxSetResourceStringLang(@sdxPureColorSilver, Corp_StrMess('sdxPureColorSilver'));
  cxSetResourceStringLang(@sdxPureColorMaroon, Corp_StrMess('sdxPureColorMaroon'));
  cxSetResourceStringLang(@sdxPureColorPurple, Corp_StrMess('sdxPureColorPurple'));
  cxSetResourceStringLang(@sdxPureColorFuchsia, Corp_StrMess('sdxPureColorFuchsia'));
  cxSetResourceStringLang(@sdxPureColorCream, Corp_StrMess('sdxPureColorCream'));

  cxSetResourceStringLang(@sdxBrushStyleSolid, Corp_StrMess('sdxBrushStyleSolid'));
  cxSetResourceStringLang(@sdxBrushStyleClear, Corp_StrMess('sdxBrushStyleClear'));
  cxSetResourceStringLang(@sdxBrushStyleHorizontal, Corp_StrMess('sdxBrushStyleHorizontal'));
  cxSetResourceStringLang(@sdxBrushStyleVertical, Corp_StrMess('sdxBrushStyleVertical'));
  cxSetResourceStringLang(@sdxBrushStyleFDiagonal, Corp_StrMess('sdxBrushStyleFDiagonal'));
  cxSetResourceStringLang(@sdxBrushStyleBDiagonal, Corp_StrMess('sdxBrushStyleBDiagonal'));
  cxSetResourceStringLang(@sdxBrushStyleCross, Corp_StrMess('sdxBrushStyleCross'));
  cxSetResourceStringLang(@sdxBrushStyleDiagCross, Corp_StrMess('sdxBrushStyleDiagCross'));



  //*********** dxLayoutCommon
  cxSetResourceStringLang(@dxLayoutNewGroupCaption, Corp_StrMess('dxLayoutNewGroupCaption'));
  cxSetResourceStringLang(@dxLayoutNewGroupDialogCaption, Corp_StrMess('dxLayoutNewGroupDialogCaption'));
  cxSetResourceStringLang(@dxLayoutNewGroupDialogEditCaption, Corp_StrMess('dxLayoutNewGroupDialogEditCaption'));

  cxSetResourceStringLang(@dxLayoutNewItemCaption, Corp_StrMess('dxLayoutNewItemCaption'));
  cxSetResourceStringLang(@dxLayoutNewItemDialogCaption, Corp_StrMess('dxLayoutNewItemDialogCaption'));
  cxSetResourceStringLang(@dxLayoutNewItemDialogEditCaption, Corp_StrMess('dxLayoutNewItemDialogEditCaption'));


  //********** dxLayoutCustomizeForm
  cxSetResourceStringLang(@dxLayoutCustomizeFormCaption, Corp_StrMess('dxLayoutCustomizeFormCaption'));
  cxSetResourceStringLang(@dxLayoutCustomizeFormItemsCaption, Corp_StrMess('dxLayoutCustomizeFormItemsCaption'));
  cxSetResourceStringLang(@dxLayoutCustomizeFormGroupsCaption, Corp_StrMess('dxLayoutCustomizeFormGroupsCaption'));
  cxSetResourceStringLang(@dxLayoutCustomizeFormGroupsCreateCaption, Corp_StrMess('dxLayoutCustomizeFormGroupsCreateCaption'));
  cxSetResourceStringLang(@dxLayoutCustomizeFormGroupsDeleteCaption, Corp_StrMess('dxLayoutCustomizeFormGroupsDeleteCaption'));

  //************* dxLayoutEditForm
  cxSetResourceStringLang(@dxLayoutEditFormOK, Corp_StrMess('dxLayoutEditFormOK'));
  cxSetResourceStringLang(@dxLayoutEditFormCancel, Corp_StrMess('dxLayoutEditFormCancel'));

  //************ dxNavBarConsts
  cxSetResourceStringLang(@sdxInvalideGroupControl, Corp_StrMess('sdxInvalideGroupControl'));





(*  cxSetResourceStringLang(@cxSGridSumMenuItem, Corp_StrMess(''MMM'));
  cxSetResourceStringLang(@cxSGridMinMenuItem, Corp_StrMess(''MMM'));
  cxSetResourceStringLang(@cxSGridMaxMenuItem, Corp_StrMess(''MMM'));
  cxSetResourceStringLang(@cxSGridCountMenuItem, Corp_StrMess(''MMM'));
  cxSetResourceStringLang(@cxSGridAvgMenuItem, Corp_StrMess(''MMM'));
  cxSetResourceStringLang(@cxSGridNoneMenuItem, Corp_StrMess(''MMM'));

 cxSetResourceStringLang(@cxSGridNone, Corp_StrMess(''MMM'));

{  cxSetResourceStringLang(@cxSGridSumMenuItem, Corp_StrMess(''MMM'));
  cxSetResourceStringLang(@cxSGridSumMenuItem, Corp_StrMess(''MMM'));}



  cxSetResourceStringLang(@cxSGridSumMenuItem', Corp_StrMess('''));
  cxSetResourceStringLang(@cxSGridMinMenuItem', Corp_StrMess('''));
  cxSetResourceStringLang(@cxSGridMaxMenuItem', Corp_StrMess('''));
  cxSetResourceStringLang(@cxSGridCountMenuItem', Corp_StrMess('''));
  cxSetResourceStringLang(@cxSGridAvgMenuItem', Corp_StrMess('''));
  cxSetResourceStringLang(@cxSGridNoneMenuItem', Corp_StrMess('''));
  *)

//  @cxSGridSumMenuItem:='';
{  cxGetResourceString(@cxSGridSumMenuItem);
  cxSetResourceStringLang(@cxSGridSumMenuItem, Corp_StrMess('''));}
End;



end.
